<?php

if (!isset($userdata)) die();

require_once 'portrules.php';

function ExplodeBrackets($string)
{
	return(mod_ExplodeBrackets($string, ' '));
}

function ParseFile($filename)
{
	global $cid;
	if (($data = file_get_contents($filename)) === false) trigger_error("Could not find file: $filename", E_USER_ERROR);

	$lines = explode("\n", str_replace(array("\r", "	"), array('', ' '), $data));
	$captions = $lines[0];

	while (strpos($captions, '  ')) $captions = str_replace('  ', ' ', $captions);
	$tmp = explode(' ', $captions);
	$i = 1;
	foreach($tmp as $caption)
	{
		$query = "INSERT INTO d_realnames (sort, name, realname, file, dataset_id) VALUES ($i, '" . mysql_escape_string(strtolower($caption)) .
			"', '" . mysql_escape_string($caption) . "', '" . mysql_escape_string(basename($filename, '.txt')) . "', $cid)";
		mod_mysql_querya($query);
		$i++;
	}

	$captions = strtolower($captions);
	$captions = explode(' ', $captions);

	if (count(array_unique($captions)) != count($captions))
	{
		trigger_error('Duplicate caption', E_USER_ERROR);
	}

	$data = array();
	for ($i = 1;$i < count($lines);$i++)
	{
		if (strlen($lines[$i]))
		{
			$line = ExplodeBrackets($lines[$i]);
			if (count($line) != count($captions))
			{
				trigger_error('Invalid number of entries', E_USER_ERROR);
			}
			$data[] = array_combine($captions, $line);
		}
	}
	return($data);
}

function ParseScript($string)
{
	$retVal = '';
	$indent = 0;
	$pos = 0;

	$string = str_replace('_', ' ', $string);

	$i = 0;
	while ($pos < strlen($string))
	{
		$tmp = strpos($string, ';', $pos);
		$tmp2 = strpos($string, '{', $pos);
		$tmp3 = strpos($string, '}', $pos);
		if ($tmp === false) $tmp = strlen($string);
		if ($tmp2 === false) $tmp2 = strlen($string);
		if ($tmp3 === false) $tmp3 = strlen($string);

		if ($tmp < min($tmp2, $tmp3))
		{
			$retVal .= str_repeat("  ", $indent) . substr($string, $pos, $tmp - $pos + 1) . "\n";
			$pos = $tmp + 1;
		}
		else if ($tmp2 < min($tmp, $tmp3))
		{
			$retVal .= str_repeat("  ", $indent) . substr($string, $pos, $tmp2 - $pos) . "\n" . str_repeat("  ", $indent++) . "{\n";
			$pos = $tmp2 + 1;
		}
		else
		{
			if ($string{$tmp3 - 1} == ';')
			{
				$retVal .= str_repeat("  ", --$indent) . "}\n";
			}
			else
			{
				$retVal .= str_repeat("  ", $indent) . substr($string, $pos, $tmp3 - $pos) . "\n" . str_repeat("  ", --$indent) . "}\n";
			}
			$pos = $tmp3 + 1;
		}

		if ($i++ == 1000) trigger_error('<pre>' . $retVal . '1000 lines for a script...', E_USER_ERROR);
	}

	return($retVal);
}

echo 'Deleting old data<br>';
$query = "SHOW TABLES";
$result = mod_mysql_querya($query);
while ($tmp = mysql_fetch_row($result))
{
	if (strpos($tmp[0], 'd_') === 0)
	{
		$esTable = mysql_escape_string($tmp[0]);
		$query = "DESCRIBE `$esTable`";
		$fields = mod_query2Array($query, false, 'Field');
		if (in_array('dataset_id', $fields))
		{
			$query = "DELETE FROM `$esTable` WHERE dataset_id = $cid";
			mod_mysql_querya($query);
		}

		//$query = "DROP TABLE `$esTable`";
		//mod_mysql_querya($query);
	}
}

foreach ($datafiles as $filename => $val)
{
	echo "Parsing File: $filename<br>";
	$data = ParseFile("build/data/$filename.txt");

	$moveaddtable = array();

	$captions = $data[0];
	foreach($val as $addtable => $addtablecols)
	{
		if ($addtable == 'links') continue;
		$query = 'DROP TABLE IF EXISTS `' . mysql_escape_string($addtable) . '`';
		mod_mysql_querya($query);
		foreach ($addtablecols as $addtablecol => $num)
		{
			if (is_array($num)) $num = $num[0];
			for ($i = 1;$i <= $num;$i++)
			{
				unset($captions[str_replace('I', $i, $addtablecol)]);
				$moveaddtable[str_replace('I', $i, $addtablecol)] = array($i == 1, str_replace('I', '', $addtablecol), $addtable);
			}
		}
	}

	$tablestructures = array();
	foreach ($data[0] as $index => $value)
	{
		$numeric = 0;

		if (isset($val['links']))
		{
			foreach ($val['links'] as $linkcol => $linkdata)
			{
				if ($linkdata === 'script') continue;
				for ($i = 1;$i <= max(1, $linkdata[3]);$i++)
				{
					if ($linkdata[3] != -1) $linkcol = str_replace('I', $i, $linkcol);
					if ((string) $index === (string) $linkcol)
					{
						$numeric = 1;
					}
				}
			}
		}

		if ($numeric == 0 && is_numeric($value))
		{
			$numeric = 1;
			for ($i = 0;$i < count($data);$i++)
			{
				if (!is_numeric($data[$i][$index]))
				{
					$numeric = 0;
					break;
				}
			}
		}

		if ($numeric)
		{
			$type = 'int';
			$size = 11;
		}
		else
		{
			$type = 'text';
			$size = 0;
		}

		if (isset($moveaddtable[$index]))
		{
			if ($moveaddtable[$index][0])
			{
				$tmp = array($type => $size);
				if ($type == 'int')
				{
					$tmp['default'] = 0;
				}
				$tablestructures[$moveaddtable[$index][2]][$moveaddtable[$index][1]] = $tmp;
			}
		}
		else
		{
			$tablestructures[$filename][$index] = array($type => $size);
		}
	}

	foreach($tablestructures as $tablename => $tablestructure)
	{
		if ($tablename != $filename)
		{
			$tablestructure['num'] = array('int' => 11);
			$tablestructure[$filename . '_id'] = array('int' => 11, 'index' => 0);
		}
		else
		{
			$tablestructure['dataset_id'] = array('int' => 11, 'index' => 0);
		}

		checkTable($tablestructure, 'd_' . $tablename);
	}

	$captions = mod_EscapeArray(array_keys($captions), '`', 'mysql_escape_string');

	$querybase = 'INSERT INTO `d_' . mysql_escape_string($filename) . '` (' . implode(',', $captions) .
					', dataset_id) VALUES ';
	foreach ($data as $row)
	{
		$addqueries = array();

		if (isset($val['links']))
		{
			foreach ($val['links'] as $linkcol => $linkdata)
			{
				if ($linkdata === 'script')
				{
					$row[$linkcol] = ParseScript($row[$linkcol]);
				}
				else
				{
					for ($i = 1;$i <= max(1, $linkdata[3]);$i++)
					{
						$linkcola = $linkdata[3] != -1 ? str_replace('I', $i, $linkcol) : $linkcol;
						if ($row[$linkcola] != (string) $linkdata[2])
						{
							$query = 'SELECT id FROM `d_' . mysql_escape_string($linkdata[0]) . '` WHERE ';
							if ($linkdata[4])
							{
								$query .= 'INSTR(`' . mysql_escape_string($linkdata[1]) . '`, "' . mysql_escape_string($row[$linkcola]) . '") = 1';
							}
							else
							{
								$query .= '`' . mysql_escape_string($linkdata[1]) . '` = "' . mysql_escape_string($row[$linkcola]) . '"';
							}
							$result = mod_mysql_querya($query);
							if (mysql_num_rows($result) == 0)
							{
								trigger_error("Could not find $row[$linkcola] in $linkdata[0] ($linkcola)", E_USER_ERROR);
							}
							$row[$linkcola] = mysql_result($result, 0);
						}
						else
						{
							$row[$linkcola] = 0;
						}
					}
				}
			}
		}

		foreach($val as $addtable => $addtablecols)
		{
			if ($addtable == 'links') continue;
			$addquerydata = $noadd = array();
			foreach ($addtablecols as $addtablecol => $rnum)
			{
				$num = is_array($rnum) ? $rnum[0] : $rnum;
				for ($i = 1;$i <= $num;$i++)
				{
					if (is_array($rnum))
					{
						if ($row[str_replace('I', $i, $addtablecol)] == (string) $rnum[1])
						{
							$noadd[] = $i;
						}
					}
					$addquerydata[$i][str_replace('I', '', $addtablecol)] = $row[str_replace('I', $i, $addtablecol)];
					unset($row[str_replace('I', $i, $addtablecol)]);
				}
			}

			foreach ($addquerydata as $num => $querydata)
			{
				if (!in_array($num, $noadd))
				{
					$tmpcaptions = mod_EscapeArray(array_keys($querydata), '`', 'mysql_escape_string');
					$addqueries[] = 'INSERT INTO `d_' . mysql_escape_string($addtable) . '` (' .
						implode(',', $tmpcaptions) . ', num, `' . mysql_escape_string($filename) . '_id`) VALUES (' .
						implode(',', mod_EscapeArray($querydata, '"', 'mysql_escape_string')) . ", $num,";
				}
			}
		}
		$row = '(' . implode(',', mod_EscapeArray($row, '"', 'mysql_escape_string')) . ", $userdata[id])";
		mod_mysql_querya($querybase . $row);
		$tmpid = mysql_insert_id($sql);

		foreach($addqueries as $addquery)
		{
			mod_mysql_querya($addquery . $tmpid . ')');
		}
	}
}

function ParseListFile($filename)
{
	if (($content = file_get_contents("build/data/$filename.txt")) === false) trigger_error("Coult not find file: $filename", E_USER_ERROR);
	$lines = explode("\n", str_replace(array('	', "\r"), array(' ', ''), $content));
	$i = 1;
	$retval = array();
	foreach($lines as $line)
	{
		if ($line == '') continue;

		while (strpos($line, '  ') !== false) $line = str_replace('  ', ' ', $line);
		$cols = explode(' ', $line);
		if ($cols[0] != $i++) trigger_error("Invalid Listfile: $filename ($cols[0] != $i)");
		$retval[] = $cols[1];
	}
	return($retval);
}

foreach($listfiles as $listfile => $val)
{
	echo "Processing Listfile: $listfile<br>";
	$entries = ParseListFile($listfile);

	$numeric = 1;
	foreach($entries as $entry)
	{
		if (!is_numeric($entry))
		{
			$numeric = 0;
			break;
		}
	}

	checkTable(array(
		'num' => array('int' => 11, 'index' => 0),
		$listfile => array($numeric ? 'int' : 'text' => $numeric ? 11 : 0),
		'dataset_id' => array('int' => 11, 'index' => 0)
	), "d_$listfile");

	$esTable = mysql_escape_string("d_$listfile");
	$query = "DELETE FROM `$esTable` WHERE dataset_id = $cid";
	mod_mysql_querya($query);

	$i = 1;
	foreach($entries as $entry)
	{
		$query = "INSERT INTO `$esTable` (num, `" . mysql_escape_string($listfile) . "`, dataset_id) VALUES ($i, '" . mysql_escape_string($entry) . "', $cid)";
		mod_mysql_querya($query);
		$i++;
	}
}

echo 'Inserting Monter Text Files<br>';
checkTable(array(
	'name' => array('text' => 0, 'index' => 32),
	'text' => array('longtext' => 0),
	'dataset_id' => array('int' => 11, 'index' => 0)
), 'd_monstertext');
$query = "DELETE FROM d_monstertext WHERE dataset_id = $cid";
mod_mysql_querya($query);

if (!is_dir("build/monstertext")) trigger_error("Monster Text Directory does not exist", E_USER_ERROR);
if (($d = opendir("build/monstertext")) === false) die('Internal Error');
while (($filename = readdir($d)) !== false)
{
	if ($filename{0} == '.') continue;
	if (($text = file_get_contents("build/monstertext/$filename")) === false) trigger_error("Could not read File: $filename", E_USER_ERROR);
	$query = "INSERT INTO d_monstertext (name, text, dataset_id) VALUES ('" . mysql_escape_string(strtolower($filename)) . "', '" . mysql_escape_string($text) . "', $cid)";
	mod_mysql_querya($query);
}

echo 'Processing Profile File<br>';
if (($file = file_get_contents('build/profiles.txt')) === false) trigger_error('Could not read profile file', E_USER_ERROR);
$profiles = explode('[', $file);
foreach ($profiles as $profile)
{
	if (strlen(str_replace(array("\r", "\n", " ", "[", "	"), '', $profile)) < 10) continue;

	$lines = explode("\n", str_replace("\r", '', $profile));
	array_walk($lines, 'mod_array_walka', 'trim');

	if (strpos($lines[0], ']') !== strlen($lines[0]) - 1) trigger_error("Error loading Profile, name exspected: $lines[0]", E_USER_ERROR);

	$tmp = array();
	$tmp['name'] = substr($lines[0], 0, -1);
	$tmp['school_id'] = $tmp['domain_id'] = $tmp['shield_id'] = $tmp['armor_id'] = $tmp['armortype'] = $tmp['attack2'] =
		$tmp['attack2'] = $tmp['shielduse1'] = $tmp['shielduse2'] = $tmp['weapon1_id'] = $tmp['weapon2_id'] = 0;
	$tmp['race_id'] = mod_GetTableNameFromId('d_races', 'Mensch', false, array('id', 'name'));
	$tmp['attributes'] = '1:1:1:1:1:1';

	$queries = array();

	for ($i = 1;$i < count($lines);$i++)
	{
		if (strlen(str_replace(array(" ", "	"), '', $lines[$i])) == 0) continue;

		$vals = explode('=', $lines[$i], 2);
		$vals[1] = trim($vals[1]);
		switch (trim(strtolower($vals[0])))
		{
			case 'classes':
				$classes = explode(',', $vals[1]);
				foreach ($classes as $num => $class)
				{
					$tmpv = explode(':', $class);
					$classid = mod_GetTableNameFromId('d_characters', $tmpv[0], false, array('id', 'name'));
					$level = intval($tmpv[1]);
					$queries[] = "d_profiles_classes (class_id, level, num, profile_id) VALUES ($classid, $level, $num";
				}
				break;

			case 'attacktype':
				$tmp['attack1'] = intval($vals[1]{0});
				$tmp['attack2'] = intval($vals[1]{1});
				break;

			case 'weapons':
				$tmpv = explode(',', $vals[1]);
				if (count($tmpv) > 0 && strlen(trim($tmpv[0])))
				{
					$tmp['weapon1_id'] = mod_GetTableNameFromId('d_equipment', $tmpv[0], false, array('id', 'name'));
					$tmp['weapon1_id'] = mod_GetTableNameFromId('d_weapons', $tmp['weapon1_id'], false, array('id', 'name'));
				}

				if (count($tmpv) > 1 && strlen(trim($tmpv[1])))
				{
					$tmp['weapon2_id'] = mod_GetTableNameFromId('d_equipment', $tmpv[1], false, array('id', 'name'));
					$tmp['weapon2_id'] = mod_GetTableNameFromId('d_weapons', $tmp['weapon2_id'], false, array('id', 'name'));
				}
				break;

			case 'feats':
				if (strlen($vals[1]) == 0) continue;
				$feats = explode(',', $vals[1]);
				foreach ($feats as $num => $feat)
				{
					$featid = mod_GetTableNameFromId('d_feats', $feat, false, array('id', 'name'));
					$queries[] = "d_profiles_links (link, type, num, profile_id) VALUES ($featid, 'feat', $num";
				}
				break;

			case 'skills':
				if (strlen($vals[1]) == 0) continue;
				$skills = explode(',', $vals[1]);
				foreach ($skills as $num => $skill)
				{
					$tmpv = explode(':', $skill);
					$skillid = mod_GetTableNameFromId('d_skills', $tmpv[0], false, array('id', 'name'));
					$minlvl = intval($tmpv[1]);
					$maxlvl = intval($tmpv[2]);
					$queries[] = "d_profiles_skills (skill_id, minlvl, maxlvl, num, profile_id) VALUES ($skillid, $minlvl, $maxlvl, $num";
				}
				break;

			case 'armor':
				$tmpv = explode(':', $vals[1]);
				if ($tmpv[0] == 'Armreif') $tmp['armor_id'] = 0;
				else $tmp['armor_id'] = mod_GetTableNameFromId('d_equipment', $tmpv[0], false, array('id', 'name'));
				$tmp['armortype'] = intval($tmpv[1]);
				break;

			case 'shield':
				$tmpv = explode(':', $vals[1]);
				if ($tmpv[0] == 'None') $tmp['shield_id'] = 0;
				else $tmp['shield_id'] = mod_GetTableNameFromId('d_equipment', $tmpv[0], false, array('id', 'name'));
				$tmp['shielduse1'] = intval($tmpv[1]);
				$tmp['shielduse2'] = intval($tmpv[2]);
				break;

			case 'spells':
				if (strlen($vals[1]) == 0) continue;
				$spells = explode(',', $vals[1]);
				foreach ($spells as $num => $spell)
				{
					$tmpv = explode(':', $spell);
					$spellid = mod_GetTableNameFromId('d_spells', $tmpv[0], false, array('id', 'name'));
					if (count($tmpv) == 1) $amount = 0;
					else $amount = intval($tmpv[1]);
					$queries[] = "d_profiles_spells (spell_id, amount, num, profile_id) VALUES ($spellid, $amount, $num";
				}
				break;

			case 'race':
				$tmp['race_id'] = mod_GetTableNameFromId('d_races', $vals[1], false, array('id', 'name'));
				break;

			case 'minlevel':
				$tmp['minlvl'] = intval($vals[1]);
				break;

			case 'preferedschool':
				$tmp['school_id'] = mod_GetTableNameFromId('d_schools', $vals[1], false, array('id', 'name'));
				break;

			case 'domains':
				if ($vals[1] == 'None') $mp['domain_id'] = 0;
				else $tmp['domain_id'] = mod_GetTableNameFromId('d_domains', $vals[1], false, array('id', 'name'));
				break;

			case 'attributes':
				$tmp['attributes'] = $vals[1];
				break;

			case 'effects':
				if (strlen($vals[1]) == 0) continue;
				$effects = explode(',', $vals[1]);
				foreach ($effects as $num => $effect)
				{
					$effectid = mod_GetTableNameFromId('d_effects', $effect, false, array('id', 'effect'));
					$queries[] = "d_profiles_links (link, type, num, profile_id) VALUES ($effectid, 'effect', $num";
				}
				break;

			case 'specials':
				if (strlen($vals[1]) == 0) continue;
				$specials = explode(',', $vals[1]);
				foreach ($specials as $num => $special)
				{
					$specialid = mod_GetTableNameFromId('d_specials', $special, false, array('id', 'name'));
					$queries[] = "d_profiles_links (link, type, num, profile_id) VALUES ($specialid, 'special', $num";
				}
				break;

			default:
				trigger_error("Unknown Profile Entry: $vals[0] ($tmp[name])", E_USER_ERROR);
				break;
		}
	}

	$tmp['dataset_id'] = $cid;

	$keys = mod_EscapeArray(array_keys($tmp), '`', 'mysql_escape_string');
	$vals = mod_EscapeArray($tmp, '"', 'mysql_escape_string');
	$query = "INSERT INTO d_profiles (" . implode(',', $keys) . ') VALUES (' . implode(',', $vals) . ')';
	mod_mysql_querya($query);

	$id = mysql_insert_id($sql);
	foreach($queries as $query)
	{
		mod_mysql_querya("INSERT INTO $query, $id)");
	}

}

?>
