<?php

require_once 'mod_form.php';
require_once 'mod_sort.php';

class logaccess
{
	public $sql = false;				//SQL Connection
	public $logtable = false;			//SQL Table Name
	public $paramtable = false;			//SQL Table for Parameters
	public $usertable = false;			//Somehow we need user names :|
	public $nolog = array('password' => 1, 'mod_hash' => 0, 'mod_java' => 0, 'mod_setmenu' => 0, 'mod_setmenu' => 1, 'sortBy' => 1, 'preferences' => 1, 'mod_link', 'lang', 'mod_template', 'index');
							//Which Values shell we not log, Supply an array where 1 means strpos compare and 0 means strcmp
	public $cicmp = true;				//Case Insensitive compare
	public $width = '90%';				//Table Width
	public $pagesize = 500;				//Table pagesize
	public $logsession = true;			//Log Session ID

	public $stats_user = false;			//False: Do not differ, integer: Specific User (0: not logged in), true: Select user
	public $stats_timetype = false;			//Mysql Time Statement, false for standard selection
	public $useparam = false;			//Param to store in log table
}

function mod_addLogParam($data, $array, $pre, $log_id)
{
	$esParam = mysql_escape_string($data->paramtable);

	mod_doDefaults($data);
	checkTable('log', $data->logtable, $data->sql);
	checkTable('logparam', $data->paramtable, $data->sql);

	foreach($array AS $index => $val)
	{
		$logval = true;
		foreach ($data->nolog AS $nolog => $type)
		{
			$cicmp = $data->cicmp ? ($type ? 'i' : 'case') : '';
			$function = 'str' . $cicmp . ($type ? 'pos' : 'cmp');
			$tmp = call_user_func($function, $index, $nolog);
			if ($type ? ($tmp !== false) : ($tmp == 0))
			{
				$logval = false;
				break;
			}
		}
		if ($logval)
		{
			if (is_array($val))
			{
				mod_addLogParam($data, $val, $pre . '[' . $index . ']', $log_id);
			}
			else
			{
				$esName = mysql_escape_string($pre . '[' . $index . ']');
				$esValue = mysql_escape_string($val);
				$query = "INSERT INTO `$esParam` (log_id, name, value) VALUES ($log_id, '$esName', '$esValue')";
				mod_mysql_querya($query, $data->sql);
			}
		}
	}
}

function AddLog($data)
{
	global $userdata;
	mod_doDefaults($data);
	if ($data->sql === false || $data->logtable === false || $data->paramtable === false)
	{
		trigger_error('Error In SQL Settings (LOG)', E_USER_ERROR);
	}

	checkTable('log', $data->logtable, $data->sql);
	checkTable('logparam', $data->paramtable, $data->sql);
	if ($data->usertable !== false) checkTable('user', $data->usertable, $data->sql);

	$esLog = mysql_escape_string($data->logtable);
	$query = "INSERT INTO log (file, ip, user_id, time, session_id, param) VALUES ('" .
		mysql_escape_string($_SERVER['PHP_SELF']) . "', " .
		sprintf('%u', ip2long($_SERVER['REMOTE_ADDR'])) . ', ' . intval($userdata['id']) . ', ' .
		time() . ', ' . intval($userdata['session_id']) . ',' . ($data->useparam === false ? 0 : intval($data->useparam)) . ')';
	mod_mysql_querya($query, $data->sql);
	$log_id = mysql_insert_id($data->sql);

	mod_addLogParam($data, $_REQUEST, '', $log_id);
}

function ShowLog($data)
{
	global $userdata, $mod_txt, $modules_defaults, $session;
	mod_doDefaults($data);

	$esLog = mysql_escape_string($data->logtable);
	$esParam = mysql_escape_string($data->paramtable);

	$selectpart = "`$esLog`.id, `$esLog`.ip, `$esLog`.time, `$esLog`.file";
	$joinpart = '';
	$wherepart = array();
	$limitoffset = 0;
	$limitrows = 600;

	if ($data->usertable !== false)
	{
		$esUser = mysql_escape_string($data->usertable);

		$selectpart .= ",IFNULL(`$esUser`.username,'-') AS username, user_id";
		$joinpart .= " LEFT JOIN `$esUser` ON `$esUser`.id = `$esLog`.user_id";
	}

	mod_addDefaultLink(array('mod_timeuntil', 'mod_rowlimit', 'mod_logfile', 'mod_logip', 'mod_loguser', 'mod_usepages', 'mod_lastlog'));

	echo "<table width=90%><tr><td>";
	echo $mod_txt['log_until'] . ': ';
	$timeuntil = new selectparam;
	$timeuntil->name = 'mod_timeuntil';
	$timeuntil->default = date('Y-n-j');
	$timeuntil->type = 'text';
	echo CreateSelectParam($timeuntil);
	$wherepart[] = "`$esLog`.time <= " . (strtotime($timeuntil->default) + 60 * 60 * 24);

	echo "</td><td>$mod_txt[log_entries]: ";
	$rowlimit = new selectparam;
	$rowlimit->name = 'mod_rowlimit';
	$rowlimit->default = '600';
	$rowlimit->type = 'text';
	echo CreateSelectParam($rowlimit);
	$limitrows = $rowlimit->default;

	echo "</td><td>";
	$pages = new selectparam;
	$pages->name = 'mod_usepages';
	$pages->default = 'checked';
	$pages->type = 'checkbox';
	echo CreateSelectParam($pages);
	echo $mod_txt['log_pages'];

	echo "</td></tr></table>";

	if ($userdata['id'] && isset($userdata['data']))
	{
		if (isset($userdata['data']['mod_lastlog']))
		{
			if (!isset($session['mod_lastlog'])) $session['mod_lastlog'] = $userdata['data']['mod_lastlog'];
			if (isset($_REQUEST['mod_lastlog']))
			{
				$wherepart[] = "`$esLog`.time > " . intval($session['mod_lastlog']);
			}
			else
			{
				echo "<a href='$modules_defaults[defaultlink]&mod_lastlog=1'>$mod_txt[log_last]: " . date("j.n.Y G:i:s", $session['mod_lastlog']) . '</a><br>';
			}
		}
		$userdata['data']['mod_lastlog'] = time();
	}

	if (isset($_REQUEST['mod_logip']) && $_REQUEST['mod_logip'] != '')
		$wherepart[] = "`$esLog`.ip = " . intval($_REQUEST['mod_logip']);

	if (isset($_REQUEST['mod_logfile']) && $_REQUEST['mod_logfile'] != '')
		$wherepart[] = "`$esLog`.file = '" . mysql_escape_string($_REQUEST['mod_logfile']) . "'";

	if (isset($_REQUEST['mod_loguser']) && $_REQUEST['mod_loguser'] != '')
		$wherepart[] = "`$esLog`.user_id = '" . intval($_REQUEST['mod_loguser']) . "'";

	$wherepart = count($wherepart) ? (' WHERE ' . implode(' AND ', $wherepart)) : '';

	$query = "SELECT $selectpart
		FROM `$esLog`
		$joinpart
		$wherepart
		ORDER BY `$esLog`.time DESC
		LIMIT $limitoffset, $limitrows";
	$result = mod_mysql_querya($query, $data->sql);

	$logtable = new table;	
	$logtable->data = array();

	while ($tmp = mysql_fetch_assoc($result))
	{
		$query = "SELECT * FROM `$esParam` WHERE log_id = $tmp[id]";
		$result2 = mod_mysql_querya($query, $data->sql);
		$tmp['params'] = '';
		while ($tmp2 = mysql_fetch_assoc($result2))
		{
			$tmp['params'] .= $tmp2['name'] . ' = "' . htmlspecialchars(substr($tmp2['value'], 0, 512)) . (strlen($tmp2['value']) > 512 ? '...' : '') . '" &nbsp; ';
		}
		mysql_free_result($result2);

		$row = array(
			$mod_txt['log_date'] => date("j.n.Y", $tmp['time']) . '&nbsp;' . date("G:i:s", $tmp['time']),
			$mod_txt['log_ip'] => "<a href='" . mod_linkAddParameter($modules_defaults['defaultlink'], 'mod_logip', (isset($_REQUEST['mod_logip']) && $_REQUEST['mod_logip'] != '' ? false : "$tmp[ip]")) . "'>" . long2ip($tmp['ip']) . '</a>',
			$mod_txt['log_file'] => "<a href='" . mod_linkAddParameter($modules_defaults['defaultlink'], 'mod_logfile', (isset($_REQUEST['mod_logfile']) && $_REQUEST['mod_logfile'] != '' ? false : "$tmp[file]")) . "'>" . basename($tmp['file']) . '</a>',
		);
		if ($data->usertable !== false)
			$row[$mod_txt['log_user']] = "<a href='" . mod_linkAddParameter($modules_defaults['defaultlink'], 'mod_loguser', (isset($_REQUEST['mod_loguser']) && $_REQUEST['mod_loguser'] != '' ? false : "$tmp[user_id]")) . "'>" . $tmp['username'] . '</a>';
		$row[$mod_txt['log_param']] = $tmp['params'];

		$logtable->data[] = $row;
	}

	$logtable->width = $data->width;
	$logtable->title = $mod_txt['log_title'];
	$logtable->serversort = 0;
	if (!isset($_REQUEST['mod_usepages']) || $_REQUEST['mod_usepages'])
		$logtable->pagesize = $data->pagesize;
	echo CreateTable($logtable);
}

function ShowAccessList($data)
{
	global $mod_txt;
	mod_doDefaults($data);
	$esLog = mysql_escape_string($data->logtable);
	if ($data->usertable !== false)
	{
		$esUser = mysql_escape_string($data->usertable);
		$wherepart = "WHERE session_id != 0";
	}
	else
	{
		$wherepart = '';
	}

	$query = "SELECT
			COUNT(id) AS access,
			MIN(time) AS date,
			MAX(time) - MIN(time) AS time,
			session_id,
			ip
		FROM `$esLog`
		$wherepart
		GROUP BY session_id
		ORDER BY Date DESC";
	$result = mod_mysql_querya($query, $data->sql);
	$access = array();
	while ($tmp = mysql_fetch_assoc($result))
	{
		$tmp2 = array($mod_txt['log_access_date'] => date('j.n.Y - G:i:s', $tmp['date']), $mod_txt['log_access_time'] => $tmp['time'] . ' Sec.', $mod_txt['log_access_count'] => $tmp['access'], 'IP' => long2ip($tmp['ip']));
		if (isset($esUser)) 
		{
			$query = "SELECT username FROM `$esLog` LEFT JOIN `$esUser` ON `$esUser`.id = `$esLog`.user_id WHERE user_id != 0 AND session_id = $tmp[session_id] ORDER BY time DESC LIMIT 1";
			$result2 = mod_mysql_querya($query, $data->sql);
			$tmp2[$mod_txt['log_access_user']] = mysql_num_rows($result2) ? mysql_result($result2, 0) : '-';
			mysql_free_result($result2);
		}
		$access[] = $tmp2;
	}
	mysql_free_result($result);

	CreateTableA(array('data' => $access, 'width' => '90%', 'title' => $mod_txt['log_access_title']));
}

function ShowAccessStats($data)
{
	global $mod_txt;
	mod_doDefaults($data);

	$TimeOptions = array($mod_txt['log_stats_day'], $mod_txt['log_stats_week'], $mod_txt['log_stats_month'], $mod_txt['log_stats_year']);
	$TimeSql = array('%W,&nbsp;%e.%c.%Y', $mod_txt['log_stats_week'] . ' %v (%x)', '%M %Y', '%Y');

	mod_addDefaultLink('mod_stats_group');
	if ($data->stats_user === true) mod_addDefaultLink('mod_stats_user');

	$selections = array();

	if ($data->stats_timetype === false)
	{
		$time = new selectparam;
		$time->data = $TimeOptions;
		$time->name = 'mod_stats_time';
		$time->default = 2;
		$selections[] = $mod_txt['log_stats_group'] . ' ' . CreateSelectParam($time);
		$data->stats_timetype = $TimeSql[$time->default];
	}

	if ($data->stats_user === true)
	{
		$esUser = mysql_escape_string($data->usertable);
		$user = new selectparam;
		$user->data = "(SELECT 0 AS id, '$mod_txt[java_all]' AS username) UNION (SELECT id, username FROM `$esUser` ORDER BY username ASC)";
		$user->name = 'mod_stats_user';
		$selections[] = $mod_txt['user_user'] . ' ' . CreateSelectParam($user);
		$userpart = $user->default ? 'AND user_id = ' . intval($user->default) : '';
	}
	else if ($data->stats_user !== false)
	{
		$userpart = 'AND user_id = ' . intval($data->stats_user);
	}
	else
	{
		$userpart = '';
	}

	echo implode(' - ', $selections), '<br><br>';

	$esLog = mysql_escape_string($data->logtable);

	$query = "SELECT
			DATE_FORMAT(FROM_UNIXTIME(time), '$data->stats_timetype') AS `" . ($esDate = mysql_escape_string($mod_txt['log_access_date'])) . "`,
			COUNT(DISTINCT session_id) AS `" . mysql_escape_string($mod_txt['log_access_count']) . "`
		FROM `$esLog`
		WHERE session_id != 0 $userpart
		GROUP BY `$esDate`
		ORDER BY time DESC";
	CreateTableA(array('data' => $query, 'width' => '90%', 'title' => $mod_txt['log_stats_title']));
}

function ShowMultiLog($data, $defaultlog = 0)
{
	global $mod_txt;
	mod_doDefaults($data);

	echo "<a href='$data->defaultlink&mod_logtype=0'>$mod_txt[log_title]</a> - <a href='$data->defaultlink&mod_logtype=1'>$mod_txt[log_access_title]</a> - <a href='$data->defaultlink&mod_logtype=2'>$mod_txt[log_stats_title]</a><br><br><hr><br>";

	if (!isset($_REQUEST['mod_logtype'])) $_REQUEST['mod_logtype'] = $defaultlog;
	$data->defaultlink = mod_addDefaultLink('mod_logtype');

	switch ($_REQUEST['mod_logtype'])
	{
		case 0:
			ShowLog($data);
			break;
		case 1:
			ShowAccessList($data);
			break;
		case 2:
			ShowAccessStats($data);
			break;
	}
}

?>
