<?php

class management
{
	public $sql = false;					//SQL Connection
	public $defaultlink = false;				//...
	public $indexname = 'subindex';				//Name for $_REQUEST subindex var

	public $client_table = 'clients';			//Client Table Name
	public $letter_template_table = 'letter_templates';	//Letter Template Table Name
	public $adress_table = 'adresses';			//Adress and Contact Table

	public $zins_base_table = 'zins_base';
	public $zins_fall_table = 'zins_fall';
	public $zins_cost_table = 'zins_cost';

	public $letter_templates = './letter_templates/';	//Directory to store Letter Templates in

	public $tmp_letter_local_dir = false;			//Local Directory on Server to store temporary letter files
	public $tmp_letter_remote_dir = false;			//Remote Directory that clients use to access temporary letter files
}

function mod_DualQuoteEscape($string)
{
	return(str_replace('"', '""', $string));
}

function mod_CreateLetterList($query, $sql)
{
	$tmp = mod_Query2Array($query, $sql, false, MYSQL_ASSOC);
	$out = array(implode("\t", mod_EscapeArray(array_keys($tmp[0]), '"', 'mod_DualQuoteEscape')));
	foreach ($tmp as $tmp2)
		$out[] = implode("\t", mod_EscapeArray(array_values($tmp2), '"', 'mod_DualQuoteEscape'));
	return(implode("\r\n", $out));
}

function mod_CreateLetterTempfile($data, $content, $list, $filename)
{
	if (!file_exists($data->tmp_letter_local_dir)) trigger_error("Directory does not exist: $data->tmp_letter_local_dir");
	if (substr($data->tmp_letter_local_dir, -1) != "/") $data->tmp_letter_local_dir .= '/';
	if (substr($data->letter_templates, -1) != '/') $data->letter_templates .= '/';

	do; while (file_exists($tmpfilename = $data->tmp_letter_local_dir . ($tmpdirname = str_pad(date('Ym'), 8, STR_PAD_RIGHT)) . '/' . ($tmpname = mod_tempFileName()) . '.tmp'));
	if (!file_exists($data->tmp_letter_local_dir . $tmpdirname))
	{
		mkdir($data->tmp_letter_local_dir . $tmpdirname);
	}
	file_put_contents($tmpfilename, $list);

	$chr0 = chr(0);
	$pos = 0;
	$dirinterl = str_interleave($data->tmp_letter_remote_dir, $chr0);
	$strings = array();

	do
	{
		$found = false;
		$firstpos = $pos = stripos($content, $dirinterl, $pos);
		if ($pos !== false)
		{
			$found = true;
			$pos += strlen($dirinterl);
			for ($j = 0;$j < 2;$j++)
			{
				for ($i = 0;$i < 8;$i++)
				{
					if ($content{$pos} != $chr0)
					{
						$found = false;
						break;
					}
					$tmpchar = ord($content{$pos + 1});
					if (!(
						($tmpchar >= ord('0') && $tmpchar <= ord('9')) ||
						(
							$j &&
							(
								($tmpchar >= ord('a') && $tmpchar <= ord('z')) ||
								($tmpchar >= ord('A') && $tmpchar <= ord('Z'))
							)
						)
					))
					{
						$found = false;
						break;
					}
					$pos += 2;
				}

				if (!$j && ($content{$pos++} != $chr0 || $content{$pos++} != "\\"))
				{
					$found = false;
				}
				if (!$found) break;
			}
		}
					if ($found)
		{
			$strings[] = substr($content, $firstpos, strlen($dirinterl) + 42);
		}
	} while ($pos !== false);
	$content = str_replace($strings, $dirinterl . $chr0 . str_interleave("$tmpdirname\\$tmpname.tmp", $chr0), $content);

	header('Content-type: application/msword');
	header("Content-disposition: attachment; filename=\"$filename\"");
	ob_end_clean();
	echo $content;
	exit;
}

function mod_mgmt_client_update($data, $delete, $id)
{
	$esClients = mysql_escape_string($data->client_table);
	$esAdresses = mysql_escape_string($data->adress_table);

	$fields = array('p', 'b');
	foreach ($fields as $field)
	{
		if ($delete)
		{
			$query = "UPDATE `$esClients` SET adress_" . $field . "_type = 1 WHERE adress_" . $field . "_type = 0 AND id = $id";
		}
		else
		{
			$query = "UPDATE `$esClients` SET adress_" . $field . " = 0 WHERE adress_" . $field . "_type = 2 AND id = $id";
		}
		mod_mysql_querya($query, $data->sql);
	}

	$joinwhere = $delete ? " AND `$esClients`.id != $id" : '';

	$query = "SELECT `$esAdresses`.id FROM `$esAdresses` LEFT JOIN `$esClients` ON ((adress_b_type = 0 AND adress_b = `$esAdresses`.id) OR (adress_p_type = 0 AND adress_p = `$esAdresses`.id)) AND `$esClients`.deleted = 0 $joinwhere WHERE `$esClients`.id IS NULL";
	$result = mod_mysql_querya($query);
	while ($tmp = mysql_fetch_assoc($result))
	{
		$query = "SELECT * FROM `$esClients` WHERE (adress_b = $tmp[id] OR adress_p = $tmp[id]) AND deleted = 0 $joinwhere LIMIT 1";
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result))
		{
			$client = mysql_fetch_assoc($result);
			$query = "UPDATE `$esClients` SET adress_" . ($client['adress_b'] == $tmp['id'] ? 'b' : 'p') . "_type = 0 WHERE id = $client[id]";
		}
		else
		{
			$query = "DELETE FROM `$esAdresses` WHERE id = $tmp[id]";
		}
		mod_mysql_querya($query, $data->sql);
	}
}

function mod_mgmt_adr_present_callback($data, $tmp, $subtable, $edit)
{
	return($tmp[substr($subtable, 4) . '_type'] == 0);
}

function mod_mgmt_zins_RatePay($posts, $lastdate, &$ratenum, &$rateok, &$rateamount)
{
	if ($ratenum >= 240)
	{
		$rateok = false;
		if ($ratenum == 240)
		{
			echo "<font size=+1 color=red><b>Breche ab nach 240 Ratenzahlungen!!!</b></font>";
		}
		$ratenum++;
		return(false);
	}
	if (!isset($_GET['mod_mgmt_zins_ratepay'])) return(false);
	$rateday = intval($_GET['mod_mgmt_zins_ratepay']);
	if ($rateday > 28)
	{
		$rateday = 0;
	}
	$rateamount = intval(str_replace(',', '.', $_GET['mod_mgmt_zins_ratepayamount']));
	if (($ratefrom = @strtotime(implode('-', array_reverse(explode('.', $_GET['mod_mgmt_zins_ratepayfrom']))))) == -1)
	{
		$ratefrom = 0;
	}
	if (!($rateday && $rateamount && $ratefrom)) return(false);
	$ratefrom = max($ratefrom, $lastdate);
	foreach ($posts as $post)
	{
		if ($post['amount'])
		{
			$rateok = true;
			$tmpyear = date('Y', $ratefrom);
			$tmpmonth = date('m', $ratefrom);
			$tmpday = date('j', $ratefrom);
			if ($tmpday >= $rateday)
			{
				$tmpday = $rateday;
				if ($tmpmonth == 12)
				{
					$tmpyear++;
					$tmpmonth = 1;
				}
				else
				{
					$tmpmonth++;
				}
			}
			else
			{
				$tmpday = $rateday;
			}
			$ratetime = strtotime("$tmpyear-$tmpmonth-$tmpday");
			return(array('amount' => $rateamount, 'type' => 'zahlung', 'descr' => 'Ratenzahlung ' . $ratenum++, 'timestamp' => $ratetime, 'zins' => NULL));
		}
	}
	return(false);
}

function mod_mgmt_zins_LastEntry(&$LastEntryDone, &$finaldate, &$rateok)
{
	if ($LastEntryDone || $rateok)
	{
		return(false);
	}
	$LastEntryDone = 1;
	$time = strtotime(date('Y-m-d', $finaldate));
	return(array('amount' => 0, 'type' => 'ende', 'descr' => 'Restzinsen bis ' . date('j.n.Y'), 'timestamp' => $time, 'zins' => NULL));
}


function mod_mgmt_zinscalc($data, $id, $esZinsBase, $esZinsFall, $esZinsCost)
{
	if (isset($_GET['mod_mgmt_zins_finaldate']))
	{
		$finaldate = mod_getDate($_GET['mod_mgmt_zins_finaldate'], 0, time());
	}
	else
	{
		$finaldate = time();
	}

	$query = "SELECT * FROM `$esZinsCost` WHERE fall_id = $id AND timestamp <= $finaldate ORDER BY timestamp ASC, type ASC";
	$result = mod_mysql_querya($query, $data->sql);
	echo '<table><tr><td>Verarbeitung: (<a href="#mod_mgmt_zins_show">Ergebnis</a>)<ul>';
	$posts = array();
	$left = 0;

	$LastEntryDone = 0;

	$ratenum = 1;
	$rateok = false;

	while (($tmp = mysql_fetch_assoc($result)) || ($tmp = mod_mgmt_zins_RatePay($posts, $lastdate, $ratenum, $rateok, $rateamount)) || ($tmp = mod_mgmt_zins_LastEntry($LastEntryDone, $finaldate, $rateok)))
	{
		$tmp['timestamp'] += intval(date('I', $tmp['timestamp'])) * 3600;
		if (!isset($lastdate) || $tmp['timestamp'] != $lastdate)
		{
			echo '<br>Eintrag: ' . date('j.n.Y', $tmp['timestamp']). '<ul>';
		}
		else
		{
			echo '<ul>';
		}
		if (isset($lastdate) && $tmp['timestamp'] > $lastdate)
		{
			$applytime = $tmp['timestamp'] - 60 * 60 * 24 - $lastdate;
			$applytime /= 60 * 60 * 24;
			$applytime++;
			echo "<font color=red>Berechne Zinsen: ($applytime Tage: " . date('j.n.Y', $lastdate) . ' - ' . date('j.n.Y', $tmp['timestamp'] - 60 * 60 * 24) . ")<ul>";
		
			foreach ($posts as &$post)
			{
				$applytimesave = $applytime;
				$lastdatesave = $lastdate;

				if ($lastdate == $post['timestamp'])
				{
					$lastdate += 60 * 60 * 24;
					$applytime--;
				}

				if ($applytime > 0 && $post['zins'] !== '0' && ($post['amount'] || $post['zinsen']))
				{
					echo "- $post[descr] ($post[amount] ): ";
					if ($post['zins'] == NULL)
					{
						echo ' <i>(Basiszins)</i><ul>';
						$query = "SELECT * FROM `$esZinsBase`";
						$result2 = mod_mysql_querya($query, $data->sql);
						$tmpval = 0;
						do
						{
							$tmp2_2 = mysql_fetch_assoc($result2);
							if ($tmp2_2 === false)
							{
								$query = "SELECT end, percent FROM `$esZinsBase` ORDER BY end DESC LIMIT 1";
								$tmp2_result = mysql_query($query, $data->sql);
								if (mysql_num_rows($tmp2_result) == 0)
								{
									echo "<font color=red size=+1><b>Kein Basiszins vorhanden</b></font>";
									break;
								}
								$tmp2_3 = mysql_fetch_assoc($tmp2_result);
								$tmp2_3['start'] = $tmp2['end'] + 3600 * 24;
								$tmp2_3['end'] += 20 * 365 * 24 * 3600;
								$tmp2 = $tmp2_3;
							}
							else
							{
								$tmp2 = $tmp2_2;
							}

							$tmp2['start'] += date('I', $tmp2['start']) * 3600;
							$tmp2['end'] += date('I', $tmp2['end']) * 3600;

							$applytime2 = min($tmp['timestamp'] - 60 * 60 * 24, $tmp2['end']) - max($lastdate, $tmp2['start']);
							$applytime2 /= 60 * 60 * 24;
							$applytime2++;
							if ($applytime2 > 0)
							{
								$curzins = $post['amount'] * $applytime2 / 365 * $tmp2['percent'] / 100;
								echo "$tmp2[percent]% fr $applytime2 Tage <i>(" . date('j.n.Y', max($lastdate, $tmp2['start'])) . ' - ' . date('j.n.Y', min($tmp['timestamp'] - 60 * 60 * 24, $tmp2['end'])) . ": " . round($curzins,2) . " )</i> <br>";
								$tmpval += $curzins;
							}
						} while ($tmp2_2);
					}
					else
					{
						echo " <i>(Zinssatz: $post[zins]%)</i><ul>";
						$tmpval = $post['amount'] * $post['zins'] / 100 * $applytime / 365;
					}
					$tmpval = round($tmpval, 2);
					echo " Bisherige Zinsen: $post[zinsen]  Neue Zinsen: $tmpval  Gesamt: " . ($post['zinsen'] + $tmpval) . ' ';
					$post['zinsen'] += $tmpval;

					echo '</ul><br>';
				}

				$applytime = $applytimesave;
				$lastdate = $lastdatesave;
			}
			echo '</ul></font>';
		}
		if ($tmp['type'] == 'zahlung')
		{
			echo "<font color=green><b>Zahlung: $tmp[amount] </b> ($tmp[descr])<br>";
			for ($i = 0;$i < 4;$i++)
			{
				foreach ($posts as &$post)
				{
					if ($tmp['amount'] == 0)
					{
						break(2);
					}
					if ($i < 2 && $post['type'] == 'kosten')
					{
						if ($i == 0)
						{
							if ($tmpval = min($post['zinsen'], $tmp['amount']))
							{
								$post['zinsen'] -= $tmpval;
								$tmp['amount'] -= $tmpval;
								echo "Zinsen von $post[descr] getilgt: $tmpval <br>";
							}
						}
						else
						{
							if ($tmpval = min($post['amount'], $tmp['amount']))
							{
								$post['amount'] -= $tmpval;
								$tmp['amount'] -= $tmpval;
								echo "Kosten $post[descr] gezahlt: $tmpval " . ($post['amount'] ? '' : ' - <u>Posten geschlossen</u>') . "<br>";
							}
						}
					}
					else if ($i >= 2 && $post['type'] == 'haupt')
					{
						if ($i == 2)
						{
							if ($tmpval = min($post['zinsen'], $tmp['amount']))
							{
								$post['zinsen'] -= $tmpval;
								$tmp['amount'] -= $tmpval;
								echo "Zinsen von $post[descr] getilgt: $tmpval <br>";
							}
						}
						else
						{
							if ($tmpval = min($post['amount'], $tmp['amount']))
							{
								$post['amount'] -= $tmpval;
								$tmp['amount'] -= $tmpval;
								echo "Hauptforderung $post[descr] gezahlt: $tmpval " . ($post['amount'] ? '' : ' - <u>Posten geschlossen</u>') . "<br>";
							}
						}
					}
				}
			}
			if ($tmp['amount'])
			{
				echo "<b><font size=+1>" . round($tmp['amount'], 2) . "  von Zahlung brig!</font></b><br>";
				$left += $tmp['amount'];
			}
			echo '</font>';
		}
		else if ($tmp['type'] != 'ende')
		{
			if ($left)
			{
				$tmpval = min($left, $tmp['amount']);
				echo "<b><font size=+1 color=green>Von letzter Zahlung brig: $left , $tmpval  gezahlt!</font></b><br>";
				$left -= $tmpval;
				$tmp['amount'] -= $tmpval;
			}
			echo "<font color=red><b>Neuer Posten: $tmp[descr] ($tmp[amount]  / [$tmp[type]])</b></font><br>";
			$posts[] = array('descr' => $tmp['descr'], 'amount' => $tmp['amount'],
				'type' => $tmp['type'], 'zins' => $tmp['zins'], 'zinsen' => 0,
				'timestamp' => $tmp['timestamp']);
		}
		$lastdate = $tmp['timestamp'];
		echo '</ul>';
	}
	echo '<a name="mod_mgmt_zins_show"></a>Verbleibende Posten:<br>';
	$sum = 0;
	foreach ($posts as &$post)
	{
		if ($post['amount'])
		{
			echo "$post[descr]: $post[amount] , $post[zinsen]  Zinsen<br>";
			$sum += $post['amount'] + $post['zinsen'];
		}
	}
	$sum = round($sum - $left, 2);
	echo "<br><b><u>Summe: $sum </u></b>";

	if ($rateok)
	{
		echo "<br><br><b>Ratenzahlung: " . ($ratenum - 2) . " * " . ($rateamount) . " + 1 * " . round($rateamount - $left, 2) . "  = " . round(($ratenum - 1) * $rateamount - $left, 2) . "</b><br><br>";
	}

	$query = "SELECT IFNULL(MAX(end),0) FROM `$esZinsBase`";
	$tmp = mysql_result(mod_mysql_querya($query, $data->sql), 0);

	if ($tmp < $lastdate)
	{
		echo "<br><br><font size=+1><b><font color=red>Keine Vollstndige Zinsberechnung mglich, da ab dem " . date("j.n.Y", $tmp) . " keine Basiszinsstze mehr verfgbar sind!!!</font></b></font><br><br>";
	}

	echo mod_linkToForm($data->defaultlink . "&mod_mgmt_zins_fall=$id", '#mod_mgmt_zins_show', 'GET') . "Verbleibende Posten fr <input type=text name='mod_mgmt_zins_finaldate' value='" . date('d.m.Y', isset($_GET['mod_mgmt_zins_finaldate']) ? $_GET['mod_mgmt_zins_finaldate'] : time()) . "'> anzeigen.<br><i>(leer fr aktuelles datum) <input type=submit value=Aktualisieren></form><hr>";
	echo mod_linkToForm($data->defaultlink . "&mod_mgmt_zins_fall=$id", '#mod_mgmt_zins_show', 'GET') . "Ratenzahlung <input type=text name='mod_mgmt_zins_ratepayamount' value='" . (isset($_GET['mod_mgmt_zins_ratepayamount']) ? $_GET['mod_mgmt_zins_ratepayamount'] : '0') . "' size=5>  am <input type=text size=1 name='mod_mgmt_zins_ratepay' value='" . (isset($_GET['mod_mgmt_zins_ratepay']) ? $_GET['mod_mgmt_zins_ratepay'] : '1') . "'><b>.</b> des Monats ab <input type=text size=10 name=mod_mgmt_zins_ratepayfrom value='" . (isset($_GET['mod_mgmt_zins_ratepayfrom']) ? $_GET['mod_mgmt_zins_ratepayfrom'] : date('d.m.Y')) . "'><br><i>(0 oder leer fr keine Ratenzahlung) <input type=submit value=Ratenzahlung berechnen></form><br><br>";

	echo '</ul>Verarbeitung abgeschlossen</td></tr></table><br>';
	echo '<br><a href="index.php">Fall schlieen</a><br>';
	echo '<br><hr><br>';
}

function CreateManagement($data)
{
	global $mod_txt;
	mod_doDefaults($data);
	$indexname = $data->indexname;
	global $$indexname;

	$esClients = mysql_escape_string($data->client_table);
	$esLetterTemplates = mysql_escape_string($data->letter_template_table);
	$esAdresses = mysql_escape_string($data->adress_table);

	$esZinsBase = mysql_escape_string($data->zins_base_table);
	$esZinsFall = mysql_escape_string($data->zins_fall_table);
	$esZinsCost = mysql_escape_string($data->zins_cost_table);

	checkTable('mgmt_clients', $data->client_table);
	checkTable('name', $data->client_table);
	checkTable('mgmt_letter_templates', $data->letter_template_table);
	checkTable('adress', $data->adress_table);
	checkTable('contact', $data->adress_table);
	checkTable('mgmt_adress', $data->adress_table);

	checkTable('mgmt_zins_base', $data->zins_base_table);
	checkTable('mgmt_zins_fall', $data->zins_fall_table);
	checkTable('mgmt_zins_cost', $data->zins_cost_table);

	$edit = new sqledit;
	$edit->sql = $data->sql;
	$edit->defaultlink = $data->defaultlink;

	switch ($$indexname)
	{
		case 'clients':
			$edit->sqltablename = $data->client_table;
			$edit->sortable = false;
			$edit->showtable = 15;
			$edit->name = $mod_txt['mgmt_client'];
			$edit->title = $mod_txt['mgmt_clients'];
			$edit->namefield = 'CONCAT(nr, ": ", surname, ", ", forename)';
			$edit->relations = array(
				'nr' => array('name' => $mod_txt['mgmt_clientnr'], 'type' => 'int', 'force' => true, 'nodual' => true, 'autoinc' => 10000)
			);

			$edit->deletecallback = array('mod_mgmt_client_update', $data, true);
			$edit->editcallback = array('mod_mgmt_client_update', $data, false);
			$edit->savedelete = true;

			$edit->relations += mod_genNameRelations();

			$edit->relations += array(
				'call' => array('name' => $mod_txt['mgmt_call'], 'force' => true, 'inhtml' => 'id="mod_mgmt_call"', 'appendform2' =>
					'<br><select onchange="if(this.value!=0){document.getElementById(\'mod_mgmt_call\').value = this.value;if(this.value.toString().charAt(this.value.toString().length - 1) == \' \') document.getElementById(\'mod_mgmt_call\').value += document.getElementById(\'mod_mgmt_surname\').value;}"><option value=0>- ' . $mod_txt['text_selection'] . ' -</option>' . mod_createselectoptionsarray(array_combine($mod_txt['mgmt_calls'], $mod_txt['mgmt_calls'])) . '</select>')
			);

			$adress_types = array('Adresse eingeben', 'Adresse eines anderen Mandantens bernehmen', 'Keine Adresse eingeben');
			$adress_types2 = array('private', 'business');

			foreach ($adress_types2 as $index => $val)
			{
				$indexshort = '_' . substr($val, 0, 1);
				$edit->relations += array('sep' . $indexshort => array('hide' => true, 'type' => 'seperator', 'default' => '<br>'));
				$edit->relations['adress' . $indexshort . '_type'] = array('name' => '<b>' . $mod_txt['adress_' . $val . '_adress'] . '</b>', 'type' => 'select', 'options' => $adress_types, 'recheckinstance' => 'mod_adr' . $indexshort . '_recheck');
				$edit->relations['adress' . $indexshort . '_sel'] = array(
					'multipleinstanceblocks' => array(),
					array_merge(
						mod_genAdressRelations('mod_adress' . $indexshort, $indexshort),
						mod_genContactRelations('mod_adress' . $indexshort, $indexshort),
						array('check_php' => 'return($_REQUEST[$mod_tmp_relpre . "adress' . $indexshort . '_type"] == 0);', 'check_java' => "document.getElementById('mod_adr$indexshort" . "_recheck').value == 0")
					),
					array(
						'adress' . $indexshort => array('name' => 'Adresse', 'type' => 'select', 'options' => "SELECT `$esAdresses`.id, CONCAT(`$esClients`.surname, ', ', `$esClients`.forename, ' - ', `$esAdresses`.street, ', ', `$esAdresses`.zip, ' ', `$esAdresses`.city) AS name FROM `$esAdresses` LEFT JOIN `$esClients` ON `$esClients`.deleted = 0 AND ((`$esAdresses`.id = adress_b AND adress_b_type = 0) OR (`$esAdresses`.id = adress_p AND adress_p_type = 0)) WHERE `$esClients`.id IS NOT NULL AND `$esClients`.id != [EDIT_ID] GROUP BY `$esAdresses`.id ORDER BY name ASC", 'foldempty' => true),
						'check_php' => 'return($_REQUEST[$mod_tmp_relpre . "adress' . $indexshort . '_type"] == 1);', 'check_java' => "document.getElementById('mod_adr$indexshort" . "_recheck').value == 1"
					)
				);

				$edit->subtables['mod_adress' . $indexshort] = array('id' => 'adress' . $indexshort, 'defaults' => array('type' => $index), 'type' => 'reverse', 'tablename' => $data->adress_table, 'present_callback' => array('mod_mgmt_adr_present_callback', $data));
			}

			CreateSqlEdit($edit);
			break;

		case 'zinsbase':
			$edit->sqltablename = $data->zins_base_table;
			$edit->sortable = 'start ASC';
			$edit->relations = array(
				'start' => array('name' => 'Gltig von', 'type' => 'date', 'default' => '', 'force' => true),
				'end' => array('name' => 'Gltig bis', 'type' => 'date', 'default' => '', 'force' => true),
				'percent' => array('name' => 'Zinssatz', 'type' => 'int', 'float' => true, 'default' => '', 'force' => true, 'appendform' => '%')
			);
			$edit->name = 'Zinssatz';
			$edit->title = 'Basiszinsstze';
			CreateSqlEdit($edit);

			$query = "SELECT * FROM `$esZinsBase` ORDER BY start ASC";
			$result = mod_mysql_querya($query, $data->sql);
			while ($tmp = mysql_fetch_assoc($result))
			{
				if (isset($endtime))
				{
					if ($tmp['start'] != $endtime + 60 * 60 * 24)
					{
						if ($tmp['start'] > $endtime + 60 * 60 * 24)
						{
							echo "<font color='#FF0000'>Fehlende Zeitperiode: " . date('j.n.Y', $endtime + 60 * 60 * 24) . ' bis ' . date('j.n.Y', $tmp['start']) . '</font><br>';
						}
						else
						{
							echo "<font color='#CC0000'> berschnittene Zeitperiode: " . date('j.n.Y', $tmp['start']) . ' bis ' . date('j.n.Y', $endtime + 60 * 60 * 24) . '</font><br>';
						}
					}
				}
				$endtime = $tmp['end'];
			}
			break;

		case 'zinscalc':
			if (isset($_REQUEST['mod_mgmt_zins_fall']) && mod_checkTableId($data->zins_fall_table, $tmp_id = intval($_REQUEST['mod_mgmt_zins_fall'])))
			{
				echo "<center><a href='$data->defaultlink'>Fall schlieen</a></center><br>";

				$query = "SELECT * FROM `$esZinsFall` WHERE id = $tmp_id";
				$fall = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));

				$edit->defaultlink .= "&mod_mgmt_zins_fall=$tmp_id";
				$edit->adddefaults['fall_id'] = $tmp_id;
				$edit->sqlwhere = '';
				$edit->sqltablename = $data->zins_cost_table;
				$edit->sortable = false;
				$edit->title = "Fall: $fall[name] - Forderungen / Kosten / Zahlungen";
				$edit->relations = array(
					'descr' => array('name' => 'Beschreibung', 'force' => true),
					'timestamp' => array('name' => 'Datum', 'type' => 'date', 'force' => true),
					'type' => array('name' => 'Art', 'type' => 'select', 'options' => array('haupt' => 'Hauptforderung', 'kosten' => 'Kosten', 'zahlung' => 'Zahlung')),
					'amount' => array('name' => 'Betrag', 'type' => 'int', 'float' => true, 'force' => true),
					'zins' => array('name' => 'Zinsen', 'type' => 'int', 'float' => true, 'default' => 0)
				);
				CreateSqlEdit($edit);

				echo '<br><hr><br>';

				mod_mgmt_zinscalc($data, $tmp_id, $esZinsBase, $esZinsFall, $esZinsCost);
			}
			else
			{
				$edit->sqltablename = $data->zins_fall_table;
				$edit->sortable = false;
				$edit->title = 'Flle';
				$edit->name = 'Fall';
				$edit->relations = array(
					'name' => array('name' => 'Fall', 'force' => true, 'nodual' => true, 'link' => $data->defaultlink . "&mod_mgmt_zins_fall=[ID]")
				);
				$edit->adddate = true;
				CreateSqlEdit($edit);
			}

			break;

		case 'lettertemplates':
			$edit->sqltablename = $data->letter_template_table;
			$edit->sortable = false;
			$edit->name = $mod_txt['mgmt_letter_template'];
			$edit->name = $mod_txt['mgmt_letter_templates'];
			$edit->adddefaults = array('user' => 1);
			$edit->sqlwhere = '';
			$edit->relations = array(
				'name' => array('name' => $mod_txt['text_name'], 'force' => true, 'nodual' => true),
				'descr' => array('name' => $mod_txt['text_description']),
				'file' => array('name' => $mod_txt['mgmt_letter_template'], 'storage' => $data->letter_templates, 'filename' => 'filename', 'type' => 'file'),
				'filename' => array('name' => $mod_txt['text_filename'], 'type' => 'hidden')
			);
			CreateSqlEdit($edit);
			break;

		case 'letter':
			if (isset($_REQUEST['mod_mgmt_letterlist']) && count($_REQUEST['mod_mgmt_letterlist']) && isset($_REQUEST['mod_mgmt_letterfile']) && mod_checkTableId($data->letter_template_table, $fileid = intval($_REQUEST['mod_mgmt_letterfile'])))
			{
				$content = file_get_contents($data->letter_templates . $fileid);

				$query = "SELECT * FROM `$esLetterTemplates` WHERE id = $fileid";
				$tmp = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));
				$filename = preg_replace("/\\.doc$/", ' - ' . date('j.n.Y') . '.doc', $tmp['filename']);

				$query = "SELECT 
						`$esClients`.nr AS '" . mysql_escape_string($mod_txt['mgmt_clientnr']) . "',
						`$esClients`.surname AS '" . mysql_escape_string($mod_txt['adress_surname']) . "',
						`$esClients`.forename AS '" . mysql_escape_string($mod_txt['adress_forename']) . "',
						`$esClients`.company AS '" . mysql_escape_string($mod_txt['adress_company']) . "',
						`$esAdresses`.street AS '" . mysql_escape_string($mod_txt['adress_street']) . "',
						`$esAdresses`.zip AS '" . mysql_escape_string($mod_txt['adress_zip']) . "',
						`$esAdresses`.city AS '" . mysql_escape_string($mod_txt['adress_city']) . "',
						`$esClients`.call AS '" . mysql_escape_string($mod_txt['mgmt_call']) . "',
						CONCAT(IF(company = '', '', CONCAT(company, '\r\n')), IF(surname = '' AND forename = '', '', CONCAT(forename, ' ', surname, '\r\n')), street,
							'\r\n', zip, ' ', city) AS '" . mysql_escape_string($mod_txt['mgmt_adress_block']) . "'
					FROM
						`$esClients`
					LEFT JOIN `$esAdresses`
						ON `$esAdresses`.id = IF(adress_b = 0, adress_p, adress_b)
					WHERE
						`$esAdresses`.id IS NOT NULL AND
						`$esClients`.id IN (" . implode(',', mod_EscapeArray($_REQUEST['mod_mgmt_letterlist'], '', 'intval')) . ")
				";
				$list = mod_CreateLetterList($query, $data->sql);

				mod_CreateLetterTempfile($data, $content, $list, $filename);
			}
			else
			{
				echo "<center><b><u style='font-size:120%'>$mod_txt[mgmt_recsel]:</u></b></center>";

				echo mod_linkToForm($data->defaultlink);
				$list = new duallist;
				$list->sql = $data->sql;
				$list->fullids = true;
				$list->inputname = 'mod_mgmt_letterlist';
				$list->data = array("SELECT id, CONCAT(nr, ': ', surname, ', ', forename) FROM `$esClients`", array());
				$list->desc = array($mod_txt['mgmt_clientsavail'], $mod_txt['mgmt_clientssel']);
				$list->size = 10;
				echo CreateFormDualList($list);

				echo "<br><hr><br><center><b><u style='font-size:120%'>$mod_txt[mgmt_lettersel]:</u></b></center>";

				$query = "SELECT id, CONCAT(name, IF(descr='','',CONCAT(' - ', descr)), ' (', filename, ')') AS name FROM `$esLetterTemplates` ORDER BY user ASC, name ASC";

				echo "<select size=10 name='mod_mgmt_letterfile'>" . mod_createselectoptions($query, $data->sql, false, false) . '</select>';

				echo "<br><hr><br><input type=submit value='$mod_txt[mgmt_sendletter]'></form>";
			}
			break;
	}
}

?>