<?php

class shop
{
	public $sql;							//SQL Connection
	public $defaultlink = false;					//Default Link
	public $item_group_table = 'item_groups';			//Item Group Table
	public $item_list_table = 'item_lists';				//Item List Table
	public $item_table = false;					//Item Table
	public $category_table = false;					//Category Table
	public $category_link_table = false;				//Category Link Table
	public $shipping_table = false;					//Shipping Type Table
	public $link_table = false;					//Article Link Table (false for no article links)
	public $user_table = false;					//User table
	public $prices_table = false;					//Prices Table
	public $adress_table = false;					//Adress Table
	public $contact_table = false;					//...
	public $image_folder = false;					//Image Folder (leave false and supply an image field to store in db)
	public $image_file = false;					//php file to use to display images

	public $add_type = false;					//False for simple button, true for html add_html text inserted, 1 for image in add_html, 0 for link only when multi = false
	public $add_multi = false;					//Add multiple items at once
	public $add_html = false;					//See above

	public $add_item_link = false;					//Returned value, replace [ID] with real item_id
	public $item_select = false;					//SQL Select string, give array for small/big version of item list, false for default
	public $insertcosts = false;					//Insert cost posts in this col, false for default

	public $esGroupid = false;					//Group List id, internally used
	public $dwInstance = false;					//Internally used
	public $category_id = false;					//"
	public $dwItemsum = false;					//Item Count "
	public $dwPricesum = false;					//Price Sum ""
	public $pricegroups = true;					//Use User groups to determine prices instead of price field in article

	public $displayType = true;					//True to display, false to return array (for ItemList)
	public $extendedLinkTable = true;				//Extended table for Item links instead of simple display

	public $tabledata = array();					//Passed to sqledit
	public $articlelinkpre = '';					//Append to link before article_id

	public $register = false;					//Register string as user mod to allow changing data

	public $shophtml = false;					//HTML Var passed to menu
	public $shophtmlclass = false;					//Classes for html part if autocreated, string for selected part only or array with 3 entries for all parts, false for nothing

	public $adminmode = false;					//Allow to edit shop articles?
	public $usershopselect = false;					//User defined select clause (can be array 'title' =>..., 'sql' => ...

	public $categorydefaultdata = array();				//Default data for category menu
	public $categoryeditdefaultdata = array();			//Default data for category menu edit
	public $categoryeditrestrict = false;				//Give an array to restrict category edit (url and urlopts as array values), negative indexes starting from -1 for url to just give defaults
	public $categoryeditpreurlopt = '';				//Preurl Opt for categories
	public $category_java = true;					//Extra Java Field for categories

	public $article_table = false;					//Name of sql table to store article table in. supply legend field in article table then
	public $articlerelations = array();				//Additional Article Relations
	public $exportdefaultlink = true;				//Export Default link for category menu
	public $urlarticlelink = '';					//Add to link to display article in menu
	public $userlistlink = '';					//Link for list...
	public $urlitemlink = '';					//Link to display item list / pay /shipping
	public $urlaccountlink = '';					//Link to account Management

	public $display_callback = 'mod_ShowArticleCallback';		//Callback funktion to display article, will get array with data
	public $ask_adress = true;					//Ask to register or just give adress when not logged in

	public $article_edit_callback = false;				//Callback function for article edit sqledit object

	public $shop_enabled = true;					//Is this a shop at all?
}

function mod_CreateShopCategoryConfig_Restrictcallback($data, $edit)
{
	for ($i = 0;$i < 2;$i++)
	{
		if (isset($data->categoryeditrestrict[$i]))
		{
			unset($edit->relations[$i ? 'urlopt' : 'url']);
			$edit->adddefaults[$i ? 'urlopt' : 'url'] = $data->categoryeditrestrict[$i];
		}
		else if (isset($data->categoryeditrestrict[-$i - 1]))
		{
			$edit->relations[$i ? 'urlopt' : 'url']['default'] = $data->categoryeditrestrict[-$i - 1];
		}
	}
}

function CreateShopCategoryConfig($data)
{
	global $mod_txt;
	mod_doDefaults($data);
	$config = new menuconfig;
	$config->sql = $data->sql;
	$config->defaultlink = $data->defaultlink;
	$config->table = $data->category_table;
	$config->title = $mod_txt['shop_categories'];
	$config->rights = 'rights';
	$config->java = $data->category_java;
	mod_doDefaults($config, $data->categoryeditdefaultdata);
	if ($data->categoryeditrestrict !== false)
	{
		$config->edit_callback = array('mod_CreateShopCategoryConfig_Restrictcallback', $data);
	}
	CreateMenuConfig($config);
}


function mod_ManageShippingCosts($data)
{
	global $mod_txt;
	if (!$data->adminmode || !$data->shop_enabled) return;
	checkTable('shop_shipping', $data->shipping_table);
	$edit = new sqledit;
	$edit->title = 'Shipping Management';
	$edit->name = 'Shipping Type';
	$edit->sqltablename = $data->shipping_table;
	$edit->sortable = false;
	$edit->relations = array(
		'name' => array('name' => $mod_txt['shop_shipping_type'], 'force' => true),
		'price' => array('group' => true, 'name' => $mod_txt['shop_price'], 'type' => 'int', 'force' => true, 'float' => 1, 'appendform' => ' ', 'sql' => true),
		'free' => array('name' => $mod_txt['shop_free_at'], 'type' => 'int', 'force' => 1, 'float' => 1, 'appendform' => '', 'sql' => true, 'group' => false)
	);
	CreateSqlEdit($edit);
}

function mod_showItemLists($data) //Account
{
	global $userdata, $mod_txt, $mod_dwShopInstance;
	if ($userdata['id'] == 0 || !$data->shop_enabled) return;

	$esItems = mysql_escape_string($data->item_table);
	$esGroup = mysql_escape_string($data->item_group_table);
	$esList = mysql_escape_string($data->item_list_table);

	echo "<a href='$data->defaultlink&mod_shop_new_cart$data->dwInstance'>$mod_txt[shop_new_cart]</a>";
	if ($data->register !== false) echo " - <a href='$data->defaultlink$data->register&mod_editself'>$mod_txt[user_selfedit]</a>";
	echo '<hr>';

	if (isset($_REQUEST["mod_shop_delete_cart$data->dwInstance"]))
	{
		$query = "SELECT user_id, ordered FROM `$esGroup` WHERE id = " . ($delid = intval($_REQUEST["mod_shop_delete_cart$data->dwInstance"]));
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result))
		{
			$tmp = mysql_fetch_assoc($result);
			if ($tmp['user_id'] == $userdata['id'] && $tmp['ordered'] < 2)
			{
				$query = "DELETE FROM `$esGroup` WHERE id = $delid";
				mod_mysql_querya($query, $data->sql);
				mod_redir_changes(array("mod_shop_delete_cart$data->dwInstance"));
			}
		}
	}

	$query = "SELECT
			CONCAT('<a href=\"" . mysql_escape_string($data->defaultlink) . "&mod_shop_select_cart$data->dwInstance=', `$esGroup`.id, '\">', DATE_FORMAT(FROM_UNIXTIME(`$esGroup`.timestamp), '%W,&nbsp;%e.%c.%Y&nbsp;-&nbsp;%H:%i:%s'), '</a>') AS '" . mysql_escape_string($mod_txt['shop_last_access']) . "',
			COUNT(`$esList`.id) AS '" . mysql_escape_string($mod_txt['shop_article']) . "',
			IF(ordered >= 2, CONCAT('" . mysql_escape_string($mod_txt['shop_ordered_at']) . ": ', DATE_FORMAT(FROM_UNIXTIME(`$esGroup`.timestamp), '%W,&nbsp;%e.%c.%Y&nbsp;-&nbsp;%H:%i:%s')), '" . mysql_escape_string($mod_txt['shop_not_ordered_yet']) . "') AS '" . mysql_escape_string($mod_txt['shop_ordered']) . "',
			IF(ordered<2,CONCAT('<a href=\"JavaScript:mod_askhref(\\'\\', \\'" . mysql_escape_string($data->defaultlink) . "&mod_shop_delete_cart$data->dwInstance=', `$esGroup`.id, '\\');\">" . mysql_escape_string($mod_txt['edit_delete']) . "</a>'),'') AS '" . mysql_escape_string($mod_txt['edit_functions']) . "'
		FROM
			`$esGroup`
		LEFT JOIN `$esList`
			ON `$esList`.group_id = `$esGroup`.id
		WHERE
			user_id = $userdata[id] AND `$esList`.id IS NOT NULL
		GROUP BY
			`$esGroup`.id 
		ORDER BY
			timestamp DESC";
	CreateTableA(array('data' => $query, 'title' => $mod_txt['shop_carts'], 'width' => '100%'));
	if (isset($_REQUEST["mod_shop_select_cart$data->dwInstance"]))
	{
		echo '<br><br>';
		$query = "SELECT ordered FROM `$esGroup` WHERE id = $data->esGroupid";
		$fixprices = ($ordered = mysql_result(mod_mysql_querya($query, $data->sql), 0)) ? -1 : false;
		$data->displayType = 1;
		$data->defaultlink .= "&mod_shop_select_cart$data->dwInstance=$data->esGroupid";
		echo mod_showItemList($data, 1, $fixprices, false, true);
		if ($ordered >= 2)
		{
			echo "<input type='button' onClick='document.location.href=\"" . htmlspecialchars(AddSlashes($data->defaultlink . $data->urlitemlink . '&mod_shop_pay=1&mod_shop_reorder=1')) . "\";' value='$mod_txt[shop_reorder]'>";
		}
	}
}

function mod_shopItemList_callback($table)
{
	global $mod_shopItemList_callback_val, $mod_txt;
	$data = $mod_shopItemList_callback_val;

	if (!$data->shop_enabled) return('');

	foreach ($table as $item)
	{
		$data->dwPricesum += $item[$mod_txt['shop_price']][1];
	}

	$esShipping = mysql_escape_string($data->shipping_table);
	$esGroup = mysql_escape_string($data->item_group_table);

	$query = "SELECT * FROM `$esGroup` WHERE id = $data->esGroupid";
	$tmp_cart = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));

	$query = "SELECT * FROM `$esShipping` WHERE id = $tmp_cart[shipping_type_id]";
	$result = mod_mysql_querya($query, $data->sql);
	if (mysql_num_rows($result) == 0)
	{
		$query = "SELECT * FROM `$esShipping` LIMIT 1";
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result) == 0) trigger_error('No shipping type exists', E_USER_ERROR);
		$update_shipping_id = true;
	}
	$tmp_shipping = mysql_fetch_assoc($result);
	if ($tmp_cart['ordered'] < 2 && isset($update_shipping_id))
	{
		$query = "UPDATE `$esGroup` SET shipping_type_id = $tmp_shipping[id] WHERE id = $data->esGroupid";
		mod_mysql_querya($query, $data->sql);
		$tmp_cart['shipping_type_id'] = $tmp_shipping['id'];
	}

	if (count($table))
	{
		$tmptable = $table[0];
		foreach ($tmptable as &$ref_tmpval) $ref_tmpval = '';

		if ($tmp_cart['ordered'] >= 2 || $data->fixprices)
		{
			$shipping_selA = $tmp_shipping['name'];
		}
		else
		{
			$shipping_sel = new selectparam;
			$shipping_sel->data = "SELECT id, CONCAT(name, ' (', IF(free > 0 AND free <= $data->dwPricesum,0,price), ' )') AS name FROM `$esShipping` ORDER BY name ASC";
			$shipping_sel->default = $tmp_cart['shipping_type_id'];
			$shipping_sel->defaultlink = $data->defaultlink;
			$shipping_selA = CreateSelectParam($shipping_sel);
			if ($tmp_cart['shipping_type_id'] != $shipping_sel->default)
			{
				$query = "SELECT * FROM `$esShipping` WHERE id = " . intval($shipping_sel->default);
				$tmp_shipping = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));
			}
		}

		$table[] = array_merge($tmptable, array($data->insertcosts => "$mod_txt[shop_shipping_costs]: $shipping_selA", $mod_txt['shop_price'] => '<p align=right>' . str_replace('.', ',', sprintf("%01.2f", ($shipping_costs = ($tmp_shipping['free'] > 0 && $tmp_shipping['free'] <= $data->dwPricesum && $data->dwPricesum != 0 ? 0 : $tmp_shipping['price'])))) . '&nbsp;</p>'));
		$data->dwPricesum += $shipping_costs;
		$table[] = array_merge($tmptable, array($data->insertcosts => "$mod_txt[shop_mwst]", $mod_txt['shop_price'] => '<p align=right>' . str_replace('.', ',', round($data->dwPricesum * 19 / 119, 2)) . "&nbsp;</p>"));
		$table[] = array_merge($tmptable, array($data->insertcosts => "<b>$mod_txt[shop_fullprice]</b>", $mod_txt['shop_price'] => "<p align=right><b>" . str_replace('.', ',', sprintf("%01.2f", $data->dwPricesum)) . "&nbsp;</b></p>"));
	}

	return($table);
}

function mod_resetItemPrices($data)
{
	$esList = mysql_escape_string($data->item_list_table);
	$esGroup = mysql_escape_string($data->item_group_table);

	$query = "SELECT ordered FROM `$esGroup` WHERE id = $data->esGroupid";
	if (mysql_result(mod_mysql_querya($query, $data->sql), 0) < 2)
	{
		$query = "UPDATE `$esList` SET price = NULL WHERE group_id = $data->esGroupid";
		mod_mysql_querya($query, $data->sql);
		$query = "UPDATE `$esGroup` SET ordered = 0 WHERE id = $data->esGroupid";
		mod_mysql_querya($query, $data->sql);
	}
}

function mod_showItemList(&$data, $type = 1, $fixprices = false, $esGroupid = false, $extTitle = false) //Cart
{
	global $mod_txt, $userdata, $mod_shopItemList_callback_val;

	if (!$data->shop_enabled) return('');

	if ($esGroupid === false) $esGroupid = $data->esGroupid;

	$esGroup = mysql_escape_string($data->item_group_table);

	if (!is_array($data->item_select)) $data->item_select = array($data->item_select, $data->item_select);
	if ($esGroupid === false || $data->dwInstance === false) trigger_error('Error', E_USER_ERROR);
	$esItems = mysql_escape_string($data->item_table);
	$esList = mysql_escape_string($data->item_list_table);
	$esPrices = mysql_escape_string($data->prices_table);

	$pricesel = array($data->pricegroups ? "MIN(`$esPrices`.price)" : "`$esItems`.price", "`$esList`.price");
		
	$selects = array();
	$selects[] = $data->item_select[$type];

	if ($type != 1) $fixprices = false;

	$joinprices = "LEFT JOIN `$esPrices` ON `$esPrices`.article_id = `$esList`.item_id AND `$esPrices`.group_id IN (" . implode(',', $userdata['groups']) . ")";

	$query = "SELECT * FROM `$esGroup` WHERE id = $esGroupid";
	$result = mod_mysql_querya($query, $data->sql);
	if (mysql_num_rows($result) == 0) trigger_error('Cart does not exist', E_USER_ERROR);
	$tmp_cart = mysql_fetch_assoc($result);

	if ($tmp_cart['ordered'] < 2)
	{
		$query = "SELECT `$esList`.id, $pricesel[0] AS price FROM `$esList` $joinprices WHERE `$esList`.group_id = $esGroupid GROUP BY `$esList`.item_id";
		$result = mod_mysql_querya($query, $data->sql);
		while ($tmp = mysql_fetch_assoc($result))
		{
			if ($tmp['price'] == 0)
			{
				$query = "DELETE FROM `$esList` WHERE id = $tmp[id]";
				mod_mysql_querya($query, $data->sql);
			}
			else if ($fixprices === true)
			{
				$query = "UPDATE `$esList` SET price = $tmp[price] WHERE id = $tmp[id]";
					mod_mysql_querya($query, $data->sql);
			}
		}
		if ($fixprices === true)
		{
			$query = "UPDATE `$esGroup` SET ordered = 1 WHERE id = $esGroupid";
			mod_mysql_querya($query, $data->sql);
			$tmp_cart['ordered'] = 1;
		}
		if (!isset($_REQUEST['mod_shop_pay'])) mod_resetItemPrices($data);
	}

	$priceuse = intval($tmp_cart['ordered'] != 0);

	$query = "SELECT COUNT(*) FROM `$esList` WHERE group_id = $esGroupid";
	$data->dwItemcount = mysql_result(mod_mysql_querya($query, $data->sql), 0);

	if ($data->dwItemcount)
	{
		$ops = array();
		$ops[] = "'<input style=\"width:30px;\" value=\"', `$esList`.amount, '\" onChange=\"document.location.href=\\'" . mysql_escape_string(htmlspecialchars(AddSlashes($data->defaultlink))) . "&mod_change_item$data->dwInstance=', `$esList`.id, '&mod_change_item_count=\\' + this.value;\">'";
		if ($data->displayType === false) $ops[count($ops) - 1] = 'CONCAT(' . $ops[count($ops) - 1] . ") AS changeamount";

		$ops2 = array('increase' => 'plus', 'decrease' => 'minus', 'del' => 'remove');
		foreach ($ops2 as $link => $var)
		{
			$ops[] = "'<a href=\"$data->defaultlink&mod_change_item$data->dwInstance=', `$esList`.id, '&mod_item_$link=1\">" . mysql_escape_string($mod_txt["shop_$var"]) . "</a>'";
			if ($data->displayType === false) $ops[count($ops) - 1] = 'CONCAT(' . $ops[count($ops) - 1] . ") AS $link";
		}

		if ($data->displayType === false)
		{
			$selects[] = "`$esList`.amount";
			$selects = array_merge($selects, $ops);
			$selects[] = "`$esItems`.*";
			$selects[] = "REPLACE(ROUND($pricesel[$priceuse], 2), '.', ',') AS price";
		}
		else
		{
			$a = "CONCAT(`$esList`.amount, '&nbsp;x&nbsp;', REPLACE(ROUND($pricesel[$priceuse], 2), '.', ','), '&nbsp;')";
			
			if ($type)
			{
				$b = 'CONCAT("<td width=30>",' . implode($ops, ',"</td><td width=10>",') . ',"</td>")';
				$selects[] = "CONCAT('<table cellspacing=0 cellpadding=3 width=100%><tr>" . ($fixprices ?
					("<td align=right>', $a, '</td>'") :
					("', $b,'</td><td align=right style=\"padding-left:10px;\"><td align=right>', $a, '</td>'")) . ", '</tr></table>') AS '" . mysql_escape_string($mod_txt['shop_price']) . "'";
			}
			else
			{
				$b = 'CONCAT(' . implode(',"&nbsp;",', $ops) . ")";
				$selects[] = "$b AS '!'";
				$selects[] = "$a AS '" . mysql_escape_string($mod_txt['shop_price']) . "'";
			}
			$selects[] = "`$esList`.amount * $pricesel[$priceuse] AS `sort_" . mysql_escape_string($mod_txt['shop_price']) . '`';
		}
	}

	$query = "SELECT " . implode(',', $selects) . " FROM `$esList` " . ($fixprices ? '' : $joinprices) . " LEFT JOIN `$esItems` ON `$esItems`.id = `$esList`.item_id WHERE `$esList`.group_id = $esGroupid GROUP BY `$esItems`.id";

	$data->dwPricesum = (double) 0;
	if ($data->displayType === false)
	{
		$retVal = mod_Query2Array($query, $data->sql);
		foreach ($retVal as $item)
		{
			$data->dwPricesum += (double) $item['price'] * $item['amount'];
		}
	}
	else
	{
		if ($type)
		{
			$table = new table;
			$table->data = $query;
			$table->sql = $data->sql;

			$table->title = $mod_txt['shop_items'];
			if ($extTitle)
			{
				if ($tmp_cart['ordered'] >= 2)
				{
					$table->title .= ' &nbsp; - &nbsp; ' . $mod_txt['shop_ordered_at'] . ': ' . date('j.n.Y G:i', $tmp_cart['ordered_at']);
				}
				if ($tmp_cart['ordered'] >= 4)
				{
					$table->title .= ' &nbsp; - &nbsp; ' . $mod_txt['shop_shipped_at'] . ': ' . date('j.n.Y G:i', $tmp_cart['ordered']);
				}
			}

			$table->width = '100%';
			$mod_shopItemList_callback_val = $data;
			$mod_shopItemList_callback_val->fixprices = $fixprices;
			$table->callback = 'mod_shopItemList_callback';

			mod_doDefaults($table, $data->tabledata, true);
			$table->colWidths[$mod_txt['shop_price']] = '210';
			$table->colWidths[$mod_txt['shop_desc_image']] = '60';
			$retVal = CreateTable($table);

			$table_data = count($table->data);
		}
		else
		{
			$table = mod_Query2Array($query, $data->sql, false, MYSQL_ASSOC);
			$table_data = count($table);

			$table2 = array();
			foreach ($table as $col)
			{
				$newcol = array();
				foreach ($col as $index => $val)
				{
					if ($index != '!' && $index != $mod_txt['shop_price'] && $index != 'sort_' . $mod_txt['shop_price'])
					{
						$newcol[] = "<td" . (count($col) - 4 > count($newcol) ? ' width=1' : '') . ">$val</td>";
					}
				}
				$newcol = '<tr>' . implode('', $newcol) . '</tr><tr><td colspan=' . (count($col) - 2) . "><table width=100% cellpadding=0 cellspacing=0 style='font-size:10px;'><tr><td>" . $col['!'] . "</td><td align=right><b>" . $col[$mod_txt['shop_price']] . '</b></td></tr></table><hr></td></tr>';

				$table2[] = $newcol;
				$data->dwPricesum += (double) $col['sort_' . $mod_txt['shop_price']];
			}
			$retVal = "<table width=100% style='font-size:10px;'>" . implode('', $table2) . '</table>';
		}

		if ($table_data == 0)
		{
			$retVal .= $mod_txt['shop_empty_cart'];
		}
		else
		{
			if ($type)
			{

			}
			else
			{
				$retVal .= "<table width=100% cellspacing=0><tr><td align=right style='font-size:12px;font-weight:bold;'>$mod_txt[shop_fullprice]: <u>$data->dwPricesum </u></td></tr></table><center><a href='$data->defaultlink$data->urlitemlink&mod_shop_cart=1'>$mod_txt[shop_cart]</a> - <a href='$data->defaultlink$data->urlitemlink&mod_shop_pay=1'>$mod_txt[shop_pay]</a></center>";
			}
		}
	}
	return($retVal);
}

$mod_dwShopInstance = 0;
function CreateItemList(&$data) //Init
{
	global $session, $userdata, $mod_dwShopInstance, $mod_txt;

	mod_doDefaults($data);
	checkTable('item_groups', $data->item_group_table);
	checkTable('item_lists', $data->item_list_table);
	checkTable('article_prices', $data->prices_table);
	checkTable('adress', $data->adress_table);
	checkTable('name', $data->adress_table);
	checkTable('shop_adress', $data->adress_table);
	checkTable('contact', $data->contact_table);
	checkTable('shop_contact', $data->contact_table);

	if ($data->item_table === false) trigger_error('No table name given', E_USER_ERROR);

	$esItems = mysql_escape_string($data->item_table);
	$esGroup = mysql_escape_string($data->item_group_table);
	$esList = mysql_escape_string($data->item_list_table);

	$data->defaultlink .= mod_autoindexlink('mod_articleid');

	if (strpos($data->image_file, '?') === false) $data->image_file .= '?';
	if ($data->item_select === false) $data->item_select = array(
		'CONCAT(\'<img height=30 src=\"' . mysql_escape_string($data->image_file) . '&img_id=\', `' . $esItems . '`.id, \'\">\') AS `' . mysql_escape_string($mod_txt['shop_desc_image']) . '`, CONCAT("<a href=\'' . mysql_escape_string($data->defaultlink . $data->urlarticlelink) . '&setmod_articleid=", `' . $esItems . '`.id, "\'>", IF(LENGTH(name)>28,CONCAT(SUBSTRING(name, 1, 25), "..."), name), "</a>") AS `' . mysql_escape_string($mod_txt['shop_article']) . '`',
		'artnmr AS `' . mysql_escape_string($mod_txt['shop_desc_nmr']) . '`, CONCAT("<a href=\'' . mysql_escape_string($data->defaultlink . $data->urlarticlelink) . '&setmod_articleid=", `' . $esItems . '`.id, "\'>", name, " - ", artkurz, "</a>") AS `' . mysql_escape_string($mod_txt['shop_article']) . '`, CONCAT(\'<img src=\"' . mysql_escape_string($data->image_file) . '&img_id=\', articles.id, \'\" width=60>\') AS `' . mysql_escape_string($mod_txt['shop_desc_image']) . '`'
	);
	if ($data->insertcosts === false) $data->insertcosts = mysql_escape_string($mod_txt['shop_article']);

	if (!$data->shop_enabled) return(array());

	if (isset($_REQUEST["mod_shop_new_cart$mod_dwShopInstance"]))
	{
		if (isset($session["mod_shop_group$mod_dwShopInstance"])) unset($session["mod_shop_group$mod_dwShopInstance"]);
	}
	else if (isset($_REQUEST["mod_shop_select_cart$mod_dwShopInstance"]))
	{
		$query = "SELECT * FROM `$esGroup` WHERE id = " . ($newgroupid = intval($_REQUEST["mod_shop_select_cart$mod_dwShopInstance"]));
		if (mysql_num_rows($result = mod_mysql_querya($query, $data->sql)) && ($tmp = mysql_fetch_assoc($result)) !== false && $tmp['user_id'] == $userdata['id'])
		{
			$session["mod_shop_group$mod_dwShopInstance"] = $newgroupid;
		}
	}

	if (isset($session["mod_shop_group$mod_dwShopInstance"]))
	{
		$esGroupid = intval($session["mod_shop_group$mod_dwShopInstance"]);
		$query = "SELECT user_id FROM `$esGroup` WHERE id = $esGroupid";
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result) == 0 || (($tmpuser = mysql_result($result, 0)) && $tmpuser != $userdata['id']))
		{
			unset($session["mod_shop_group$mod_dwShopInstance"]);
		}
		else
		{
			$query = "UPDATE `$esGroup` SET user_id = $userdata[id], adress_id = 0 WHERE id = $esGroupid AND ordered < 2";
			mod_mysql_querya($query, $data->sql);
		}
	}

	if (!isset($session["mod_shop_group$mod_dwShopInstance"]))
	{
		$query = "INSERT INTO `$esGroup` (user_id, timestamp) VALUES ($userdata[id], " . time() . ")";
		mod_mysql_querya($query, $data->sql);
		$esGroupid = mysql_insert_id($data->sql);
	}

	$query = "SELECT `$esGroup`.id FROM `$esGroup` LEFT JOIN `$esList` ON `$esList`.group_id = `$esGroup`.id WHERE `$esGroup`.user_id = $userdata[id] AND $userdata[id] > 0 AND `$esGroup`.id != $esGroupid AND `$esList`.id IS NULL";
	$ids = mod_Query2Array($query, $data->sql, 0);
	if (count($ids))
	{
		$query = "DELETE FROM `$esGroup` WHERE id IN (" . implode(',', $ids) . ')';
		mod_mysql_querya($query, $data->sql);
	}
	mod_mysql_querya($query, $data->sql);

	if ($data->add_html === false) $data->add_html = $mod_txt[$data->add_type === false ? 'shop_add_button' : 'shop_add'];
	if ($data->add_type === 1) $data->add_html = '<img src="$data->add_html" border=0>';

	if (isset($_REQUEST["mod_add_item$mod_dwShopInstance"]) || isset($_REQUEST["mod_change_item$mod_dwShopInstance"]) || isset($_REQUEST['mod_shop_reorder']))
	{
		$query = "SELECT ordered FROM `$esGroup` WHERE id = $esGroupid";
		if (mysql_result(mod_mysql_querya($query, $data->sql), 0) >= 2)
		{
			$data->esGroupid = $esGroupid = mod_CopyTableEntry($data->item_group_table, $esGroupid, $data->sql, array('ordered' => 0, 'ordered_at' => 0, 'adress_id' => 0, 'delivery_adress' => 0), array($data->item_list_table => 'group_id'));
			mod_resetItemPrices($data);
			if (isset($_REQUEST["mod_change_item$mod_dwShopInstance"]))
			{
				$query = "SELECT item_id FROM `$esList` WHERE id = " . intval($_REQUEST["mod_change_item$mod_dwShopInstance"]);
				$result = mod_mysql_querya($query, $data->sql);
				if (mysql_num_rows($result))
				{
					$query = "SELECT id FROM `$esList` WHERE group_id = $esGroupid AND item_id = " . mysql_result($result, 0);
					$result = mod_mysql_querya($query, $data->sql);
					if (mysql_num_rows($result))
					{
						$_REQUEST["mod_change_item$mod_dwShopInstance"] = mysql_result($result, 0);
					}
				}
				
				if (mysql_num_rows($result) == 0)
				{
					unset($_REQUEST["mod_change_item$mod_dwShopInstance"]);
				}
			}
		}
	}

	$session["mod_shop_group$mod_dwShopInstance"] = $data->esGroupid = $esGroupid;

	if (isset($_REQUEST["mod_add_item$mod_dwShopInstance"]) && isset($_REQUEST['mod_add_item_count']) && ($addcount = intval($_REQUEST['mod_add_item_count'])) > 0)
	{
		$query = "SELECT COUNT(*) FROM `$esItems` WHERE id = " . ($addid = intval($_REQUEST["mod_add_item$mod_dwShopInstance"]));
		if (mysql_result(mod_mysql_querya($query, $data->sql), 0))
		{
			$query = "SELECT id FROM `$esList` WHERE item_id = $addid AND group_id = $esGroupid";
			$result = mod_mysql_querya($query, $data->sql);
			if (mysql_num_rows($result))
			{
				$query = "UPDATE `$esList` SET amount = amount + $addcount WHERE id = " . mysql_result($result, 0);
			}
			else
			{
				$query = "INSERT INTO `$esList` (item_id, group_id, amount) VALUES ($addid, $esGroupid, $addcount)";
			}
			mod_mysql_querya($query, $data->sql);
			$query = "UPDATE `$esGroup` SET timestamp = " . time() . " WHERE id = $esGroupid";
			mod_mysql_querya($query, $data->sql);
			mod_redir_changes(array('mod_add_item_count', "mod_add_item$mod_dwShopInstance"));
		}
	}

	if (isset($_REQUEST["mod_change_item$mod_dwShopInstance"]) && ($changeitem = intval($_REQUEST["mod_change_item$mod_dwShopInstance"])) > 0)
	{
		$query = "SELECT amount, group_id FROM `$esList` WHERE id = $changeitem";
		if (mysql_num_rows($result = mod_mysql_querya($query, $data->sql)) && ($tmp = mysql_fetch_assoc($result)) !== false && $tmp['group_id'] = $esGroupid)
		{
			$amount = $tmp['amount'];
			unset($query);
			if (isset($_REQUEST['mod_item_del']) || (isset($_REQUEST['mod_item_decrease']) && $amount == 1))
			{
				$query = "DELETE FROM `$esList`";
			}
			else if (isset($_REQUEST['mod_item_increase']) || isset($_REQUEST['mod_item_decrease']))
			{
				$query = "UPDATE `$esList` SET amount = amount " . (isset($_REQUEST['mod_item_increase']) ? '+' : '-') . " 1";
			}
			else if (isset($_REQUEST['mod_change_item_count']) && ($newamount = intval($_REQUEST['mod_change_item_count'])) > 0)
			{
				$query = "UPDATE `$esList` SET amount = $newamount";
			}
			if (isset($query))
			{
				mod_resetItemPrices($data);
				mod_mysql_querya($query . " WHERE id = $changeitem", $data->sql);
				$query = "UPDATE `$esGroup` SET timestamp = " . time() . " WHERE id = $esGroupid";
				mod_mysql_querya($query, $data->sql);
				mod_redir_changes(array('mod_item_increase', 'mod_item_decrease', 'mod_item_del', 'mod_change_item_count', "mod_change_item$mod_dwShopInstance"));
			}
		}
	}

	if ($data->add_multi)
	{
		$data->add_item_link = mod_linkToForm($data->defaultlink);
		$data->add_item_link .= "<input type='hidden' name='mod_add_item$mod_dwShopInstance' value='[ID]'><input name='mod_add_item_count' value='1' type='text' size='3'> ";
		$data->add_item_link .= $data->add_type ? "<span onClick='this.parentNode.submit();'>$data->add_html</span>" : "<input type='submit' value='$data->add_html'>";

		$data->add_item_link .= '</form>';
	}
	else
	{
		$data->add_item_link = "$data->defaultlink&mod_add_item_count=1&mod_add_item$mod_dwShopInstance=[ID]";

		if ($data->add_type) $data->add_item_link = "<a href='$data->add_item_link'>$data->add_html</a>";
		else if ($data->add_type === false) $data->add_item_link = "<input type='button' value='$data->add_html' onClick='document.location.href=\"" . htmlspecialchars(AddSlashes($data->add_item_link)) . "\";'>";
	}

	$data->dwInstance = $mod_dwShopInstance;
	$mod_dwShopInstance++;

	return(mod_showItemList($data, 0));
}

function mod_delete_delivery_adress_callback($id)
{
	global $mod_delete_delivery_adress_callback_val;
	$data = $mod_delete_delivery_adress_callback_val;

	$esAdress = mysql_escape_string($data->adress_table);

	$query = "UPDATE `$esAdress` SET user_id = 0 WHERE id = $id";
	mod_mysql_querya($query, $data->sql);

	return(-1);
}

function mod_deliveryAdresses($data)
{
	global $userdata, $user, $mod_txt, $mod_delete_delivery_adress_callback_val;
	if (!$userdata['id']) return;
	$edit = new sqledit;
	$edit->sqltablename = $data->adress_table;
	$edit->sortable = false;
	$edit->adddefaults['user_id'] = $userdata['id'];
	$edit->sqlwhere = '';
	$edit->relations = $user->relations;
	foreach ($edit->relations as $index => $val) if (isset($val['subtable']) && $val['subtable'] == $data->adress_table) unset($edit->relations[$index]['subtable']);
	foreach ($edit->relations as $index => $val) if (isset($val['subtable']) && $val['subtable'] == $data->contact_table) unset($edit->relations[$index]);
	$edit->title = $mod_txt['shop_delivery_adresses'];
	$edit->name = $mod_txt['shop_delivery_adress'];
	$edit->defaultlink = $data->defaultlink;
	$edit->deletecallback = 'mod_delete_delivery_adress_callback';
	$mod_delete_delivery_adress_callback_val = $data;
	$edit->sql = $data->sql;
	CreateSqlEdit($edit);
	
}

function mod_showAccount($data)
{
	if (!$data->shop_enabled) return;

	mod_showItemLists($data);
	if (!isset($_REQUEST["mod_shop_select_cart$data->dwInstance"]))
	{
		echo '<br><hr><br>';
		mod_deliveryAdresses($data);
	}
}

function CreateShopMenu(&$data)
{
	global $mod_txt, $modules_defaults;

	mod_doDefaults($data);

	if ($data->shophtml === false)
	{
		$tmparray1 = $tmparray2 = array();
		for ($i = 0;$i < 3;$i++)
		{
			$tmparray1[] = $mod_txt["shop_menu_$i"] . (($tmpval = ($data->shophtmlclass === false || (!is_array($data->shophtmlclass) && $i != 2))) ? '' : ('<font class="' . (is_array($data->shophtmlclass) ? $data->shophtmlclass[$i] : $data->shophtmlclass) . '">'));
			$tmparray2[] = ($tmpval ? '' : '</font>') . '</div>';
		}

		$data->shophtml = array(
			array('<div [JAVA]>', '<div [JAVA]>', '<div [JAVA]>'),
			$tmparray1,
			$tmparray2
		);
	}

	checkTable('menu', $data->category_table);
	checkTable('category_link', $data->category_link_table);
	$categories = new menu;
	$categories->table = $data->category_table;
	$categories->html = $data->shophtml;
	$categories->preurlopt = $data->categoryeditpreurlopt;

	if ($data->category_java)
	{
		if ($categories->javamenu = isset($_REQUEST['mod_java']) && $_REQUEST['mod_java'])
		{
			$categories->javasql = 'SELECT IF(COUNT(*)>0,0,1) FROM ' . mysql_escape_string($data->category_link_table) . ' WHERE category_id = [ID]';
		}
	}
	else
	{
		$categories->javamenu = $categories->javasql = false;
	}
	mod_doDefaults($categories, $data->categorydefaultdata, true);
	$retVal = CreateMenu($categories, -1, 0, false, true);
	$data->category_id = $categories->target_id;
	$data->defaultlink .= $categories->addlink;
	$data->mod_categoryset = substr($categories->addlink, 1, strpos($categories->addlink, '=') - 1);
	if ($data->exportdefaultlink) $modules_defaults['defaultlink'] .= $categories->addlink;
	return($retVal);
}

function mod_CreateArticleList_deletecallback($id)
{
	global $mod_CreateArticleList_callbackval;

	$query = "DELETE FROM `" . mysql_escape_string($mod_CreateArticleList_callbackval->category_link_table) . "` WHERE article_id = $id";
	mod_mysql_querya($query, $mod_CreateArticleList_callbackval->sql);
}

function mod_CreateArticleList_copycallback($id)
{
	global $mod_CreateArticleList_callbackval, $mod_txt;
	$esTable = mysql_escape_string($mod_CreateArticleList_callbackval->category_link_table);
	$esArticleTable = mysql_escape_string($mod_CreateArticleList_callbackval->item_table);

	$query = "SELECT category_id FROM `$esTable` WHERE article_id = $id";
	$result = mod_mysql_querya($query, $mod_CreateArticleList_callbackval->sql);
	while ($tmp = mysql_fetch_assoc($result))
	{
		$query = "SELECT IFNULL(MAX(sort), 0) + 1 FROM `$esTable` WHERE category_id = $tmp[category_id]";
		$newsort = mysql_result(mod_mysql_querya($query, $mod_CreateArticleList_callbackval->sql), 0);

		$query = "UPDATE `$esTable` SET sort = $newsort WHERE category_id = $tmp[category_id] AND article_id = $id";
		mod_mysql_querya($query, $mod_CreateArticleList_callbackval->sql);

	}
	$query = "UPDATE `$esArticleTable` SET artnmr = CONCAT('<font style=\"color:red;\">" . mysql_escape_string($mod_txt['shop_id_twice']) . "</font> ', artnmr) WHERE id = $id";
	mod_mysql_querya($query, $mod_CreateArticleList_callbackval->sql);
}

function CreateArticleList($data, $useQuery = false, $allowedit = true) //Articles in Categories
{
	global $mod_txt, $userdata, $mod_CreateArticleList_callbackval, $dwEditInstance;

	mod_doDefaults($data);

	$articleQuery = array();
	$sreplace1 = $sreplace2 = '';

	$edit = new sqledit;
	$edit->sortable = false;
	$edit->defaultlink = $data->defaultlink;
	$edit->sql = $data->sql;
	$edit->addable = false;
	$edit->tabledata['vHighlight'] = 0;
	$edit->copyable = array(array(), array('image' => ''));

	checkTable('category_link', $data->category_link_table);
	checkTable('articles', $data->item_table);
	checkTable('article_links', $data->link_table);
	checkTable('article_prices', $data->prices_table);
	$esItems = mysql_escape_string($data->item_table);
	$esLink = mysql_escape_string($data->category_link_table);
	$esLinks = mysql_escape_string($data->link_table);
	$esCategories = mysql_escape_string($data->category_table);
	$esPrice = mysql_escape_string($data->prices_table);

	if ($useQuery !== false)
	{
		$articleQuery = $useQuery[0];
		$menuname = $useQuery[1];
		if (isset($useQuery[2]))
		{
			$additionalCol = $useQuery[2];
			if (!is_array($additionalCol)) $additionalCol = array($additionalCol);
		}
		if (!is_array($articleQuery))
		{
			$articleQuery = array($articleQuery);
			$menuname = array($menuname);
			if (isset($additionalCol)) $additionalCol = array($additionalCol);
		}
	}
	else if ($data->adminmode && isset($_REQUEST['mod_shop_editmissing']) && $_REQUEST['mod_shop_editmissing'])
	{
		$articleQuery[] = "FROM articles LEFT JOIN menu_article_trans ON menu_article_trans.article_id = articles.id WHERE menu_article_trans.id IS NULL GROUP BY articles.id";
		$menuname[] = $mod_txt['lost_articles'];
		$edit->defaultlink .= '&mod_shop_editmissing=1';
	}
	else if ($data->usershopselect !== false)
	{
		if (!is_array($data->usershopselect)) $data->usershopselect = array('sql' => $data->usershopselect);
		$articleQuery[] = $data->usershopselect['sql'];
		$menuname[] = isset($data->usershopselect['title']) ? $data->usershopselect['title'] : false;
	}
	else if (isset($_REQUEST['mod_shop_search']) && $_REQUEST['mod_shop_search'] != '')
	{
		$searchs = explode(' ', $_REQUEST['mod_shop_search']);
		$searcha = array();
		foreach($searchs as $search)
		{
			$searcha[] = '(INSTR(name, "' . mysql_escape_string($search) . '") OR INSTR(artkurz, "' . mysql_escape_string($search) . '"))';
			$sreplace1 .= "REPLACE(";
			$sreplace2 .= ", '" . mysql_escape_string($search) . "', '<font color=red style=\"color:red;\">" . mysql_escape_string($search) . "</font>')";
		}
		$articleQuery[0] = "
			FROM
				`$esItems`
			WHERE
		" . implode(' AND ', $searcha) . "OR artnmr = '" . mysql_escape_string($_REQUEST['mod_shop_search']) . "'";

		$linklist = array(0);
		$query = "SELECT id " . $articleQuery[0];
		$result = mod_mysql_querya($query, $data->sql);
		while ($tmp = mysql_fetch_row($result))
		{
			$linklist[] = $tmp[0];
		}

		$linklist2 = array();
		$query = "SELECT `$esItems`.id FROM `$esLinks` LEFT JOIN `$esItems` ON `$esLinks`.article_id = `$esItems`.id OR `$esLinks`.link = `$esItems`.id WHERE (`$esLinks`.link IN (" . implode(',', $linklist) . ") OR `$esLinks`.article_id IN (" . implode(',', $linklist) . ")) AND `$esItems`.id NOT IN (" . implode(',', $linklist) . ") GROUP BY `$esItems`.id";
		$result = mod_mysql_querya($query, $data->sql);
		while ($tmp = mysql_fetch_row($result))
		{
			$linklist2[] = $tmp[0];
		}
		if (count($linklist2))
		{
			$articleQuery[1] = " FROM `$esItems` WHERE `$esItems`.id IN (" . implode(',', $linklist2) . ")";
			$menuname[1] = $mod_txt['shop_accessoires'];
		}
		$menuname[0] = $mod_txt['shop_search'] . ': ' . $_REQUEST['mod_shop_search'];

		$edit->defaultlink .= "&search=$_REQUEST[mod_shop_search]";
	}
	else if ($data->category_id > 0)
	{
		echo '<font class="kat">';
		echo '</font>';

		if (!isset($noarticle))
		{
			echo mod_createDirRoot($data->category_id, $data->category_table, mod_removeURLParam($data->defaultlink, $data->mod_categoryset) . '&' . $data->mod_categoryset . '=', $data->sql, -1,
				"SELECT COUNT(*) FROM `$esLink` WHERE category_id = [ID]");
			$query = "SELECT name FROM `$esCategories` WHERE id = $data->category_id";
			$menuname[0] = mysql_result(mod_mysql_querya($query, $data->sql), 0);

			$articleQuery[0] = "
				FROM
					`$esLink`
				LEFT JOIN
					`$esItems` ON articles.id = `$esLink`.article_id
				WHERE category_id = $data->category_id
				ORDER BY `$esLink`.sort ASC
			";
		}

		$edit->sortable = true;
		$edit->sortablelinktable = $data->category_link_table;
		$edit->sortablelinkdefaults = array('category_id' => $data->category_id, 'article_id' => '[ID]');
		$edit->addable = true;
	}


	if (isset($articleQuery))
	{
		$colWidths = array(mysql_escape_string($mod_txt['shop_desc_image']) => '80', mysql_escape_string($mod_txt['shop_price']) => '120', mysql_escape_string($mod_txt['edit_functions']) => '110');
		$inTds = array(mysql_escape_string($mod_txt['shop_desc_image']) => 'valign=top bgcolor=white align=center', mysql_escape_string($mod_txt['shop_article']) => 'valign=top', mysql_escape_string($mod_txt['shop_price']) => 'align=right');

		foreach ($articleQuery as $index => $artQuery)
		{
			$pricejoin = "LEFT JOIN `$esPrice` ON " . (isset($userdata['groups']) && count($userdata['groups']) ? ("`$esPrice`.group_id IN (" . implode(',', $userdata['groups']) . ") AND `$esPrice`.article_id = articles.id") : 'FALSE');
			$query = "SELECT `$esItems`.id " . str_ireplace('where', "WHERE `$esItems`.id IS NOT NULL AND ", $artQuery);
			$ids = mod_Query2Array($query, $data->sql, 0);
			if (count($ids))
			{
				$linkmenu = new menu;
				$linkmenu->table = $data->category_table;
				$linkmenu->html = array('<option disabled value="[ID]">', '', '</option>');
				$linkmenu->nolinks = true;
				$linkmenu->url = false;
				$linkmenu->sql = $data->sql;
				$linkmenu->prenames = ' -> ';
				$query2 = "SELECT id FROM `$esCategories`";
				$ids2 = mod_Query2Array($query2, $data->sql, 0);
				$tmplinkopts = CreateMenu($linkmenu, -1, 1, $ids2, -1, true, false, false);
				$linkopts2 = str_replace('<option disabled', '<option', implode('', $tmplinkopts));
				$linkopts = array();
				foreach ($tmplinkopts as $id => $option)
				{
					$linkopts[] = str_replace('disabled value', 'disabled novalue', $option);
					$query2 = "SELECT name, article_id FROM `$esLink` LEFT JOIN `$esItems` ON `$esItems`.id = article_id WHERE category_id = $id ORDER BY sort ASC";
					$result2 = mod_mysql_querya($query2, $data->sql);
					while ($tmp2 = mysql_fetch_assoc($result2))
					{
						$linkopts[] = "<option value=\"$tmp2[article_id]\">" . str_repeat('&nbsp;', substr_count($option, '&nbsp;') + 2) . htmlspecialchars($tmp2['name']) . '</option>';
					}
				}
				$linkopts = implode('', $linkopts);

				$groupopts = "SELECT id, name FROM groups";
				$groupopts = mod_createselectoptions($groupopts);

				if (isset($_REQUEST['mod_editarticle'])) $_GET["mod_editsql$dwEditInstance"] = $_POST["mod_editsql$dwEditInstance"] = $_REQUEST["mod_editsql$dwEditInstance"] = $_REQUEST['mod_editarticle'];

				$edit->sqltablename = $data->item_table;
				$edit->title = $menuname[$index];
				$edit->tabledata['colWidths'] = $colWidths;
				$edit->tabledata['inTds'] = $inTds;
				$edit->sqlwhere = 'articles.id IN (' . implode(',', $ids) . ')';
				$edit->name = $mod_txt['shop_article'];
				$edit->autohide = true;
				$edit->sqljoin = $pricejoin;
				$edit->relations = array(
					'mod_info1' => array('type' => 'virtual', 'name' => $mod_txt['shop_desc_image'], 'sql' => "CONCAT('<a href=\"index.php" . mysql_escape_string($data->defaultlink . $data->urlarticlelink) . "&setmod_articleid=', articles.id, '\"><img width=80 border=0 src=\"" . mysql_escape_string($data->image_file) . "&img_id=', articles.id, '\"></a>')"),
					'mod_info2' => array('type' => 'virtual', 'name' => $mod_txt['shop_article'], 'sql' => "CONCAT('<font class=\"artikel\"><a href=\"index.php" . mysql_escape_string($data->defaultlink . $data->urlarticlelink) . "&setmod_articleid=', articles.id, '\"><b>', $sreplace1 articles.name $sreplace2, '</b> (', $sreplace1 articles.artnmr $sreplace2, ')</a></font><br>', " . (isset($montharticle) ? 'month.text' : "$sreplace1 artkurz $sreplace2") . ")"),
					'mod_info4' => array('type' => 'virtual', 'name' => $mod_txt['shop_price'], 'sql' => "IF(`$esPrice`.id IS NULL, 'k.A.', CONCAT('<table cellspacing=0><tr><td valign=top align=right style=\"padding-right:10px;\">', REPLACE(ROUND(MIN(`$esPrice`.price), 2), '.', ','), '&nbsp;</td>" . ($data->shop_enabled ? ("<td valign=top align=right>', REPLACE('" . mysql_escape_string($data->add_item_link) . "', '" . mysql_escape_string('[ID]') . "', articles.id), '</td>") : '') . "</tr></table>'))"),
					'artnmr' => array('name' => $mod_txt['shop_desc_nmr_short'], 'formname' => $mod_txt['shop_desc_nmr'], 'force' => true, 'nodual' => true),
					'name' => array('name' => $mod_txt['shop_desc_name'], 'force' => true, 'nodual' => true),
					'artkurz' => array('name' => $mod_txt['shop_desc_short'], 'force' => true),
					'artlang' => array('name' => $mod_txt['shop_desc_long'], 'type' => 'html', 'rows' => '300', 'htmltoolbar' => true),
					'image' => array('name' => $mod_txt['shop_image'], 'type' => 'file', 'hide' => true, 'storage' => $data->image_folder),
					'topart' => array('name' => 'Topart', 'type' => 'checkbox'),
					'mod_sep1' => array('type' => 'seperator', 'default' => '<hr>'),
					'links' => array('name' => $mod_txt['shop_desc_links'], 'type' => 'multi', 'sqllink' => $data->link_table, 'hide' => true,
						'sqllinkdata' => array('article_id' => '[ID]', 'link' => '[LINK0]', 'name' => '[LINK1]', 'category' => '[LINK2]'),
						'multilink' => true, 'multitextselects' => array(0), 'sqllinknums' => 'sort', 'multitextseperator' => '<br><br>', 'multitextcopy' => true,
						'multitexthtml' => "<select onChange='for(i=0;i<this.childNodes.length;i++)if(this.childNodes[i].value==this.value)this.parentNode.getElementsByTagName(\"INPUT\")[0].value=this.childNodes[i].innerHTML.replace(/.nbsp;/g,\"\");' name=\"[NAME][0]\">$linkopts</select><br>Name: <input name=\"[NAME][1]\" size=30> - Kategorie: <input name=\"[NAME][2]\" size=30>"
					),
					'mod_sep2' => array('type' => 'seperator', 'default' => '<hr>'),
					'categories' => array('name' => $mod_txt['shop_categories'], 'type' => 'multi', 'sqllink' => $data->category_link_table, 'hide' => true, 'sqllinkdata' => array('article_id' => '[ID]', 'category_id' => '[LINK]'),
						'multitextselects' => 1, 'multitexthtml' => "<select name=\"[NAME]\">$linkopts2</select>", 'multitextdefaults' => array($data->category_id)
					),
					'mod_sep3' => array('type' => 'seperator', 'default' => '<hr>'),
					'prices' => array('name' => $mod_txt['shop_desc_prices'], 'type' => 'multi', 'sqllink' => $data->prices_table, 'hide' => true,
						'multilink' => true, 'multitextselects' => array(0), 'sqllinkdata' => array('article_id' => '[ID]', 'group_id' => '[LINK0]', 'price' => '[LINK1]'),
						'multitexthtml' => "<select name=\"[NAME][0]\">$groupopts</select> Preis: <input name=\"[NAME][1]\">",
						'sqllinkcallback' => array(1 => 'mod_check_double')
					)
				);

				if (isset($additionalCol))
				{
					foreach ($additionalCol[$index] as $colindex => $colsql)
					{
						if ($colindex == 'join')
						{
							$edit->sqljoin .= ' ' . $colsql;
						}
						else if ($colindex == 'sort')
						{
							$edit->sortable = $colsql;
						}
						else
						{
							$edit->relations[] = array('name' => $colindex, 'type' => 'virtual', 'sql' => $colsql);
						}
					}
				}

				if ($data->article_table !== false || count($data->articlerelations))
				{
					$edit->relations['mod_sep4'] = array('type' => 'seperator', 'default' => '<hr>');
				}

				if ($data->article_table !== false)
				{
					$edit->relations['table'] = array('name' => $mod_txt['shop_desc_table'], 'type' => 'table', 'tablesqltable' => $data->article_table, 'tableconstants' => array('article_id' => '[ID]'), 'tabletitles' => true);
					$edit->relations['legend'] = array('name' => $mod_txt['shop_desc_legend'], 'type' => 'html', 'rows' => '150');
				}

				if (count($data->articlerelations))
				{
					$edit->relations += $data->articlerelations;
				}
				$edit->admin = $data->adminmode;

				$mod_CreateArticleList_callbackval = $data;
				$edit->deletecallback = 'mod_CreateArticleList_deletecallback';
				$edit->copycallback = 'mod_CreateArticleList_copycallback';

				if (!$allowedit)
				{
					$edit->editable = $edit->copyable = $edit->deleteable = $edit->sortable = $edit->copyable = false;
				}

				if ($data->article_edit_callback !== false)
				{
					mod_call_user_func($data->article_edit_callback, $edit);
				}

				CreateSqlEdit($edit);

				echo '<br>';
			}
		}
	}
}

function mod_payment_switch_delivery_adress($id)
{
	global $mod_ShopPayment_callback_val;
	$data = $mod_ShopPayment_callback_val;

	$esGroup = mysql_escape_string($data->item_group_table);

	$query = "SELECT * FROM `$esGroup` WHERE id = $data->esGroupid";
	$tmp = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));

	if (isset($_REQUEST['mod_shop_delivery_adr']) ^ ($tmp['delivery_adress'] > 0))
	{
		$query = "UPDATE `$esGroup` SET delivery_adress = - $tmp[delivery_adress] WHERE id = $data->esGroupid";
		mod_mysql_querya($query, $data->sql);
		if ($tmp['delivery_adress'] > 0)
		{
			
		}
		else
		{
			$_REQUEST['mod_shop_pay'] = 2;
			if ($tmp['delivery_adress'] < 0)
			{
				unset($_REQUEST['mod_shop_delivery_adr']);
			}
		}
	}
}

function mod_payment_adress_continue($id)
{
	$_REQUEST['mod_shop_pay'] = 3;
	mod_payment_switch_delivery_adress($id);
}

function mod_ShopPayment_callback($id)
{
	global $mod_ShopPayment_callback_val;
	$data = $mod_ShopPayment_callback_val;

	$esGroup = mysql_escape_string($data->item_group_table);

	$query = "UPDATE `$esGroup` SET " . (isset($mod_ShopPayment_callback_val->mod_add_delivery_address) && $mod_ShopPayment_callback_val->mod_add_delivery_address == true ? 'delivery_adress' : 'adress_id') . " = $id WHERE id = $data->esGroupid";
	mod_mysql_querya($query, $data->sql);

	mod_payment_adress_continue($id);
}

function mod_showOrderSumary($data, $adress = false, $esGroupid = false, $admin = false)
{
	global $mod_txt;
	if ($esGroupid === false) $esGroupid = $data->esGroupid;
	$esGroupid = intval($esGroupid);
	if (!mod_checkTableID($data->item_group_table, $esGroupid)) trigger_error('Internal Error, Cart does not exist', E_USER_ERROR);

	$esGroup = mysql_escape_string($data->item_group_table);
	$esList = mysql_escape_string($data->item_list_table);
	$esAdress = mysql_escape_string($data->adress_table);
	$esContact = mysql_escape_string($data->contact_table);
	$esUser = mysql_escape_string($data->user_table);

	$query = "SELECT * FROM `$esGroup` WHERE id = $esGroupid";
	$tmp = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));

	$data->displayType = true;
	echo mod_showItemList($data, 1, -1, $esGroupid, $admin);

	if ($tmp['user_id'])
	{
		$query = "SELECT * FROM `$esUser` WHERE id = $tmp[user_id]";
		$tmp_user = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));
	}

	$query = "SELECT * FROM `$esAdress` LEFT JOIN `$esContact` ON `$esContact`.id = `$esAdress`.contact_id WHERE `$esAdress`.id = " . ($tmp['user_id'] ? $tmp_user['adress_id'] : $tmp['adress_id']);
	$result = mod_mysql_querya($query, $data->sql);
	if (mysql_num_rows($result))
	{
		$adress = mysql_fetch_assoc($result);
	}

	if ($tmp['user_id'])
	{
		$adress['email'] = $tmp_user['email'];
	}

	$adresses = array($adress);
	if ($tmp['delivery_adress'] > 0)
	{
		$query = "SELECT * FROM `$esAdress` WHERE id = $tmp[delivery_adress]";
		$adresses[] = $delivery_adress = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));
	}

	for ($i = 0;$i < count($adresses);$i++)
	{
		$tabledata = array();
		if (!$i && $tmp['user_id'])
		{
			$tabledata[] = array($mod_txt['user_user'], $tmp_user['username']);
		}
		if ($adresses[$i]['company'] != '') $tabledata[] = array($mod_txt['adress_company'], $adresses[$i]['company']);
		$tabledata[] = array($mod_txt['adress_surname'], $adresses[$i]['surname']);
		$tabledata[] = array($mod_txt['adress_forename'], $adresses[$i]['forename']);
		$tabledata[] = array($mod_txt['adress_street'], $adresses[$i]['street']);
		$tabledata[] = array($mod_txt['shop_user_adress'], $adresses[$i]['zip'] . ' ' . $adresses[$i]['city']);
		if (!$i)
		{
			$tabledata[] = array($mod_txt['contact_tel'], $adresses[$i]['tel']);
			$tabledata[] = array($mod_txt['contact_fax'], $adresses[$i]['fax']);
			$tabledata[] = array($mod_txt['contact_mail'], $adresses[$i]['email']);
		}
		CreateTableA(array('data' => $tabledata, 'title' => $mod_txt[count($adresses) ? ($i ? 'shop_delivery_adress' : 'shop_bill_adress') : 'shop_adress'], 'repeatHeader' => -1, 'width' => '100%', 'vHighlight' => 0));
	}

	if (!isset($delivery_adress))
	{
		echo '<center><b>', sprintf($mod_txt['shop_identical_adress'], $mod_txt['shop_delivery_adress'], $mod_txt['shop_bill_adress']), '</center>';
	}
}

function ShopPayment($data)
{
	global $mod_txt, $userdata, $user, $mod_ShopPayment_callback_val, $session, $user;
	if (!$data->shop_enabled) return;

	$esGroup = mysql_escape_string($data->item_group_table);
	$esList = mysql_escape_string($data->item_list_table);
	$esAdress = mysql_escape_string($data->adress_table);
	$esContact = mysql_escape_string($data->contact_table);

	$query = "SELECT * FROM `$esGroup` WHERE id = $data->esGroupid";
	$tmp = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));

	if ($tmp['adress_id'])
	{
		$query = "SELECT COUNT(*) FROM `$esAdress` WHERE id = $tmp[adress_id]";
		if (mysql_result(mod_mysql_querya($query, $data->sql), 0) == 0)
		{
			$tmp['adress_id'] = 0;
			$query = "UPDATE `$esGroup` SET adress_id = 0 WHERE id = $data->esGroupid";
			mod_mysql_querya($query, $data->sql);
		}
	}

	$query = "SELECT COUNT(*) FROM `$esList` WHERE group_id = $tmp[id]";
	$tmp['item_count'] = mysql_result(mod_mysql_querya($query, $data->sql), 0);

	$query = "SELECT * FROM `$esAdress` LEFT JOIN `$esContact` ON `$esContact`.id = `$esAdress`.contact_id WHERE `$esAdress`.id = " . ($userdata['id'] ? $userdata['adress_id'] : $tmp['adress_id']);
	$result = mod_mysql_querya($query, $data->sql);
	if (mysql_num_rows($result))
	{
		$adress = mysql_fetch_assoc($result);
	}

	if (isset($_REQUEST['mod_shop_cart']) && $_REQUEST['mod_shop_cart'])
	{
		$button = "<input type='button' value='$mod_txt[shop_continue]' onClick='document.location.href=\"" . htmlspecialchars(AddSlashes(mod_linkAddParameter($data->defaultlink, 'mod_shop_pay', 2))) . "\";'>";
		$data->defaultlink .= '&mod_shop_cart=1';
		echo mod_showItemList($data, 1, false, false, true);

		if ($tmp['ordered'] < 2 && $tmp['item_count']) echo $button;
	}
	else if (isset($_REQUEST['mod_shop_pay']) && ($tmp['item_count'] || isset($_REQUEST['mod_shop_pay_confirmed'])))
	{
		$_REQUEST['mod_shop_pay'] = intval($_REQUEST['mod_shop_pay']);

		if ($tmp['ordered'] >= 2) $_REQUEST['mod_shop_pay'] = 3;
		else if ($tmp['ordered'] == 0)
		{
			if ($_REQUEST['mod_shop_pay'] > 2 && ($tmp['user_id'] || $tmp['adress_id']))
			{
				$mod_tmp_payment_goto = 3;
				if ($_REQUEST['mod_shop_pay'] == 4) $mod_tmp_payment_goto .= '&mod_tmp_resend_msg=1';
			}
			else if ($_REQUEST['mod_shop_pay'] > 1) $mod_tmp_payment_goto = 2;
			$_REQUEST['mod_shop_pay'] = 1;
		}
		else if ($_REQUEST['mod_shop_pay'] > 1 && $tmp['user_id'] == 0 && $tmp['adress_id'] == 0) $_REQUEST['mod_shop_pay'] = 2;

		if ($tmp['ordered'] < 2 && !isset($_REQUEST['mod_shop_pay_confirmed']))
		{
			echo "<h1>$mod_txt[shop_order]</h1><h2>";
			echo "<a href='$data->defaultlink&mod_shop_pay=1'>$mod_txt[shop_cart]</a>";
			echo " - <a href='$data->defaultlink&mod_shop_pay=2'>$mod_txt[shop_adress]</a>";
			if (isset($adress))
			{
				echo " - <a href='$data->defaultlink&mod_shop_pay=3'>$mod_txt[shop_summary]</a>";
			}
			echo "</h2>";
		}
		else
		{
			echo "<h1>Bestellung vom: " . date('j.n.Y', $tmp['ordered_at']) . '</h1>';
		}
		if (isset($_REQUEST['mod_tmp_resend_msg'])) echo "<font style='color:red;'>$mod_txt[shop_change_alert]</font><br><br>";

		$data->defaultlink .= "&mod_shop_pay=$_REQUEST[mod_shop_pay]";
		switch ($_REQUEST['mod_shop_pay'])
		{
			case 2:
				$mod_ShopPayment_callback_val = $data;
				$inaddform = "<tr><td>&nbsp;</td><td><input type=checkbox name='mod_shop_delivery_adr' " . ($tmp['delivery_adress'] > 0 || isset($_REQUEST['mod_shop_delivery_adr']) ? 'checked' : '') . "> $mod_txt[shop_different_delivery_adress]</td></tr>";

				$edit = new sqledit;
				$edit->relations = $user->relations;
				foreach ($edit->relations as $index => $val) if (isset($val['subtable']) && $val['subtable'] == $data->adress_table) unset($edit->relations[$index]['subtable']);
				$edit->relations['email'] = array('name' => $mod_txt['contact_mail'], 'force' => true, 'subtable' => $data->contact_table);
				$edit->sqltablename = $data->adress_table;
				$edit->sortable = $edit->deleteable = false;
				$edit->showtable = false;
				$edit->mod_txt['edit_title_add'] = '%s';
				$edit->defaultlink = $data->defaultlink . '&mod_shop_userreg=0';
				$edit->mod_txt['edit_title_add'] = '%s';
				$edit->mod_txt['edit_submit_add'] = $mod_txt['shop_continue'];

				$bottomdisplay = '';

				if ($userdata['id'])
				{
					$user->editdata['name'] = 'Benutzerdaten';
					$_REQUEST['mod_editself'] = 1;
					$user->editdata['editcallback'] = 'mod_payment_switch_delivery_adress';
					$user->editdata['inaddform'] = $inaddform;
					$user->editdata['ineditform'] = true;
					$user->defaultlink = $data->defaultlink;

					CreateUserRegister($user);
					if (!isset($_REQUEST['mod_shop_delivery_adr']) && $tmp['delivery_adress'] == 0) $bottomdisplay .= "<input type='button' value='$mod_txt[shop_continue]' onClick='document.location.href=\"" . htmlspecialchars(AddSlashes(mod_linkAddParameter($data->defaultlink, 'mod_shop_pay', 3))) . "\";'>";
				}
				else
				{
					if ($data->ask_adress && !isset($adress) && !isset($_REQUEST['mod_shop_userreg']))
					{
						echo mod_CreateUserLoginForm($data->defaultlink, $user);
						echo "<hr><a href='$data->defaultlink&mod_shop_userreg=1'>$mod_txt[user_reg]</a>";
						echo "<hr><a href='$data->defaultlink&mod_shop_userreg=0'>$mod_txt[shop_noreg]</a>";
					}
					else if (isset($_REQUEST['mod_shop_userreg']) && $_REQUEST['mod_shop_userreg'])
					{
						$user->editdata['mod_txt']['edit_title_add'] = $user->editdata['mod_txt']['edit_title_submit'] = $mod_txt['shop_user_reg'];
						if (isset($adress))
						{
							foreach ($adress as $index => $val)
							{
								if (isset($user->relations[$index])) $user->relations[$index]['default'] = $val;
							}
						}
						$user->defaultlink = $data->defaultlink . "&mod_shop_userreg=1";
						$user->editdata['createcallback'] = 'mod_payment_adress_continue';
						$user->editdata['inaddform'] = $inaddform;
						$user->editdata['ineditform'] = true;
						CreateUserRegister($user);
					}
					else
					{
						$edita = clone $edit;
						$edita->subtables[$data->contact_table] = $user->editdata['subtables'][$data->contact_table];
						unset($edita->subtables[$data->contact_table]['defaults']['email']);
						$edita->name = $mod_txt['shop_bill_adress'];
						$edita->inaddform = $inaddform;
						$edita->ineditform = true;
						if ($tmp['adress_id'] == 0)
						{
							$edita->editable = false;
							$edita->createcallback = 'mod_ShopPayment_callback';
						}
						else
						{
							$edita->forceedit = $tmp['adress_id'];
							$edita->editcallback = 'mod_payment_switch_delivery_adress';
						}
						CreateSqlEdit($edita);
						if ($tmp['adress_id'] != 0 && !isset($_REQUEST['mod_shop_delivery_adr']))
						{
							$bottomdisplay .= "<input type='button' value='$mod_txt[shop_continue]' onClick='document.location.href=\"" . htmlspecialchars(AddSlashes(mod_linkAddParameter($data->defaultlink, 'mod_shop_pay', 3))) . "\";'>";
						}

						$bottomdisplay .= "<hr><a href='$data->defaultlink&mod_shop_userreg=1'>$mod_txt[user_reg]</a>";
					}
				}

				$query = "SELECT * FROM `$esGroup` WHERE id = $data->esGroupid";
				$tmp = array_merge($tmp, mysql_fetch_assoc(mod_mysql_querya($query, $data->sql)));

				if ($tmp['delivery_adress'] > 0 || isset($_REQUEST['mod_shop_delivery_adr']))
				{
					echo '<hr>';
					if ($userdata['id'])
					{
						if ($tmp['delivery_adress'] > 0)
						{
							$midpart = "(SELECT $tmp[delivery_adress] AS id, '- " . mysql_escape_string($mod_txt['shop_current_adress']) . " -' AS Name) UNION ";
						}
						else
						{
							$midpart = '';
						}
						$adrselect = new selectparam;
						$adrselect->data = "$midpart (SELECT 0 AS id, '- " . mysql_escape_string($mod_txt['shop_new_adress']) . " -' AS Name) UNION (SELECT id, CONCAT(street, ' - ', zip, ' ', city) AS Name FROM `$esAdress` WHERE user_id = $userdata[id] AND id != $tmp[delivery_adress]) ORDER BY Name ASC";
						$adrselect->default = $tmp['delivery_adress'];
						$adrselect->defaultlink = $data->defaultlink . '&mod_shop_delivery_adr=1';
						$adrselect->sql = $data->sql;
						$adrselect->name = 'mod_shop_seladr';
						echo $mod_txt['shop_delivery_adresses'], ': ', CreateSelectParam($adrselect), " - <a href='$data->defaultlink$data->urlaccountlink'>" . sprintf($mod_txt['shop_manage'], $mod_txt['shop_delivery_adresses']) . '</a><br><br>';

						if ($tmp['delivery_adress'] != $adrselect->default)
						{
							$tmp['delivery_adress'] = intval($adrselect->default);
							$query = "UPDATE `$esGroup` SET delivery_adress = $tmp[delivery_adress] WHERE id = $data->esGroupid";
							mod_mysql_querya($query, $data->sql);
							mod_redir_changes(array('mod_shop_seladr'));
						}
					}
					$edita = clone $edit;
					$edita->name = $mod_txt['shop_delivery_adress'];
					foreach ($edita->relations as $index => $val) if (isset($val['subtable']) && $val['subtable'] == $data->contact_table) unset($edita->relations[$index]);
					if ($tmp['delivery_adress'] == 0)
					{
						$edita->editable = false;
						$edita->createcallback = 'mod_ShopPayment_callback';
					}
					else
					{
						$edita->forceedit = $tmp['delivery_adress'];
					}
					$edita->inaddform = '<input type=hidden name="mod_shop_delivery_adr" value="on">';
					$mod_ShopPayment_callback_val->mod_add_delivery_address = true;
					CreateSqlEdit($edita);
					$mod_ShopPayment_callback_val->mod_add_delivery_address = false;

					if ($tmp['delivery_adress'] != 0)
					{
						echo "<hr><input type='button' value='$mod_txt[shop_continue]' onClick='document.location.href=\"" . htmlspecialchars(AddSlashes(mod_linkAddParameter($data->defaultlink, 'mod_shop_pay', 3))) . "\";'>";
					}
				}
				echo $bottomdisplay;
				break;

			case 3:
				mod_showOrderSumary($data, $adress);
				if ($tmp['ordered'] < 2)
				{
					echo "<input type='button' value='$mod_txt[shop_confirm_order]' onClick='document.location.href=\"" . htmlspecialchars(AddSlashes(mod_linkAddParameter($data->defaultlink, 'mod_shop_pay', 4))) . "\";'>";
				}

				break;

			case 4:
				$query = "UPDATE `$esGroup` SET ordered = 2, ordered_at = " . time() . " WHERE id = $data->esGroupid";
				mod_mysql_querya($query, $data->sql);
				if ($tmp['delivery_adress'] < 0)
				{
					$query = "UPDATE `$esGroup` SET delivery_adress = 0 WHERE id = $data->esGroupid";
					mod_mysql_querya($query, $data->sql);
					$query = "DELETE FROM `$esAdress` WHERE id = " . (-$tmp['delivery_adress']);
					mod_mysql_querya($query, $data->sql);
				}
				if ($userdata['id'])
				{
					$newid1 = mod_CopyTableEntry($data->adress_table, $userdata['adress_id'], $data->sql, array('contact_id' => 0, 'user_id' => 0));
					if ($tmp['delivery_adress'] > 0)
					{
						$newid2 = mod_CopyTableEntry($data->adress_table, $tmp['delivery_adress'], $data->sql, array('contact_id' => 0, 'user_id' => 0));
					}
					else $newid2 = 0;

					$query = "UPDATE `$esGroup` SET adress_id = $newid1, delivery_adress = $newid2 WHERE id = $data->esGroupid";
					mod_mysql_querya($query, $data->sql);
				}

				unset ($session["mod_shop_group$data->dwInstance"]);
				$_REQUEST['mod_shop_pay'] = 1;
				$_REQUEST['mod_shop_pay_confirmed'] = 1;
				mod_redir_changes(array());
				break;

			default:
				if (isset($_REQUEST['mod_shop_pay_confirmed']))
				{
					echo "<h1>$mod_txt[shop_order_confirmed]</h1>";
				}
				else
				{
					echo mod_showItemList($data, 1, true);

					echo "<input type='button' value='$mod_txt[shop_continue]' onClick='document.location.href=\"" . htmlspecialchars(AddSlashes(mod_linkAddParameter($data->defaultlink, 'mod_shop_pay', 2))) . "\";'>";
				}
				break;
		}

		if (isset($mod_tmp_payment_goto))
		{
			header("location: " . mod_removeURLParam($data->defaultlink, 'mod_shop_pay') . "&mod_shop_pay=$mod_tmp_payment_goto");
			exit;
		}

		if ($tmp['ordered'] >= 2)
		{
			echo "<input type='button' onClick='document.location.href=\"" . htmlspecialchars(AddSlashes(mod_linkAddParameter($data->defaultlink, 'mod_shop_pay', 1) . '&mod_shop_reorder=1')) . "\";' value='$mod_txt[shop_reorder]'>";
		}
	}
}

function mod_ShowArticleCallback($tmp, $return = false)
{
	global $mod_txt;
	if ($tmp['link'] != '') $tmp['link'] = '<hr><br>' . $tmp['link'];

	$retVal = <<<EOT

<table width=100% cellpadding=0 cellspacing=0>
  <tr>
    <td valign=top>
	<table cellpadding=0 cellspacing=0 width=100%>
	  <tr>
	    <td>
		<b><u>$tmp[name]</u>
	    </td>
	    <td align=right>
		Art. Nr. $tmp[artnmr]
	    </td>
	  </tr>
	  <tr>
	    <td colspan=2>
		<table cellpadding=5>
		  <tr>
		    <td align=justify><p align=justify>
			$tmp[artlang]
			<br><br><table><tr><td valign=top><font style='color:red;font-size:16px;font-weight:bold;'>$mod_txt[shop_price]: $tmp[price]</font></td><td valign=top style='padding-left:30px;'>$tmp[cart]</td></tr></table>
			</p>
		    </td>
		  </tr>
		</table>
	    </td>
	  </tr>
	</table>
    </td>
    <td width=10>
	&nbsp;
    </td>
    <td width=250 valign=top align=center>
	$tmp[image]
	<font size=-2 color=#555555>$mod_txt[shop_image_differ]</font>
    </td>
  </tr>
</table>
$tmp[table]
$tmp[link]
$tmp[admin]

EOT;

	if ($return) return($retVal);
	else echo $retVal;
}

function ShowArticle($data)
{
	global $userdata, $mod_txt;
	mod_doDefaults($data);

	checkTable('articles', $data->item_table);
	checkTable('article_links', $data->link_table);
	checkTable('article_prices', $data->prices_table);
	$esItems = mysql_escape_string($data->item_table);
	$esLink = mysql_escape_string($data->category_link_table);
	$esLinks = mysql_escape_string($data->link_table);
	$esPrice = mysql_escape_string($data->prices_table);

	if (isset($_GET['mod_articleid']) && mod_checkTableId($data->item_table, $articleid = intval($_GET['mod_articleid'])))
	{
		$query = "SELECT `$esItems`.*, IF(MIN(`$esPrice`.price) IS NULL, 'k.A.', REPLACE(ROUND(MIN(`$esPrice`.price), 2), '.', ',')) AS price FROM `$esItems` LEFT JOIN `$esPrice` ON " . (isset($userdata['groups']) && count($userdata['groups']) ? ("`$esPrice`.article_id = $articleid AND `$esPrice`.group_id IN (" . implode(',', $userdata['groups']) . ")") : 'FALSE') . " WHERE `$esItems`.id = $articleid GROUP BY `$esItems`.id";
		$tmp_article = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));

		if ($data->link_table !== false)
		{
			$query = "FROM `$esLinks` LEFT JOIN `$esItems` ON `$esLinks`.link = `$esItems`.id WHERE `$esLinks`.article_id = $articleid ORDER BY `$esLinks`.sort ASC";
			if ($data->extendedLinkTable)
			{
				$addCols = array();

				$querytmp = "SELECT COUNT(DISTINCT category) FROM `$esLinks` WHERE article_id = $articleid AND category != ''";
				if (mysql_result(mod_mysql_querya($querytmp, $data->sql), 0))
				{
					$addCols[$mod_txt['shop_categories']] = "`$esLinks`.category";
					$addCols['join'] = "LEFT JOIN `$esLinks` ON `$esItems`.id = `$esLinks`.link";
				}
				ob_start();
				CreateArticleList($data, array($query, $mod_txt['shop_accessoires'], $addCols), false);
				$links = ob_get_clean();
			}
			else
			{
				$query = "SELECT `$esItems`.artnmr, `$esItems`.id, `$esLinks`.name, `$esLinks`.category $query";
				$lastcat = "";
				$result = mod_mysql_querya($query, $data->sql);

				if (mysql_num_rows($result))
				{
					$links = "<br><br><b><u>$mod_txt[shop_accessoires]</u></b><br><table>";
					while ($tmp2 = mysql_fetch_assoc($result))
					{
						$uselinks = 1;
						if ($tmp2['category'] != $lastcat)
						{
							$links .= "<tr><td colspan=2>&nbsp;</td></tr><tr><td colspan=2><b>$tmp2[category]</b></td></tr>";
						}
						$lastcat = $tmp2['category'];
						$links .= "<tr><td>- $tmp2[name]</td><td>&nbsp;&nbsp;&nbsp;<a href='index.php$data->defaultlink&setmod_articleid=$tmp2[id]'>$tmp2[artnmr]</a></td></tr>";
					}
					$links .= "</table>";
				}
			}
			if (isset($links)) $tmp_article['link'] = $links;
		}

		$tmp_article['image'] = "<img src='" . mysql_escape_string($data->image_file) . "&img_id=$tmp_article[id]'>";

		$query = "SELECT category_id FROM `$esLink` WHERE article_id = $tmp_article[id] LIMIT 1";
		$result = mod_mysql_querya($query, $data->sql);
		$articlecat = mysql_num_rows($result) ? mysql_result($result, 0) : 0;
		mysql_free_result($result);

		$tmp_article['admin'] = $data->adminmode ? ("Admin: <a href='index.php$data->defaultlink$data->userlistlink&mod_editarticle=$articleid&$data->mod_categoryset=$articlecat#mod_sqledit0'>Edit</a><br>") : '';

		$tmp_article['cart'] = $data->shop_enabled ? str_replace('[ID]', $articleid, $data->add_item_link) : '';

		if ($data->article_table !== false)
		{
			$esTable = mysql_escape_string($data->article_table);
			$tables = array();
			$query = "SELECT COUNT(DISTINCT row) AS size_y, COUNT(DISTINCT col) AS size_x FROM `$esTable` WHERE article_id = $tmp_article[id]";
			$result = mod_mysql_querya($query);
			$arttable = array();

			while ($tmp = mysql_fetch_assoc($result))
			{
				$tmp['legend'] = mod_cr2br(str_replace(' ', '&nbsp;', $tmp_article['legend']));
				$query = "SELECT * FROM `$esTable` WHERE article_id = $tmp_article[id] AND col = 0 ORDER BY row ASC";
				$result2 = mod_mysql_querya($query);
				for ($i = 0;$i < $tmp['size_y'];$i++)
				{
					$tmp2 = mysql_fetch_assoc($result2);
					$tagy[$i] = $tmp2['text'];
				}

				$query = "SELECT * FROM `$esTable` WHERE article_id = $tmp_article[id] AND row = 0 ORDER BY col ASC";
				$result2 = mod_mysql_querya($query);
				for ($i = 0;$i < $tmp['size_x'];$i++)
				{
					$tmp2 = mysql_fetch_assoc($result2);
					$tagx[$i] = $tmp2['text'];
				}

				$query = "SELECT * FROM `$esTable` WHERE article_id = $tmp_article[id] ORDER BY row ASC, col ASC";
				$result2 = mod_mysql_querya($query);
		
				for ($i = 0;$i < $tmp['size_y'];$i++)
				{
					for ($j = 0;$j < $tmp['size_x'];$j++)
					{
						$tmp2 = mysql_fetch_assoc($result2);
						if ($i && $j)
						{
							$arttable[$i][$j] = ($tmp2['text'] == '' ? '&nbsp;' : $tagy[$i] . $tagx[$j] . $tmp2['text']);
						}
					}
				}
				$tables[] = CreateTableA(array('data' => $arttable, 'noHeader' => 1, 'vHighlight' => 0, 'width' => '100%'), 1) . "<table><tr><td><font size=-1 color='#777777'>$tmp[legend]</td></tr></table><br>";
			}
			$tmp_article['table'] = implode('<br>', $tables);
		}
		if ($tmp_article['price'] != 'k.A.') $tmp_article['price'] .= ' '; else $tmp_article['cart'] = '';
		call_user_func($data->display_callback, $tmp_article);
	}
}

function ShowShopOrders($data)
{
	global $mod_txt;

	if (!$data->shop_enabled) return;

	$esGroup = mysql_escape_string($data->item_group_table);
	$esUser = mysql_escape_string($data->user_table);
	$esAdress = mysql_escape_string($data->adress_table);
	$esList = mysql_escape_string($data->item_list_table);
	$esContact = mysql_escape_string($data->contact_table);
	$esItems = mysql_escape_string($data->item_table);

	if (isset($_GET['mod_shop_setorder']) && isset($_GET['mod_shop_oldorder']))
	{
		$query = "SELECT ordered FROM `$esGroup` WHERE id = " . ($order_id = intval($_GET['mod_shop_setorder']));
		$result = mod_mysql_querya($query, $data->sql);
		if (mysql_num_rows($result) && mysql_result($result, 0) == ($oldorder = intval($_GET['mod_shop_oldorder'])) && ($oldorder >= 2 && $oldorder <= 3))
		{
			if ($oldorder == 3)
			{
				$neworder = max(4, time());
			}
			else
			{
				$neworder = 3;
			}
			$query = "UPDATE `$esGroup` SET ordered = $neworder WHERE id = $order_id";
			mod_mysql_querya($query, $data->sql);
		}
	}

	$query = "SELECT
		CONCAT(`$esAdress`.forename, ' ', `$esAdress`.surname) AS Kunde,
		CONCAT(`$esAdress`.street, '<br>', `$esAdress`.zip, '&nbsp;', `$esAdress`.city) AS Adresse,
		DATE_FORMAT(FROM_UNIXTIME(`$esGroup`.ordered_at), '%W,&nbsp;%e.%c.%Y&nbsp;-&nbsp;%H:%i:%s') AS Bestelldatum,
		CONCAT('<a href=\"" . mysql_escape_string($data->defaultlink) . "&mod_shop_ordersumary=', `$esGroup`.id, '#mod_shop_orderinfo\">', COUNT(`$esList`.id), '&nbsp;" . mysql_escape_string($mod_txt['shop_article']) . "&nbsp;(" . mysql_escape_string($mod_txt['shop_cart']) . ")</a>') AS `" . mysql_escape_string($mod_txt['shop_article']) . "`,
		CONCAT(REPLACE(ROUND(SUM(`$esList`.price * `$esList`.amount), 2), '.', ','), '&nbsp;') AS Preis,
		IF(ordered < 4, CONCAT('<a href=\"" . mysql_escape_string($data->defaultlink) . "&mod_shop_setorder=', `$esGroup`.id, '&mod_shop_oldorder=', ordered, '\">', IF(ordered=2, '" . mysql_escape_string($mod_txt['shop_send_confirmation']) . "', '" . mysql_escape_string($mod_txt['shop_send_package']) . "'), '</a>'), CONCAT('" . mysql_escape_string($mod_txt['shop_send_done']) . "<br>', DATE_FORMAT(FROM_UNIXTIME(ordered), '%W,&nbsp;%e.%c.%Y&nbsp;-&nbsp;%H:%i:%s'))) AS Funktionen
	FROM
		`$esGroup`
	LEFT JOIN `$esUser`
		ON `$esUser`.id = `$esGroup`.user_id
	LEFT JOIN `$esAdress`
		ON `$esAdress`.id = IF(`$esGroup`.user_id = 0, `$esGroup`.adress_id, `$esUser`.adress_id)
	LEFT JOIN `$esList`
		ON `$esList`.group_id = `$esGroup`.id
	WHERE
		ordered >= 2
	GROUP BY
		`$esGroup`.id
	ORDER BY
		`$esGroup`.ordered ASC, `$esGroup`.ordered_at DESC
	";

	CreateTableA(array('data' => $query, 'sql' => $data->sql, 'width' => '100%', 'title' => 'Bestellungen', 'inTd' => 'valign=top'));

	if (isset($_GET['mod_shop_ordersumary']))
	{
		echo '<a name="mod_shop_orderinfo"></a><br><hr><br>';
		mod_showOrderSumary($data, false, $_GET['mod_shop_ordersumary'], true);
	}
}

function mod_shop_create_search($shop)
{
	global $mod_txt;
	return(mod_linkToForm($shop->defaultlink, '', 'GET') . '<input name=mod_shop_search type=text style="width:100" value="' . (isset($_GET['mod_shop_search']) ? htmlspecialchars($_GET['mod_shop_search'], ENT_QUOTES) : '') . "\"><br><input type=submit value='$mod_txt[shop_search]'><input type=hidden name=setmenu value=0></form>");
}

function mod_shop_cleanup($data)
{
	global $mod_txt;
	if (!$data->adminmode) return;

	if (isset($_GET['mod_cleanupdone']))
	{
		echo sprintf($mod_txt['shop_cleanup_done'], $_GET['mod_cleanupdone']);;
	}
	else if (isset($_GET['mod_startcleanup']))
	{
		$es = $query = array();

		$es['Group'] = mysql_escape_string($data->item_group_table);
		$es['List'] = mysql_escape_string($data->item_list_table);
		$es['Adress'] = mysql_escape_string($data->adress_table);
		$es['Contact'] = mysql_escape_string($data->contact_table);
		$es['User'] = mysql_escape_string($data->user_table);
		$es['Items'] = mysql_escape_string($data->item_table);
		$es['Link'] = mysql_escape_string($data->category_link_table);
		$es['Links'] = mysql_escape_string($data->link_table);
		$es['Categories'] = mysql_escape_string($data->category_table);

		$query[] = "DELETE FROM `$es[Link]` WHERE category_id NOT IN (SELECT id FROM `$es[Categories]`) OR article_id NOT IN (SELECT id FROM `$es[Items]`)";
		$tmpquery = "SELECT `$es[Group]`.id FROM `$es[Group]` LEFT JOIN `$es[List]` ON group_id = `$es[Group]`.id WHERE `$es[List]`.id IS NULL";
		$ids = mod_Query2Array($tmpquery, $data->sql, 0);
		if (count($ids)) $query[] = "DELETE FROM `$es[Group]` WHERE id IN (" . implode($ids) . ") AND ordered < 2";
		$query[] = "DELETE FROM `$es[List]` WHERE group_id NOT IN (SELECT id FROM `$es[Group]`)";
		$query[] = "DELETE FROM `$es[Links]` WHERE article_id NOT IN (SELECT id FROM `$es[Items]`) OR link NOT IN (SELECT id FROM `$es[Items]`)";

		$num = 0;
		foreach ($query as $q)
		{
			mod_mysql_querya($q, $data->sql);
			$num += $data->sql === false ? mysql_affected_rows() : mysql_affected_rows($data->sql);
		}

		foreach ($es as $table)
		{
			$query = "OPTIMIZE TABLE `$table`";
			mod_mysql_querya($query, $data->sql);
		}
		header("location: $data->defaultlink&mod_cleanupdone=$num");
	}
	else
	{
		echo "<a href='$data->defaultlink&mod_startcleanup=1'>$mod_txt[shop_start_cleanup]</a>";
	}
}

?>
