<?php

if (!isset($mod_serversort))
{
	$mod_serversort = 0;
}

require_once 'mod_functions.php';
require_once 'mod_sortbyserver.php';
require_once 'mod_java.php';

if (!isset($_content))
{
	$_content = "";
}

$mod_dwTableInstance = 0;

class table
{
	public $data;							//Table Data, Either 2-Dimensional Array, Mysql Result Resource or Mysql Query as String
	public $multi_data = false;					//Set true if data consists of an array of different datas to merge. BE CAREFUL TO MAINTAIN COL NAMES!
	public $sortable = 1;						//Table sortable
	public $dwRows = 0;						//Amount of rows is returned in here
	public $rowNames = array();					//Array with Captions for each Col
	public $darkened = array();					//Array that can define darkened Cols (Colname | Colnum => true)
	public $styles = array("alt1", "alt2");				//Styles Clases that alternate every line
	public $darkenedStyles = array("mod_sorttableheader");		//Darkened Style Class
	public $highlightColours = array("#bbbbbb", "#a6a6ba");		//Colours for Highlighting alternating for every line
	public $doubleHighlightColours = array("#888888", "#76768a");	//Coulours where vertical and horizontal highlight overlap
	public $headerHighlightColour = "#2255aa";			//Coulour for Highlighted Col in the Header
	public $highlight = 1;						//horizontal highlighting
	public $vHighlight = 1;						//vertival highlighting
	public $tableClass = "mod_sorttable";				//style class for whole table
	public $headerClass = "mod_sorttableheader";			//style class for header lines
	public $titleClass = "mod_sorttabletitle";			//style class for title line
	public $title = "";						//Title
	public $sortBy = false;						//Value or array to sort by, array if you want to sort according to multiple cols
	public $sortByOrder = array();					//Inverse sort for cols when col set to -1
	public $repeatHeader = 0;					//Repeat Header line every n lines or never when false - -1 for no header at all
	public $sql = false;						//SQL Connection
	public $checkNumericRows = 1;					//Check if a row is entirely numeric and then usw numeric sort instead of alphabetic
	public $noHeader = 0;						//Do not display any headers
	public $ignore = -1;						//Ignore a col
	public $numerize = 0;						//Add Numbers as first col
	public $pagesize = 0;						//How many lines per page (0 = only one page)
									//Set to a String or -(Index + 1) for a page for each Letter
	public $pagepos = 2;						//Where to display pagelist (bit 1: top, bit2: bottom)
	public $startpage = 1;						//Startpage if pagesize is used
	public $pagesizesort = false;					//Sort for pagesize < 0 usage, give array(sortBy => sortByOrder,...), will preceed even user defined searches then, can also be user without pagesize :|
	public $emptytable = true;					//Display nothing if table is empty if false
	
	public $seperateby = array();					//Seperate Lines that differ in fields given
	public $seperatehtml = '<hr>';					//HTML Code to insert in seperation line

	public $inTable = '';						//HTML Tag in <table>
	public $inTr = '';						//HTML Tag in every <tr>
	public $inTd = '';						//HTML Tag in every <td>
	public $inTds = array();					//array with html tags for every <td> in every col
	public $inTh = '';						//HTML Tag in every <th>
	public $colWidths = array();					//Array with widths for every col
	public $width = '';						//Width of whole table

	public $serversort = false;					//Sort Table with PHP not Javascript, really faster for big tables, but requires reload for every sort
	public $nojump = false;						//Do not jump to position when serversort set
	public $autoserversort = array(1000, 100, 10000);		//Limit of rows when serversort should automaticly be set (false = never, 0 = always), can also supply an array with rowcounts, to enable serversort, disable vhighlight, disable hightlight in this order
	public $defaultlink = false;					//Default Parameters to supply if sorting with php

	public $search = array();					//Array with Field Names/Indizes in which to search - ONLY FOR CLIENT SORT TABLE (serversort = false) !!!)
	public $searchtext = false;					//Text before search input field

	public $callback = false;					//Name of callback function that is called and processes data before output
}

function CreateTableA($params, $return = 0)
{
	$Atable = new table;
	foreach($params as $index => $value)
	{
		$Atable->$index = $value;
	}

	$content = CreateTable($Atable);

	$rows = $Atable->dwRows;
	unset($Atable);

	if ($return)
	{
		return($content);
	}
	else
	{
		echo $content;
		return($rows);
	}
}

function CreateTableEscapeA($value)
{
	return("'" . str_replace("\r", "", str_replace("\n", "\\n", addslashes($value))) . "'");
}

function CreateTableEscape(&$value, $key)
{
	$value = CreateTableEscapeA($value);
}

function CreateTableAllCols(&$table_data, $javaname, $varname)
{
	global $mod_dwTableInstance;

	$tmp = $table_data->$varname;
	array_walk($tmp, 'CreateTableEscape');
	$_content = $javaname . "[$mod_dwTableInstance] = [" . implode(",", $tmp) . "];\n";
	unset($tmp);
	return($_content);
}


function CreateTableEachCol(&$table_data, $javaname, $varname)
{
	global $mod_dwTableInstance;
	$_content = $javaname . "[$mod_dwTableInstance] = [];";
	if (count($table_data->data))
	{
		foreach ($table_data->$varname as $index => $value)
		{
			if (!is_int($index))
			{
				$index = mod_array_search($index, $table_data->rowNames);
			}
			if ($index !== false)
				$_content .= $javaname . "[$mod_dwTableInstance][$index] = " . CreateTableEscapeA($value) . ";";
		}
	}
	$_content .= "\n";
	return($_content);
}

function CreateTableColList(&$table_data, $javaname, $varname)
{
	global $mod_dwTableInstance;
	foreach ($table_data->$varname as &$val)
	{
		if (!is_int($val))
		{
			$val = mod_array_search($val, $table_data->rowNames);
		}
	}
	return($javaname . "[$mod_dwTableInstance] = [" . implode(',', $table_data->$varname) . "];\n");
}

function CreateTable(&$table_data)
{
	global $mod_dwTableInstance, $mod_serversort, $mod_txt, $modules_defaults, $modules_config, $userdata;

	mod_doDefaults($table_data);
	
	if (isset($modules_config['table_config'])) mod_doDefaults($table_data, $modules_config['table_config'], true);

	$_content = '';

	if ($table_data->sortByOrder !== false && !is_array($table_data->sortByOrder))
	{
		$table_data->sortByOrder = array($table_data->sortByOrder);
	}
	if ($table_data->sortBy !== false && !is_array($table_data->sortBy))
	{
		$table_data->sortBy = array($table_data->sortBy);
	}
	for ($i = 0;$i < count($table_data->sortBy);$i++)
	{
		if (!isset($table_data->sortByOrder[$i]))
		{
			$table_data->sortByOrder[$i] = 1;
		}
	}

	if ($table_data->searchtext === false) $table_data->searchtext = $mod_txt['sort_search'] . ':';

	if ($table_data->multi_data !== true)
	{
		$table_data->data = array($table_data->data);
	}

	for ($j = 0;$j < count($table_data->data);$j++)
	{
		$free_result = false;
		
		if (is_string($table_data->data[$j]))
		{
			if ($table_data->sql === false)
			{
				trigger_error("No SQL connection set");
			}
			else
			{
				if (($table_data->data[$j] = (modules_mysqli ?
							mysqli_query($table_data->sql, $table_data->data[$j]) :
							mod_mysql_querya($table_data->data[$j], $table_data->sql))) === false)
				{
					trigger_error("Error in SQL-Query<br>");
					return;
				}
				$free_result = true;
			}
		}

		if (is_object($table_data->data[$j]) || is_resource($table_data->data[$j]))
		{
			$result = $table_data->data[$j];
			$table_data->data[$j] = array();
			for ($i = 0;$i < (modules_mysqli ? mysqli_num_rows($result) : mysql_num_rows($result));$i++)
			{			
				$table_data->data[$j][$i] = (modules_mysqli ? mysqli_fetch_assoc($result) :
							mysql_fetch_array($result, MYSQL_ASSOC));
				foreach($table_data->data[$j][$i] as $index => $val)
				{
					if (strpos($index, 'sort_') === 0)
					{
						$table_data->data[$j][$i][substr($index, 5)] = array($table_data->data[$j][$i][substr($index, 5)], $val);
						unset($table_data->data[$j][$i][$index]);
					}
				}
			}
			if ($free_result)
			{
				mysql_free_result($result);
			}
		}
		
		if (count($table_data->seperateby) && count($table_data->data[$j]))
		{
			$tmpsep = array();
			foreach ($table_data->seperateby as $sepby) $tmpsep[$sepby] = $table_data->data[$j][0][$sepby];
			for ($i = 1;$i < count($table_data->data[$j]);$i++)
			{
				$tmpsepnew = array();
				$insertline = false;
				foreach ($table_data->seperateby as $sepby)
				{
					if (($tmpsepnew[$sepby] = $table_data->data[$j][$i][$sepby]) != $tmpsep[$sepby])
					{
						$insertline = true;
						break;
					}
				}
				$tmpsep = $tmpsepnew;
				if ($insertline)
				{
					array_splice($table_data->data[$j], $i, 0, array($table_data->data[$j][$i]));
					foreach ($table_data->data[$j][$i] as &$ref_tmpval)
					{
						$ref_tmpval = $table_data->seperatehtml;
					}
					$i++;
				}
			}
		}
	}

	for ($i = 1;$i < count($table_data->data);$i++)
	{
		$table_data->data[0] = array_merge($table_data->data[0], $table_data->data[$i]);
	}
	$table_data->data = $table_data->data[0];

	if ($table_data->callback !== false)
	{
		$table_data->data = mod_call_user_func($table_data->callback, array($table_data->data));
	}

	$table_data->dwRows = count($table_data->data);

	$oldRowNames = $table_data->rowNames;

	$table_data->rowNames = array();

	if (count($table_data->data) == 0)
	{
		if ($table_data->emptytable === false) return;
		$table_data->numerize = 0;
	}

	if ($table_data->numerize)
	{
		$table_data->rowNames[] = '-';
	}

	if ($table_data->dwRows)
	{
		foreach (reset($table_data->data) as $index => $value)
		{
			$table_data->rowNames[] = $index;
		}
	}
	else
	{
		$oldRowNames = array();
	}

	if ($table_data->ignore != -1)
	{
		array_splice($table_data->rowNames, $table_data->ignore, 1);
	}

	if (count($oldRowNames))
	{
		if (count($oldRowNames) != count($table_data->rowNames))
		{
			trigger_error("Invalid Number of RowNames");
		}
		$rowNamesA = $oldRowNames;
	}
	else
	{
		$rowNamesA = $table_data->rowNames;
	}

	if (is_array($table_data->autoserversort))
	{
		if (count($table_data->data) >= $table_data->autoserversort[1]) $table_data->vHighlight = false;
		if (count($table_data->data) >= $table_data->autoserversort[2]) $table_data->Highlight = false;
		$table_data->autoserversort = $table_data->autoserversort[0];
	}

	if (is_string($table_data->pagesize))
	{
		$table_data->pagesize = -(mod_array_search($table_data->pagesize, $table_data->rowNames) + 1);
	}

	$_content .= "<script>\n";

	$_content .= "mod_sorttablehhlcolours[$mod_dwTableInstance] = " . CreateTableEscapeA($table_data->headerHighlightColour) . ";\n";
	$_content .= CreateTableAllCols($table_data, 'mod_sorttablehlcolours', 'highlightColours');
	$_content .= CreateTableAllCols($table_data, 'mod_sorttabledhlcolours', 'doubleHighlightColours');
	$_content .= "mod_sorttabletitles[$mod_dwTableInstance] = " . CreateTableEscapeA($table_data->title) . ";\n";

	$_content .= "</script>\n";

	if ($table_data->numerize)
	{
		$inum = 0;
		foreach($table_data->data as &$row)
		{
			$row['-'] = ++$inum;
		}
		unset($row);
	}

	if ($mod_serversort || $table_data->serversort || ($table_data->autoserversort !== false && count($table_data->data) >= $table_data->autoserversort) || (isset($modules_defaults) && isset($modules_defaults['user_data_config']) && isset($userdata['data']['mod_config']['java_tables']) && !$userdata['data']['mod_config']['java_tables']))
	{
		$_content .= CreateServerTable($table_data, $rowNamesA);
		$mod_dwTableInstance++;
		return($_content);
	}
	else
	{
		$_content .= "<div id='mod_sorttable$mod_dwTableInstance'>Tabelle noch nicht initialisiert</div>\n";
	}

	if ($table_data->pagesizesort !== false)
	{
		$table_data->sortBy = array_merge(array_keys($data->pagesizesort), $table_data->sortBy);
		$table_data->sortByOrder = array_merge(array_values($data->pagesizesort), $table_data->sortByOrder);
	}

	$_content .= "<script>\n";

	array_walk($rowNamesA, 'CreateTableEscape');
	$_content .= "mod_sorttablerownames[$mod_dwTableInstance] = ";
	if ($table_data->noHeader)
	{
		$_content .= "false;\n";
	}
	else
	{
		$_content .= "[";
		$_content .= implode(',', $rowNamesA);
		$_content .= "];\n";
	}
	unset($rowNamesA);

	$_content .= "mod_sorttabledata[$mod_dwTableInstance] = [";
	$rows = array();
	foreach($table_data->data as $row)
	{
		$values = array();
		for ($i = 0;$i < count($table_data->rowNames);$i++)
		{
			$entry = $row[$table_data->rowNames[$i]];
			if (!is_array($entry))
			{
				if ($table_data->checkNumericRows && is_numeric($entry))
				{
					$entry = array(CreateTableEscapeA($entry), intval($entry));
				}
				else if (($tmp = preg_replace('/<\S[^>]*>/', '', $entry)) != $entry)
				{
					$entry = array(CreateTableEscapeA($entry), CreateTableEscapeA($tmp));
				}
				else
				{
					$entry = array(CreateTableEscapeA($entry));
				}
			}
			else
			{
				$entry[0] = CreateTableEscapeA($entry[0]);
			}
			$values[] = '[' . implode(',', $entry) . ']';
		}
		$rows[] = '[' . implode(',', $values) . ']';
	}

	$_content .= implode(',', $rows);
	$_content .= "];\n";

	$_content .= "mod_sorttablesortable[$mod_dwTableInstance] = " . intval($table_data->sortable) . ";\n";
	$_content .= "mod_sorttablepage[$mod_dwTableInstance] = $table_data->startpage;\n";
	$_content .= "mod_sorttableby[$mod_dwTableInstance] = [];mod_sorttablereverse[$mod_dwTableInstance] = [];\n";

	$_content .= CreateTableAllCols($table_data, 'mod_sorttablestyles', 'styles');
	$_content .= CreateTableAllCols($table_data, 'mod_sorttabledarkstyles', 'darkenedStyles');

	$_content .= "mod_sorttablehighlight[$mod_dwTableInstance] = " . intval($table_data->highlight) . ";\n";
	$_content .= "mod_sorttablevhighlight[$mod_dwTableInstance] = " . intval($table_data->vHighlight) . ";\n";
	$_content .= "mod_sorttableclasses[$mod_dwTableInstance] = '" . $table_data->tableClass . "';\n";
	$_content .= "mod_sorttableheaderclasses[$mod_dwTableInstance] = '" . $table_data->headerClass . "';\n";
	$_content .= "mod_sorttablerepeatheader[$mod_dwTableInstance] = " . $table_data->repeatHeader . ";\n";
	$_content .= "mod_sorttabletitleclasses[$mod_dwTableInstance] = '" . $table_data->titleClass . "'\n";

	$_content .= "mod_sorttableintable[$mod_dwTableInstance] = " . CreateTableEscapeA($table_data->inTable) . ";\n";
	$_content .= "mod_sorttableintr[$mod_dwTableInstance] = " . CreateTableEscapeA($table_data->inTr) . ";\n";
	$_content .= "mod_sorttableintd[$mod_dwTableInstance] = " . CreateTableEscapeA($table_data->inTd) . ";\n";
	$_content .= "mod_sorttableinth[$mod_dwTableInstance] = " . CreateTableEscapeA($table_data->inTh) . ";\n";

	$_content .= "mod_sorttablewidth[$mod_dwTableInstance] = " . CreateTableEscapeA($table_data->width) . ";\n";

	$_content .= CreateTableEachCol($table_data, 'mod_sorttablecolwidths', 'colWidths');
	$_content .= CreateTableEachCol($table_data, 'mod_sorttableintds', 'inTds');
	$_content .= CreateTableEachCol($table_data, 'mod_sorttabledarkened', 'darkened');

	$_content .= CreateTableColList($table_data, 'mod_sorttablesearch', 'search');
	$_content .= "mod_sorttablesearchtext[$mod_dwTableInstance] = " . CreateTableEscapeA($table_data->searchtext) . ";\n";

	$_content .= "mod_sorttablepagesize[$mod_dwTableInstance] = " . $table_data->pagesize . ";\n";
	$_content .= "mod_sorttablepagepos[$mod_dwTableInstance] = " . $table_data->pagepos . ";\n";

	if ($table_data->sortBy === false)
	{
		$_content .= "mod_CreateTable($mod_dwTableInstance" . ($table_data->pagesize ? ", $table_data->startpage" : '') . ");";
	}
	else
	{
		$keys = array();
		for ($i = 0;$i < count($table_data->sortBy);$i++)
		{
			if (is_int($table_data->sortBy[$i]))
			{
				$keys[] = $table_data->sortBy[$i];
			}
			else
			{
				$keys[] = mod_array_search($table_data->sortBy[$i], $table_data->rowNames);
			}
		}
		$_content .= "mod_sorttableby[$mod_dwTableInstance] = [" . implode(',', $keys) . "];";
		$_content .= "mod_sorttablereverse[$mod_dwTableInstance] = [" . implode(',', $table_data->sortByOrder) . "];\n";
		$_content .= "mod_SortTable($mod_dwTableInstance, -1);\n";
	}
	$_content .= "</script>\n";

	if (count($oldRowNames))
	{
		$table_data->rownames = $oldRowNames;
	}

	$mod_dwTableInstance++;

	return($_content);
}

?>
