<?php

require_once 'mod_sort.php';
require_once 'mod_functions.php';
require_once 'mod_sqledit2.php';

$dwEditInstance = 0;

class sqledit
{
	public $sql = false;			//SQL Connection
	public $sqltablename = false;		//Table Name of SQL Table to Edit
	public $sqlselect = false;		//User defined Select Statement for The HTML Table

	public $sqlwhere = 'TRUE';		//User defined WHERE Statement for all SQL Queries
	public $sqlforcewhere = false;		//Always append to sqlwhere, even if sqlwhere is overwritten by adddefaults
	public $sqlsortwhere = array();		//Sort only within directorys (given field values must match) (usefull for dir edit)
	public $sqljoin = '';			//User define JOIN Statement
	public $sqlgroup = false;		//User denied GROUP Clause

	public $adddefaults = array();		//Default Values (will be added by default to every new entry, if $sqlwhere = '' they will build a where clause
	public $justadddefaults = array();	//Like adddefaults but wont affect where clause (never)...

	public $relations = array();		//Relations between SQL Data and Table Entries 'SQL Name' => array('parameter' => 'val, ...)
						//Parameters:
						//	'name'	 : Col Caption
						//	'formname' : May set different Colname for the edit part in the form
						//	'appendform' : "String that will be appended to the input box in edit form
						//	'appendform2' : "String directly appended, usefull for checkboxes
						//	'inhtml' : HTML Code that is included in input tag

						//	'sql'	 : User defined SQL Part in Select Clause, set to true to append appendform
						//	'autosql': Control automatic sql queries for relation, usefull for select / root / checkboxm,false disables (default: true)
						//	'fieldname' Name of field in sql db if not array index is used

						//	'type'	 :	'text' (default)
						//			'int' Integer, does not differ from text though instead for checking purpose, 'force' checks for integer > 0, set force to numeric 1 to check if entry was numeric (is_numeric)
						//			'checkbox' autosql: true = yes/no (default); 1 = X/-; false = disable
						//			'select' (see options), set (You can use force to get an invalid start value, true sets that's option to 0 or give an numeric value)
						//			'hidden' (will only be displayed in table but not be edited)
						//			'virtual' (as hidden but no such field in db exists)
						//			'callback' (Call a function to produce the input/select box, gets current value as parameter for edit or false for new value)
						//			'md5' (Use for Password fields, an MD5 of the value is saved, if edited and '' is returned no change is done)
						//			'file' (For file upload, if used in combination with filename attribute, a file upload is required, can be overwritten with force=false, if no filename is set force is treated as usual)
						//			'date' Date
						//			'datetime' Date and Time
						//			'fixed' Just display some text :|, no db entry, cannot be changed
						//			'seperator' Insert one line in table, line consistes only of one col, inhtml is inserted in td, default will become line content
						//			'multi' Use Mutitext From mod_form.php
						//			'html' HTML Edit, use rows for height instead of rows and htmltoolbar to display toolbar
						//			'list' Dual List (or single list option of dual List), use in combination with sqllink (or not for binary list):|, can also supply rows col for size
						//			'table' Create a table - Use with rows / cols / default can contain array with a table overriding cols/rows
						//			'root' List with root entries
						//			'ip' ......

						//	'storage'	: For files directory to store them in instead of the db
						//	'filename':		Table name that saves filename when uploading files. A relation of type hide must exist with the same name to work!
						//	'filesize':		If set maximum size of file, Standard is 2 MB, for unlimited set to -1, Size in Bytes

						//	'rootdefaults'	: Set to true to take defaults from adddefaults, a custom string, array with expressions or array('name' => 'value')
						//	'rootjoin'	: Join Clause for ids, true to copy from editdata
						//	'rootdisable'	: Array with ids to disable, array can contain strings for sql where clauses
						//	'rootname' : Name for root entry for type root

						//	'tablesqltable'	: Sql Table Name to store table in
						//	'tableconstants': Constant Values to add / reuire in Table SQL Table, array($name => $value), to store multiple tables in one table (confusing though:|) ([ID] os sqledit id)
						//	'tablefixed'	: Fixed Table Size
						//	'tabletitles'   : Table Titles (See Forms File)
						//	'numerictable'	: Intval entries

						//	'listdata'	: Query to fetch data for duallist, must return (id, name, sel) where sel is 0 or 1 depending on selection status, [ID] will be replaced by entry id, 0 for new entry, [VALUE] will be replaced by current value if exists
						//	'binarylist'	: Binary List (No fullids)
						//	'singlelist'	: Single List (Option for Duallist)

						//	'htmltoolbar'	: Display Toolbar for HTMLEdit

						//	'multitexthtml' : For Type multi inputhtml variable
						//	'multitextdata' : MultiText Data, can be left false or unset if sqllink is user
						//	'multitextdefaults' : Default Data for creating
						//	'multitextselects' : Will be passed as selectvals to multitext (mod_form.php)
						//	'multitextseperator': .....
						//	'multitextcopy' : Passed to multitext again...

						//	'signed'	: true for signed integer regarding force checks
						//	'float'		: true for float (will convert '.' to ',' if set to 1!
						//	'currency' : This field is a currency field. Set Type to int, float to 1 yourself!. will append currency (Eur, $) to sql statement etc and round to 2 digits.

						//	'hide'	 : Hide in Table, only for add / edit, set to true! (Will be autoset for sqllink / table - type if sql is false
						//	'virtualedit' : (Virtual Edit Field, no such field in db, if you want to hide in table combine with hide)
						//	'rows'	 : Amount of rows for a textfield (textarea then :|) / htmledit / duallist / table
						//	'cols'	 : Amount of cols in a table, width of htmledit
						//	'width'	: Width of field
						//	'style'	 : Style parameter for this inputs
						//	'color'	 : Color to display entry in table in. Will be directly passed to mysql query to create html string, so for example use "'red'" to get mysql string 'red', or "'#FFFFFF'" for white, can alse be an sql statement "IF(a,'red','green')"
						//	'group'  : true / false for start stop grouping fields in one line, instead of true a string will preceed the first field
						//	'cut'	 : Display only 'cut' letters in table
						//	'showextended' : Append real table entry in brackets in Display Table

						//	'pw'	 : Set to true to display asterix (*) in input field, Set to 2 do add confirm field
						//	'confirm': Name for Confirm Field

						//	'options': Options for Select Type, Supply by assoziative array or SQL Query, string that doesnt start with SELECT can be custom options, in a string [EDIT_ID] will be replaced by id if an entry is edited or 0 otherwise
						//	'zeroopt': Option for 0 Value, that will preceed the sql query with a union, can be used with array options and will become first array elem

						//	'link'	 : Supply a link for each entry, "[ID]" will be replaced with the entry id
						//	'linktarget' : Target for link

						//	'func'	 : Name of a callback function for type = callback ($value, $id, $name) (-1 for sqllink, -2 if field does not exist in db)
						//	'default': Default value for new entry
						//	'default_callback':	Name of a callback function that returns value for new entry
						//	'autoinc' : Auto Increment Value to one value higher than current highest value, set a numeric value instead of true for lowest value below that
						//	'force'	 : Set to true to force this field not empty! (Numeric 1 does the same with some specials noted in type description), set to a string for a callback function to check if the entry is valid (max return error message), gets a second arg (true if update, false for new entry), supply an array with all valid values or a string with a space that is executet as sql statement to get valid values, when used with multilink you may give an array
						//	'nodual' : Set if you dont want to allow two identical entries in this field, provide a string that is appended to the where clause if desired or just true
						//	'foldempty' : If no apropriate POST Variable is received set to ''

						//	'sqllink': No such field in Database. Use in combination with callback. Supply table name for links.
						//	'sqllinkdata':		Supply an array ($index => $val). Use [ID] for id in this table and [LINK] for entrys that must be given as array per http post (see example!)
						//	'sqllinknums':		Save SQL Link Order, set to field name to store num in
						//	'sqllinkkeepids':	Keep ID in Link Table, must be user with sqllinknums
						//	'sqllinktype':		Fake type for use with false, give array for multilink
						//	'multilink':		Link with Multiple entries, use sqllink with [LINK0], [LINK1] etc instead of link anf provide array as POST for input

						//	'editable' : set to false to make a single field constant
						//	'requireedit' : If set to true, field will only be displayed when editing, if false only for adding
						//	'admin'	 : See global admin tag

						//	'texts'	: array with 2 entries for type checkbox, set to true for autotexts ('-', $name)

						//	'multipleinstance' : Relation is an array of multiple relations, each subrelation must contain 'check_php' that is a callback function to check if this instance applies (will be given $relname as parameter, if a space is in string then it is 'eval'ed instead of called, $mod_tmp_relpre then contains relation prefix) and 'check_java' that is a java expression that checks in runtime, subrelations are checked in array order, empty java or php for catchall, all subrelations will be merged with ['multipleinstance'] for common values, check_php and check_java will default to empty if not set.
						//	'recheckinstance' : Set to recheck multiple instances when relation is changed, Set recheckinstance to the id that the relation will be given that you will use in the 'check_java', cannot be used in combination with inhtml
						//	'multipleinstanceblocks' : Use Blocks of multipleinstance fields instead of single relations only. Give an array with blocks (arrays) of relations where each block contains 'check_php' / 'check_java', 'multipleinstanceblocks' is an array with default values just like 'multipleinstance'
						//	'multiplehideline' : hide this line if multiple instance rule DOES apply, set false to display line when rule applies. You need extra false values for the other lines of the instance because lines will never be showed again otherwise!

						//	'subtable': Point to a subtable to store values in
						//	'subdefaults' mod_doDefaults for subforms (list, multitext, table)

	public $defaultlink = false;		//Default link Parameter that will be added to every link
	public $sqleditwidth = false;		//Width of the Edit Screen

	public $subtables = array();		//Subtables, provide 'name' => array('id' => 'id_field_name', 'defaults' => array('name' => 'val')), apply 'type' => 'reverse' to store link in sqltablename to subtable, otherwise the other way around, if using reverse-type supply a 'idtable' index pointing to the table name where the id is stored if not in data->sqltablename, 'tablename' may overwrite index as table name, 'present_callback' can be the name of a callback function to determine if an apropriate subtable entry exists, will be called with subtableindex and an array with main table entries as parameters (before changes when editing but after insert when adding) and an edit flag as 3 (will be new $tmp array instead of edit = true). param, return true for auto, false if not existent or an numeric id to force using this entry

	public $addable = true;			//Can add something...
	public $addbutton = false;		//Dont display add formular always but if you press the add entry button, true/1 for button on top, -1 for button on tail of the table etc., give a string for custom button [NAME] and [LINK] will be replaced
	public $addchangebutton = false;	//Give an array for 0 => addbutton, 1 => changebutton, (-1/-2 for images), if only 0 => x is given or a string but no array, this text will be used for both buttons, set an element to false for default value
	public $editable = true;		//Table can only be edited if set to true, Set to a string for a mysql Expression that determines editability for every db entry
	public $deleteable = true;		//Items can only be deleted if set to true, string as above
	public $sortable = true;		//Table sortable, String for custom Order By
	public $sortableadd = false;		//Add Sort entry even if not sortable
	public $sortablelinktable = false;	//Sort is in Subtable, give tablename 
	public $sortablelinkdefaults = false;	//array(defaultfield => defaultval)), [ID] is replaced with entry id
	public $copyable = false;		//Set to true to allow copying, give an array ('link' => array($field1 => $val1, $field2 => $val2...)) where img is the link content and fields are fields not to be copied and give values to set, leave link numeric for default image
	public $viewable = false;		//Allow to view if edit is disabled, rules for editable apply for viewable. viewable will disable edit features completely

	public $adddate = false;		//Automaticly add a date for every new entry (If you set this to true the date will be actualized every time the entry is changed, set to 1 if you dont like this or use $addchange)
	public $addchange = false;		//Automaticly add a date for the last change (Can only be used with adddate set true, 
	public $dateformat = '%W,&nbsp;%e.%c.%Y&nbsp;-&nbsp;%H:%i:%s';	//MySQL Date Format String
	public $dateonlyformat = '%W,&nbsp;%e.%c.%Y';	//MySQL Date Format String

	public $noaction = false;		//No update can be done to the SQL Database if set to true

	public $deletecallback = false;		//Callback function, that is called beforce an entry is deleted taking the entry's id as parameter, may return -1 to stop deletion
	public $editcallback = false;		//Callback after edit...
	public $createcallback = false;		//Callback function called after a new entry was created given the id as argument, may return -1 for no creation
	public $copycallback = false;		//... for copy..., id is given as arg

	public $savedelete = false;		//Instead of deleting an entry set deleted = $userid or -1 for no user
	public $askdelete = false;		//Ask with a JavaScript Popup before deleting an entry

	public $onsubmit = false;		//Set to a Java Script Command that is executed before the form is submited
	public $inaddform = false;		//HTML Code that is included in the Form when adding new entries (good to use with createcallback)
	public $ineditform = false;		//As above for edit, set true to copy from above
	public $showtable = true;		//Show Table before edit form, String for name of a callback function for each entry function($arraytable, $arrayselect, $functions, $first) //Will be called with $first = -1 after last entry, false to disable, numeric value n for pulldownlist (1) or select with size (n)
	public $pages = -1;			//for custom showtable, set 1 for pagelist before table, -1 for after table, true for both, 0/false for none
	public $pagetype = 1;			//1 For Standard Pages, 2 Custom Selectable Pagesize, 3 both, 0 nothing, string for simple archive button with string, just try..., array for link/title
	public $pagecols = 1;			//Multiple cols in a line... will display 
	public $pagesize = 0;			//0/flase disable, will be forwarded to sorttable->pagesize or pagesize for custom showtable in combination with pages, pagetype, pagecols

	public $forceedit = false;		//Force an edit instead of an add (Usefull with showtable = false), set id to edit

	public $name = false;			//Name that is displayed
	public $title = false;			//Title for the table
	public $namefield = 'name';		//Set A Name field from where an entryname is taken when editing, false for disable, an string with an space (' ') for an sql statement

	public $mod_redir_changes = false;	//Use header location command to reload page after sqledit changed something, insures actual data and prevents change from happening again when someone reloads the page

	public $prelines = array();		//Array with preceeding lines in the table
	public $table_callback = false;		//Name of a callback function that is passed to the sort table

	public $functions = array();		//Provide an array with 'Field Name' => 'Placeholder' where Placeholder will be Replaced by Function Col in All Fields, empty array for standard functions col, Cols must provide 'sql' Parameter widh Placeholder in it

	public $nojump = false;			//Dont jump to position (#) when editin but show the top of the page, set to !== true do jump but do not jump when adding/editing
	public $commonstyle = false;		//Common Style Parameter for all Inputs
	public $customdesign = false;		//Set to a string, that contains a custom design for the input formular. [INPUT_$relation[index]] will be replaced with apropriate input field
	public $functionseperator = ' ';	//String to put in between of function buttons
	public $postcallback = false;		//Name of a function that may change http post data for edit/add, will be given the post name string wher you must append relation index, will give second parameter $edit true/false

	public $tabledata = array();		//Additional Table data that will be passed through by doDefaults

	public $autodefaults = true;		//If set to true, when adding an entry, the table will be scanned for further fields, that dont have a default value, and then set to '' or 0

	public $subedits = array();		//Sub SQL Edits when editing an entry. Supply 'field' => sqledit, where field will be appended to adddefaults with the id of the current entry being edited, default sql where is '' then, if you change this, supply an apropriate where!

	public $afterchange = array();		//Array that will be Appended to REQUEST after a change was done
	public $checktable = array();		//Pass this to checktable
	public $admin = true;			//Set to false to disable edit functions. You can supply a admin tag to each relation. Supply true / false, that will be checked against $data->admin if the relation is to display, can also supply a string, that will override the sql statement if admin = false

	public $action = false;			//Action Array passes to checkAction if not false, if no type set sqltablename will become type, called as second createcallback, sql is passed through
	public $changes = false;		//Field name to log changes on
	public $changetype = 1;			//1: Calculate strdiff and decide when to log changes, will log first string when adding to calc diff from, 2: Always and only log when editing
	public $autohide = false;		//Autohide all entries that are not virtual and no hide option set in relation

	public $subedit = false;		//If subedit is set true CreateSqlEdit returns an array with 'edit' => Edit/Add Field and The Table Ids Pointing to the corresponding function field, if set to 1 it works as usual and in addition returns the array, 2 is like 1 but group is ignored, use 3 to maintain user functions
	public $mod_txt = array();		//Override mod_txt
}

function mod_CreateSqlEdit_sqllink(&$data, $instance, $id, $dodelete = false, $doinsert = true)
{
	global $dwEditInstance;
	foreach($data->relations as $index => $val)
	{
		if (isset($val['requireedit']) && (($val['requireedit'] && (!isset($_POST["mod_editsqlsave"]) || $_POST['mod_editsqlsave2'] != $dwEditInstance)) || (!$val['requireedit'] && isset($_POST["mod_editsqlsave"]) && $_POST['mod_editsqlsave'] == $dwEditInstance)))
		{
			continue;
		}

		$relname = "mod_sql-$instance-$index";
		if (isset($val['sqllink']))
		{
			if (isset($insertnumsave)) unset($insertnumsave);
			$esLink = mysql_escape_string($val['sqllink']);

			$delete = $insert1 = $insert2 = $insertnums = array();
			foreach($val['sqllinkdata'] as $field => $value)
			{
				$insert1[] = '`' . mysql_escape_string($field) . '`';
				if ($value == '[ID]')
				{
					$delete[] = '`' . mysql_escape_string($field) . '` = ' . intval($id);
					$insert2[] = intval($id);
				}
				else if (strncmp($value, '[LINK', 5) === 0)
				{
					$insertnums[isset($val['multilink']) && $val['multilink'] ? intval(substr($value, 5, -1)) : 0][] = count($insert2);
					$insert2[] = '';
				}
				else
				{
					$delete[] = '`' . mysql_escape_string($field) . '` = "' . mysql_escape_string($value) . '"';
					$insert2[] = '"' . mysql_escape_string($value) . '"';
				}
			}
			if ($dodelete)
			{
				$query = "DELETE FROM `$esLink` WHERE " . implode(' AND ', $delete);
				if ($doinsert && isset($val['sqllinkkeepids']) && $val['sqllinkkeepids'] && isset($_POST[$relname]))
				{
					$query .= " AND num > " . count($_POST[$relname]);
				}
				mod_mysql_querya($query, $data->sql);
			}

			if (isset($val['sqllinknums']))
			{
				$insertnumsave = count($insert1);
				$insert1[] = '`' . mysql_escape_string($val['sqllinknums']) . '`';
			}

			if ($doinsert && isset($_POST[$relname]))
			{
				$j = 1;
				foreach($_POST[$relname] as $link)
				{
					if (!is_array($link)) $link = array($link);
					if (isset($val['force']))
					{
						if (!is_array($val['force'])) $val['force'] = array($val['force']);
						if (isset($val['sqllinktype']) && !is_array($val['sqllinktype'])) $val['sqllinktype'] = array($val['sqllinktype']);
						$tmpval = $val;
						foreach ($val['force'] as $callbackid => $callbackfunc)
						{
							$_POST['mod_sqledit_tmp'] = $link[$callbackid];
							$tmpval['type'] = isset($val['sqllinktype']) ? $val['sqllinktype'] : '';
							if (mod_checkrelvalid($val, 'mod_sqledit_tmp', $data->sql, $data, -1))
							{
								return(-1);
							}
							unset($_POST['mod_sqledit_tmp']);
						}
					}
					for ($i = 0;$i < count($link);$i++)
					{
						foreach($insertnums[$i] as $insertnum)
						{
							$insert2[$insertnum] = '"' . mysql_escape_string($link[$i]) . '"';
						}
					}

					$insert1a = $insert2a = array();
					if ($doinsert && isset($val['sqllinkkeepids']) && $val['sqllinkkeepids'])
					{
						$query = "SELECT id FROM `$esLink` WHERE " . implode(' AND ', $delete) . " AND `" .
							mysql_escape_string($val['sqllinknums']) . "` = $j";
						$result = mod_mysql_querya($query, $data->sql);
						if (mysql_num_rows($result))
						{
							$insert1a[] = 'id';
							$insert2a[] = mysql_result($result, 0);
						}
					}
					if (isset($insertnumsave)) $insert2[$insertnumsave] = $j++;

					$query = "REPLACE INTO `$esLink` (" . implode(',', array_merge($insert1, $insert1a)) .
						') VALUES (' . implode(',', array_merge($insert2, $insert2a)) . ')';
					mod_mysql_querya($query, $data->sql);
				}
			}
		}

		if (isset($val['type']) && $val['type'] == 'table')
		{
			$delete = $insert1 = $insert2 = array();

			foreach($val['tableconstants'] as $field => $value)
			{
				$insert1[] = '`' . mysql_escape_string($field) . '`';
				if ($value == '[ID]')
				{
					$delete[] = '`' . mysql_escape_string($field) . '` = ' . intval($id);
					$insert2[] = intval($id);
				}
				else
				{
					$delete[] = '`' . mysql_escape_string($field) . '` = "' . mysql_escape_string($value) . '"';
					$insert2[] = '"' . mysql_escape_string($value) . '"';
				}
			}
			if ($dodelete)
			{
				$query = "DELETE FROM `" . mysql_escape_string($val['tablesqltable']) . "` WHERE " . implode(' AND ', $delete);
				mod_mysql_querya($query, $data->sql);
			}

			if ($doinsert && isset($_POST[$relname]))
			{
				$insert1[] = 'row';$insert1[] = 'col';$insert1[] = 'text';

				for ($i = 0;$i < count($_POST[$relname]);$i++)
				{
					for ($j = 0;$j < count($_POST[$relname][$i]);$j++)
					{
						if ($i == 0 && $j == 0 && $val['tabletitles'] === true) $_POST[$relname][0][0] = '';
						$insert2tmp = $insert2;
						$insert2tmp[] = $i;$insert2tmp[] = $j;$insert2tmp[] = '"' . (isset($val['numerictable']) && $val['numerictable'] ? intval($_POST[$relname][$i][$j]) : mysql_escape_string($_POST[$relname][$i][$j])) . '"';
						$query = "INSERT INTO `" . mysql_escape_string($val['tablesqltable']) . '` (' . implode(',', $insert1) .
							') VALUES (' . implode(',', $insert2tmp) . ')';
						mod_mysql_querya($query, $data->sql);
					}
				}
			}
		}
	}
	return(true);
}

function mod_checkrelvalid($val, $relname, $sql, &$data, $edit)
{
	global $dwEditInstance, $mod_txt;
	$nosql = 0;
	if (isset($val['force']) && $val['force'] !== false)
	{
		if ($val['force'] === true || $val['force'] === 1)
		{
			if (isset($val['type']) && $val['type'] == 'int' && $val['force'] === 1)
			{
				if (!is_numeric($_POST[$relname]))
				{
					$data->mod_errors[] = sprintf($mod_txt['edit_error_numeric'], $val['name']);
				}
			}
			else if (isset($val['type']) && $val['type'] == 'int' && $_POST[$relname] <= 0 && (!isset($val['signed']) || !$val['signed'] || $_POST[$relname] == 0))
			{
				$data->mod_errors[] = sprintf($mod_txt['edit_error_invalid'], $val['name']);
			}
			else if ('' == $_POST[$relname])
			{
				$data->mod_errors[] = sprintf($mod_txt['edit_error_required'], $val['name']);;
			}
		}
		else if (is_string($val['force']))
		{
			if (strpos($val['force'], ' ') !== false)
			{
				$val['force'] = mod_Query2Array($val['force'], $data->sql, 0);
			}
			else if (($tmp = call_user_func($val['force'], $_POST[$relname], isset($_POST['mod_editsqlsave']) && $_POST['mod_editsqlsave'] == $dwEditInstance)) !== true)
			{
				$data->mod_errors[] = $tmp === false ? sprintf($mod_txt['edit_error_invalid'], $val['name']) : $tmp;
			}
		}
		if (is_array($val['force']) && !in_array($_POST[$relname], $val['force']))
		{
			$data->mod_errors[] = sprintf($mod_txt['edit_error_invalid'], $val['name']);
		}
		if (isset($val['type']) && $val['type'] == 'select')
		{
			mod_selectquery($val, $sql, $edit);
			if (!isset($val['options'][$_POST[$relname]]))
			{
				if (isset($val['force'])) $data->mod_errors[] = $mod_txt['edit_select_error'] . " ($val[name])";
				$nosql = 1;
			}
		}
	}
	if (count($data->mod_errors)) $nosql = 1;
	return($nosql);
}

function mod_selectquery(&$relation, $sql, $edit)
{
	global $dwEditInstance;
	if (is_string($relation['options']) && ($tmp = stripos($relation['options'], 'select')) !== false && $tmp < 2)
	{
		$query = str_replace('[EDIT_ID]', $edit ? intval($_REQUEST["mod_editsql$dwEditInstance"]) : 0, $relation['options']);
		if (isset($relation['zeroopt'])) $query = "(SELECT 0 AS id, '" . mysql_escape_string($relation['zeroopt']) . "' AS name) UNION ($query)";
		$result = mod_mysql_querya($query, $sql);
		$relation['options'] = array();
		while ($opttmp = mysql_fetch_row($result))
		{
			$relation['options'][$opttmp[0]] = $opttmp[1];
		}
		mysql_free_result($result);
	}
	else if (is_array($relation['options']) && isset($relation['zeroopt']))
	{
		$relation['options'] = array_merge(array(0 => $relation['zeroopt']), $relation['options']);
	}
}

function mod_getDate(&$value, $datetime, $default = 0)
{
	$tmp = explode(' ', $value);

	if (count($tmp) == 0) return;

	$date = '1970-1-1';
	$time = ($datetime ? '0:0:0' : '12:0:0');

	foreach ($tmp as $tmp2)
	{
		if (strpos($tmp2, '.'))
		{
			$date = implode('-', array_reverse(explode('.', $tmp2)));
		}
		else if ($datetime && strpos($tmp2, ':'))
		{
			$time = $tmp2;
		}
	}

	$value = strtotime($date . ' ' . $time);
	if ($value < 3600 * 24) $value = $default;

	return($value);
}

function mod_CreateSqlEdit_addbutton($data, $highlight = false, $create = false)
{
	global $dwEditInstance, $mod_txt;
	if (is_string($data->addbutton))
	{
	    return(str_replace(array('[NAME]', '[LINK]'), array(sprintf($mod_txt['edit_title_add'], $data->name), "$data->defaultlink&mod_addsqlcreate=$dwEditInstance" . ($data->nojump === true ? '' : "#mod_sqledit$dwEditInstance")), $data->addbutton));
	}
	else
	{
	    return(($highlight ? '' : '<i>(') . "<a href='$data->defaultlink" . ($create || $data->addbutton ? "&mod_addsqlcreate=$dwEditInstance" : '') . ($data->nojump === true ? '' : "#mod_sqledit$dwEditInstance") . "'>" . sprintf($mod_txt['edit_title_add'], $data->name) . "</a>" . ($highlight ? '' : ')</i>'));
	}
}

function mod_sqledit_filesize($relation)
{
	$maxFileSize = isset($relation['filesize']) ? ($relation['filesize'] == -1 ? get_cfg_var('upload_max_filesize') : $relation['filesize']) : '2M';
	if (substr($maxFileSize, -1) == 'M') $maxFileSize = substr($maxFileSize, 0, -1) * 1024 * 1024;
	else if (substr($maxFileSize, -1) == 'K') $maxFileSize = substr($maxFileSize, 0, -1) * 1024;
	$maxFileSize = intval($maxFileSize);
	return($maxFileSize);
}

function mod_sqledit_getrootvals($data, $relation)
{
	$esTable = mod_mysql_escape_table($data->sqltablename);
	if (isset($relation['rootdefaults']))
	{
		if ($relation['rootdefaults'] === true) $relation['rootdefaults'] = $data->adddefaults;
		if (is_string($relation['rootdefaults']))
		{
			$where = $relation['rootdefaults'];
		}
		else
		{
			foreach ($relation['rootdefaults'] AS $index2 => &$ref_value)
			{
				if (!is_numeric($index2))
				{
					$ref_value = '`' . mysql_escape_string($index2) . '` = "' . mysql_escape_string($ref_value) . '"';
				}
			}
			$where = implode(' AND ', $relation['rootdefaults']);
		}
	}
	else
	{
		$where = 'TRUE';
	}

	if (isset($relation['rootjoin']))
	{
		if ($relation['rootjoin'] === true) $joinpart = $data->sqljoin;
		else $joinpart = $relation['rootjoin'];
	}
	else $joinpart = '';

	$query = "SELECT `$esTable`.id, `$esTable`.root FROM `$esTable` $joinpart WHERE $where";
	$idsroot = mod_Query2Array($query, $data->sql);
	$ids = $roots = array();
	foreach($idsroot as $tmpval)
	{
		$ids[] = $tmpval['id'];
		$roots[] = $tmpval['root'];
	}

	$disableids = array();
	if (isset($relation['rootdisable']))
	{
		foreach($relation['rootdisable'] as $rootdisable)
		{
			if (is_string($rootdisable))
			{
				$disableids += mod_Query2Array("SELECT CONCAT('value=\"', `$esTable`.id, '\"') FROM `$esTable` $joinpart WHERE $rootdisable", $data->sql, 0);
			}
			else
			{
				$disableids[] = "value=\"$rootdisable\"";
			}
		}
	}
	return(array($ids, $roots, $disableids));
}


function mod_sqledit_check_addedit($data, $index, &$val, $edit, $relname)
{
	global $dwEditInstance;
	if (isset($val['multipleinstance']))
	{
		foreach ($val as $index2 => $val2)
		{
			if ($index2 === 'multipleinstance') continue;
			$val2 = array_merge($val['multipleinstance'], $val2);
			$mod_tmp_relpre = "mod_sql-$dwEditInstance-";
			if (!isset($val2['check_php']) || $val2['check_php'] == '' || (strpos($val2['check_php'], ' ') === false ? call_user_func($val2['check_php'], $mod_tmp_relpre) : eval($val2['check_php'])))
			{
				$usemultiple = true;
				break;
			}
		}
		if (!isset($usemultiple)) return('Internal Error');
		$val = $val2;
	}
	if (isset($val['type']) && $val['type'] == 'root')
	{
		$tmpval = mod_sqledit_getrootvals($data, $val);
		$tmpval[0][] = -1;

		if (!in_array($_POST[$relname], $tmpval[0]) || in_array($_POST[$relname], $tmpval[2]))
		{
			return("Invalid Root Entry");
		}
	}
	return(true);
}

function mod_sqledit_subtables($tmp_id, $fieldname, $setquery, $subtable, $data, $maintmp, $edit)
{
	$query1 = $query2 = $check = array();
	$esId = mysql_escape_string($subtable['id']);
	$esMainTable = mod_mysql_escape_table($data->sqltablename);
	$esTable = mysql_escape_string($fieldname);
	$esRealTable = mysql_escape_string(isset($subtable['tablename']) ? $subtable['tablename'] : $fieldname);
	if (isset($subtable['type']) && $subtable['type'] == 'reverse')
	{
		$esLinkTable = isset($subtable['idtable']) ? mysql_escape_string($subtable['idtable']) : $esMainTable;
		$reverse = true;
		$data->mod_sqledit_subtables_join_tmp .= " LEFT JOIN `$esRealTable` AS `$esTable` ON `$esTable`.id = `$esLinkTable`.`$esId`";
		$query = "SELECT `$esLinkTable`.`$esId` FROM `$esMainTable` $data->mod_sqledit_subtables_join_tmp WHERE `$esMainTable`.id = $tmp_id AND `$esTable`.id IS NOT NULL";
	}
	else
	{
		$query1[] = $subtable['id'];
		$query2[] = $tmp_id;
		$check[] = "`$esId` = $tmp_id";
	}
	if (isset($subtable['defaults']))
		foreach ($subtable['defaults'] as $name => $val) 
			$check[] = ($query1[] = '`' . mysql_escape_string($name) . '`') . ' = ' . ($query2[] = '"' . mysql_escape_string($val) . '"');

	if (!isset($reverse))
	{
		$query = "SELECT id FROM `$esRealTable` WHERE " . implode(' AND ', $check);
	}

	if (isset($subtable['present_callback']))
	{
		$retVal = mod_call_user_func($subtable['present_callback'], array($maintmp, $fieldname, $edit));
		if ($retVal === false) $query = "SELECT * FROM `$esRealTable` WHERE FALSE";
		else if (is_int($retVal))
		{
			$querytmp = "SELECT COUNT(*) FROM `$esRealTable` WHERE id = " . intval($retval);
			if (mysql_result(mod_mysql_querya($querytmp, $data->sql), 0)) $query = "SELECT " . intval($retVal);
		}
	}

	$result = mod_mysql_querya($query, $data->sql);

	$check = array_merge($check, $setquery);
	$query = (mysql_num_rows($result) ? 'UPDATE' : 'INSERT INTO') . " `$esRealTable` SET " . implode(', ', $check) . (mysql_num_rows($result) ? (" WHERE id = " . mysql_result($result, 0)) : '');
	mod_mysql_querya($query, $data->sql);
	if (isset($reverse) && mysql_num_rows($result) == 0)
	{
		$newid = mysql_insert_id($data->sql);
		$query = "UPDATE `$esLinkTable` SET `$esId` = $newid WHERE id = $tmp_id";
		mod_mysql_querya($query, $data->sql);
	}
}

function mod_sqledit_update_checkrel($val, $edit)
{
	return(
		(isset($val['type']) && ($val['type'] == 'virtual' || $val['type'] == 'fixed' || $val['type'] == 'seperator')) ||
		(isset($val['virtualedit']) && $val['virtualedit']) || ($edit != -1 && isset($val['requireedit']) && $val['requireedit'] == $edit)
	);
}

function mod_sqledit_update(&$data)
{
	global $dwEditInstance, $userdata, $mod_txt, $mod_dwHtmlEditInstance, $mod_msg;

	$esTable = mod_mysql_escape_table($data->sqltablename);
	if ($data->noaction === false)
	{
		if ($data->addable && isset($_POST['mod_addsql']) && $_POST['mod_addsql'] == $dwEditInstance && $data->forceedit === false)
		{
			$query = array();
			$fields = array();
			$filenames = array();
			if ($data->postcallback !== false) call_user_func($data->postcallback, "mod_sql-$dwEditInstance-", false);
			foreach ($data->relations as $index => $val)
			{
				$relname = "mod_sql-$dwEditInstance-$index";

				$retVal = mod_sqledit_check_addedit($data, $index, $val, false, $relname);
				if ($retVal === false) continue;
				if ($retVal !== true)
				{
					$data->mod_errors[] = $retVal;
					$noaddsql = 1;
					break;
				}

				$realindex = isset($val['fieldname']) ? $val['fieldname'] : $index;
				$esIndex = mysql_escape_string($realindex);
				$fieldname = isset($val['subtable']) ? $val['subtable'] : 'mod_sqltable_main';

				if (mod_sqledit_update_checkrel($val, false))
				{
					continue;
				}
				if (!isset($val['sqllink']) && (!isset($val['type']) || $val['type'] != 'table'))
				{
					if (!isset($val['storage'])) $fields[$fieldname][] = $realindex;
				}
				else
				{
					$mod_add_requiresqllink = true;
					continue;
				}
				if (isset($val['type']) && $val['type'] == 'hidden' && !in_array($index, $filenames))
				{
					if (isset($val['default']))
					{
						$query[$fieldname][] = '"' . mysql_escape_string($val['default']) . '"';
					}
					else if (isset($val['default_callback']))
					{
						$query[$fieldname][] = '"' . mysql_escape_string(call_user_func($val['default_callback'])) . '"';
					}
					else
					{
						$query[$fieldname][] = '0';
					}
					continue;
				}

				if (isset($val['foldempty']) && $val['foldempty'] && !isset($_POST[$relname]))
				{
					$_POST[$relname] = '';
				}
				
				if (isset($val['pw']) && $val['pw'] == 2 && $_POST[$relname . '_confirm'] != $_POST[$relname])
				{
					$data->mod_errors[] = $data->mod_inttxt['edit_error_pwmatch'];
					$noaddsql = 1;
					break;
				}

				if (isset($val['type']) && $val['type'] == 'file')
				{
					if (isset($_FILES[$relname]['error']) && $_FILES[$relname]['error'] == 0 && $_FILES[$relname]['size'] <= mod_sqledit_filesize($val))
					{
						if (isset($val['filename']))
						{
							$_POST["mod_sql-$dwEditInstance-$val[filename]"] = $_FILES[$relname]['name'];
							$filenames[] = $val['filename'];
						}
						if (isset($val['storage'])) continue;
						$_POST[$relname] = file_get_contents($_FILES[$relname]['tmp_name']);
					}
					else if ((!isset($val['filename']) || isset($val['force'])) && (!isset($val['force']) || $val['force'] === false))
					{
						$_POST[$relname] = '';
						if (isset($val['storage'])) continue;
					}
					else
					{
						$data->mod_errors[] = isset($_FILES[$relname]['size']) && $_FILES[$relname]['size'] > mod_sqledit_filesize($val) ? sprintf($data->mod_inttxt['edit_error_filesize'], mod_sqledit_filesize($val)) : $data->mod_inttxt['edit_error_upload'];
						$noaddsql = 1;
						break;
					}
				}

				if (isset($val['type']) && ($val['type'] == 'date' || $val['type'] == 'datetime')) mod_getDate($_POST[$relname], ($val['type'] == 'datetime'));

				if (isset($val['type']) && $val['type'] == 'int')
				{
					if (isset($val['float']))
					{
						if ($val['float'] === 1)
						{
							if (isset($val['currency'])) $_POST[$relname] = round($_POST[$relname], 2);
							$_POST[$relname] = str_replace(',', '.', $_POST[$relname]);
						}
					}
					else
					{
						$_POST[$relname] = intval($_POST[$relname]);
					}
				}
				
				if (isset($val['type']) && $val['type'] == 'ip')
				{
					$_POST[$relname] = ip2long($_POST[$relname]);
				}

				if (mod_checkrelvalid($val, $relname, $data->sql, $data, false))
				{
					$noaddsql = 1;
					break;
				}

				if (isset($val['nodual']) && $val['nodual'] !== false)
				{
					$querychk = "SELECT COUNT(*) FROM `$esTable` WHERE `$esIndex` = '" . mysql_escape_string($_POST[$relname]) . "'" . (is_string($val['nodual']) ? " AND $val[nodual]" : '');
					if ($data->savedelete === true)
					{
						$querychk .= " AND (`$esTable`.deleted = 0)";
					}

					if (mysql_result(mod_mysql_querya($querychk, $data->sql), 0))
					{
						$data->mod_errors[] = sprintf($data->mod_inttxt['edit_error_duplicate'], $val['name']);
						$noaddsql = 1;
						break;
					}
				}

				$query[$fieldname][] = '"' . mysql_escape_string(isset($val['type']) && $val['type'] == 'checkbox' ? (isset($_POST[$relname]) ? 1 : 0) : (isset($val['type']) && $val['type'] == 'md5' ? md5($_POST[$relname]) : $_POST[$relname])) . '"';
			}
			foreach ($data->adddefaults as $default)
			{
				$query['mod_sqltable_main'][] = '"' . mysql_escape_string($default) . '"';
			}
			foreach ($data->justadddefaults as $default)
			{
				$query['mod_sqltable_main'][] = '"' . mysql_escape_string($default) . '"';
			}

			if (!isset($noaddsql) && $data->action !== false)
			{
				if (!isset($data->action['type'])) $data->action['type'] = mod_mysql_get_table($data->sqltablename);
				if (($resttime = mod_checkAction($data->action, false, false, $data->sql)) !== true)
				{
					if (isset($data->action['msg'])) $data->mod_errors[] = $data->action['msg'];
					else $data->mod_errors[] = sprintf($data->mod_inttxt['edit_action_wait'], -$resttime);
					$noaddsql = true;
				}
			}

			if (!isset($noaddsql))
			{
				if (($data->sortableadd || $data->sortable === true || is_array($data->sortable)) && $data->sortablelinktable === false)
				{
					$sortpart1 = ', sort';
					$query2 = "SELECT IFNULL(MAX(sort), 0) + 1 FROM `$esTable`";
					$sortpart2 = ', ' . mysql_result(mod_mysql_querya($query2, $data->sql), 0);
				}
				else
				{
					$sortpart1 = $sortpart2 = '';
				}

				$date = array();
				if ($data->adddate)
				{
					$date['timestamp'] = time();
				}
				if ($data->addchange)
				{
					$date['changed'] = time();
				}

				$fields['mod_sqltable_main'] = array_merge($fields['mod_sqltable_main'], array_keys($data->adddefaults), array_keys($data->justadddefaults), array_keys($date));

				$autodefaultpart = array();
				if ($data->autodefaults)
				{
					foreach ($fields as $fieldautoname => $fieldautoval)
					{
						$autodefaultpart[$fieldautoname] = '';
						$tmpquery = "DESCRIBE `" . ($fieldautoname == 'mod_sqltable_main' ? $esTable : mysql_escape_string(isset($data->subtables[$fieldautoname]['tablename']) ? $data->subtables[$fieldautoname]['tablename'] : $fieldautoname)) . "`";
						$result = mod_mysql_querya($tmpquery, $data->sql);
						while ($tmp = mysql_fetch_assoc($result))
						{
							if (strtolower($tmp['Field']) != 'id' &&
								!(($data->sortable === true || is_array($data->sortable)) && $tmp['Field'] == 'sort') &&
								!in_array($tmp['Field'], $fields[$fieldautoname]) &&
								(string) $tmp['Default'] == '' &&
								($fieldautoname == 'mod_sqltable_main' || !isset($data->subtables[$fieldautoname]['defaults'][$tmp['Field']]))
							)
							{
								if ($fieldautoname == 'mod_sqltable_main')
								{
									$autodefaultpart[$fieldautoname] .= ',' . (strpos($tmp['Type'], 'int') !== false ? '0' : '""');
								}
								else
								{
									$query[$fieldautoname][] = strpos($tmp['Type'], 'int') !== false ? '0' : '""';
								}
								$fields[$fieldautoname][] = $tmp['Field'];
							}
						}
					}
				}
				$fields = mod_escapeArray($fields, '`', 'mysql_escape_string');
				$querydo = "INSERT INTO `$esTable` (" . implode(',', $fields['mod_sqltable_main']) . " $sortpart1) VALUES (" . implode(',', array_merge($query['mod_sqltable_main'], array_values($date))) . " $autodefaultpart[mod_sqltable_main] $sortpart2)";
				mod_mysql_querya($querydo, $data->sql);
				$tmp_id = mysql_insert_id($data->sql);

				$querygettmp = "SELECT * FROM `$esTable` WHERE id = $tmp_id";
				$tmp = mysql_fetch_assoc(mod_mysql_querya($querygettmp, $data->sql));

				foreach ($fields as $fieldname => $fieldvar)
				{
					if ($fieldname != 'mod_sqltable_main')
					{
						$setquery = array();
						foreach ($fieldvar as $fieldindex => $fieldname2)
						{
							$setquery[] = $fieldname2 . ' = ' . $query[$fieldname][$fieldindex];
						}
						mod_sqledit_subtables($tmp_id, $fieldname, $setquery, $data->subtables[$fieldname], $data, $tmp, false);
					}
				}

				if (isset($mod_add_requiresqllink))
				{
					if (mod_CreateSqlEdit_sqllink($data, $dwEditInstance, $tmp_id) === -1)
					{
						$createok = -1;
						$data->mod_errors[] = 'Internal error';
					}
				}

				if ((!isset($createok) || $createok != -1) && $data->createcallback !== false)
				{
					$createok = mod_call_user_func($data->createcallback, $tmp_id);
				}
				if (isset($createok) && $createok == -1)
				{
					if (isset($mod_add_requiresqllink))
					{
						mod_CreateSqlEdit_sqllink($data, $dwEditInstance, $tmp_id, true, false);
					}

					$query = "DELETE FROM `$esTable` WHERE id = $tmp_id";
					mod_mysql_querya($query, $data->sql);
				}
				else
				{
					foreach ($data->relations as $index => $val)
					{
						if (isset($val['type']) && $val['type'] == 'file' && isset($val['storage']))
						{
							$relname = "mod_sql-$dwEditInstance-$index";
							if (substr($val['storage'], -1) != '/') $val['storage'] .= '/';
							if (isset($_FILES[$relname]['error']) && $_FILES[$relname]['error'] == 0)
							{
								if (file_exists($val['storage'] . $tmp_id))
								{
									unlink($val['storage'] . $tmp_id);
								}
								move_uploaded_file($_FILES[$relname]['tmp_name'], $val['storage'] . $tmp_id);
							}
						}
					}
					if ($data->changes !== false && $data->changetype === 1)
					{
						mod_addChange(mod_mysql_get_table($data->sqltablename), $tmp_id, $data->changes, false, $data->sql, $_REQUEST["mod_sql-$dwEditInstance-$data->changes"]);
					}
					if ($data->mod_redir_changes || count($data->afterchange))
					{
						$_REQUEST["mod_sqleditmsg-$dwEditInstance"] = serialize(array_merge($mod_msg, $data->mod_errors));
						$_REQUEST += $data->afterchange;
						mod_redir_changes(array("mod_sql-$dwEditInstance-", 'mod_addsql'));
					}
				}
			}
		}

		if ($data->editable && !$data->viewable && isset($_POST['mod_editsqlsave']) && $_POST['mod_editsqlsave'] == $dwEditInstance && isset($_POST['mod_editsqlsave2']) && ($data->forceedit === false || $data->forceedit == $_POST['mod_editsqlsave2']))
		{
			$query = array();
			$filenames = array();
			$chkquery = "SELECT COUNT(*) FROM `$esTable` $data->sqljoin WHERE `$esTable`.id = " . intval($_POST['mod_editsqlsave2']) . " AND ($data->sqlwhere)";
			if ($data->editable !== true)
			{
				$chkquery .= " AND ($data->editable)";
			}
			if ($data->savedelete === true)
			{
				$chkquery .= " AND (`$esTable`.deleted = 0)";
			}
			if (mysql_result(mod_mysql_querya($chkquery, $data->sql), 0) == 0)
			{
				$noeditsql = 1;
			}
			else
			{
				if ($data->postcallback !== false) call_user_func($data->postcallback, "mod_sql-$dwEditInstance-", true);
				foreach ($data->relations as $index => $val)
				{
					$relname = "mod_sql-$dwEditInstance-$index";

					$retVal = mod_sqledit_check_addedit($data, $index, $val, true, $relname);

					$fieldname = isset($val['subtable']) ? $val['subtable']	: 'mod_sqltable_main';

					$realindex = isset($val['fieldname']) ? $val['fieldname'] : $index;
					$esIndex = mysql_escape_string($realindex);

					if ($retVal === false) continue;
					if ($retVal !== true)
					{
						$data->mod_errors[] = $retVal;
						$noeditsql = 1;
						break;
					}

					if (mod_sqledit_update_checkrel($val, true))
					{
						continue;
					}
					if (isset($val['editable']) && $val['editable'] !== true)
					{
						if (is_string($val['editable']))
						{
							if (mysql_result(mod_mysql_querya($chkquery . " AND $val[editable]", $data->sql), 0) == 0) continue;
						}
						else
						{
							continue;
						}
					}
					if (isset($val['type']) && $val['type'] == 'hidden' && !in_array($index, $filenames))
					{
						continue;
					}
					if (isset($val['foldempty']) && $val['foldempty'] && !isset($_POST[$relname]))
					{
						$_POST[$relname] = '';
					}
					if (isset($val['pw']) && $val['pw'] == 2 && $_POST[$relname . '_confirm'] != $_POST[$relname])
					{
						$data->mod_errors[] = $data->mod_inttxt['edit_error_pwmatch'];
						$noeditsql = 1;
						break;
					}
					if (isset($val['type']) && $val['type'] == 'md5')
					{
						if ($_POST[$relname] == '')
						{
							continue;
						}
						$_POST[$relname] = md5($_POST[$relname]);
					}
					if (isset($val['sqllink']) || (isset($val['type']) && $val['type'] == 'table'))
					{
						$mod_edit_requiresqllink = true;
						continue;
					}

					if (isset($val['type']) && $val['type'] == 'file')
					{
						if ((!isset($val['filename']) || (isset($val['force']) && $val['force'] === false)) && isset($_POST[$relname . '_delete']))
						{
							$_POST[$relname] = '';
							if (isset($val['filename']))
							{
								$_POST["mod_sql-$dwEditInstance-$val[filename]"] = '';
								$filenames[] = $val['filename'];
							}
						}
						else if (isset($_FILES[$relname]['error']) && $_FILES[$relname]['error'] == 0 && $_FILES[$relname]['size'] <= mod_sqledit_filesize($val))
						{
							$_POST[$relname] = file_get_contents($_FILES[$relname]['tmp_name']);

							if (isset($val['filename']))
							{
								$_POST["mod_sql-$dwEditInstance-$val[filename]"] = $_FILES[$relname]['name'];
								$filenames[] = $val['filename'];
							}
						}
						else
						{
							if (isset($FILES[$relname]['size']) && $_FILES[$relname]['size'] > mod_sqledit_filesize($val)) $data->mod_errors[] = sprintf($data->mod_inttxt['edit_error_filesize'], mod_sqledit_filesize($val));
							continue;
						}
						if (isset($val['storage'])) continue;
					}

					if (isset($val['type']) && ($val['type'] == 'date' || $val['type'] == 'datetime')) mod_getDate($_POST[$relname], ($val['type'] == 'datetime'));
					if (isset($val['type']) && $val['type'] == 'int')
					{
						if (isset($val['float']))
						{
							if ($val['float'] === 1)
							{
								if (isset($val['currency'])) $_POST[$relname] = round($_POST[$relname], 2);
								$_POST[$relname] = str_replace(',', '.', $_POST[$relname]);
							}
						}
						else
						{
							$_POST[$relname] = intval($_POST[$relname]);
						}
					}
					
					if (isset($val['type']) && $val['type'] == 'ip')
					{
						$_POST[$relname] = ip2long($_POST[$relname]);
					}

					if (isset($val['nodual']) && $val['nodual'] !== false)
					{
						$querychk = "SELECT COUNT(*) FROM `$esTable` WHERE `$esIndex` = '" . mysql_escape_string($_POST[$relname]) . "' AND id != " . intval($_POST['mod_editsqlsave2'] . (is_string($val['nodual']) ? " AND $val[nodual]" : ''));
						if ($data->savedelete === true)
						{
							$querychk .= " AND (`$esTable`.deleted = 0)";
						}

						if (mysql_result(mod_mysql_querya($querychk, $data->sql), 0))
						{
							$data->mod_errors[] = sprintf($data->mod_inttxt['edit_error_duplicate'], $val['name']);
							$noeditsql = 1;
							break;
						}
					}

					if (mod_checkrelvalid($val, $relname, $data->sql, $data, true))
					{
						$noeditsql = 1;
						break;
					}

					$query[$fieldname][] = '`' . mysql_escape_string($realindex) . "` = '" . mysql_escape_string(isset($val['type']) && $val['type'] == 'checkbox' ? (isset($_POST[$relname]) ? 1 : 0) : $_POST[$relname]) . "'";
				}
				if ($data->addchange)
				{
					$query['mod_sqltable_main'][] = 'changed = ' . time();
				}
				else if ($data->adddate === true)
				{
					$query['mod_sqltable_main'][] = 'timestamp = ' . time();
				}
			}

			if (isset($noeditsql))
			{
				$_REQUEST["mod_editsql$dwEditInstance"] = $_REQUEST['mod_editsqlsave2'];
			}
			else
			{
				if (count($query))
				{
					if ($data->changes !== false)
					{
						mod_addChange(mod_mysql_get_table($data->sqltablename), intval($_POST['mod_editsqlsave2']), $data->changes, false, $data->sql, $_REQUEST["mod_sql-$dwEditInstance-$data->changes"], $data->changetype === 2);
					}
					$querygettmp = "SELECT * FROM `$esTable` WHERE id = " . intval($_POST['mod_editsqlsave2']);
					$tmp = mysql_fetch_assoc(mod_mysql_querya($querygettmp, $data->sql));
					if (count($query['mod_sqltable_main']))
					{
						$querydo = "UPDATE `$esTable` SET " . implode(',', $query['mod_sqltable_main']) . " WHERE id = " . ($tmp_id = intval($_POST['mod_editsqlsave2']));
						mod_mysql_querya($querydo, $data->sql);
					}
					$tmp2 = mysql_fetch_assoc(mod_mysql_querya($querygettmp, $data->sql));
					foreach ($query as $fieldname => $setquery)
					{
						if ($fieldname != 'mod_sqltable_main')
						{
							mod_sqledit_subtables($tmp_id, $fieldname, $setquery, $data->subtables[$fieldname], $data, $tmp, $tmp2);
						}
					}
				}

				if (isset($mod_edit_requiresqllink))
				{
					if (mod_CreateSqlEdit_sqllink($data, $dwEditInstance, $_POST['mod_editsqlsave2'], true) === -1)
					{
						$data->mod_errors[] = 'Internal error';
					}
				}

				foreach ($data->relations as $index => $val)
				{
					if (isset($val['type']) && $val['type'] == 'file' && isset($val['storage']))
					{
						$relname = "mod_sql-$dwEditInstance-$index";
						if (substr($val['storage'], -1) != '/') $val['storage'] .= '/';
						if ((($ul_ok = (isset($_FILES[$relname]['error']) && $_FILES[$relname]['error'] == 0 && $_FILES[$relname]['size'] <= mod_sqledit_filesize($val))) || isset($_POST[$relname . '_delete'])))
						{
							if (file_exists($val['storage'] . intval($_POST['mod_editsqlsave2'])))
							{
								unlink($val['storage'] . intval($_POST['mod_editsqlsave2']));
							}
							if ($ul_ok)
							{
								move_uploaded_file($_FILES[$relname]['tmp_name'], $val['storage'] . intval($_POST['mod_editsqlsave2']));
							}
						}
						if (!isset($_POST[$relname . '_delete']) && isset($_FILES[$relname]['size']) && $_FILES[$relname]['size'] > mod_sqledit_filesize($val))
						{
							$data->mod_errors[] = sprintf($data->mod_inttxt['edit_error_filesize'], mod_sqledit_filesize($val));
						}
					}
				}

				if ($data->editcallback !== false)
				{
					mod_call_user_func($data->editcallback, intval($_POST['mod_editsqlsave2']));
				}
				if ($data->mod_redir_changes || count($data->afterchange))
				{
					$_REQUEST["mod_sqleditmsg-$dwEditInstance"] = serialize(array_merge($mod_msg, $data->mod_errors));
					$_REQUEST += $data->afterchange;
					mod_redir_changes(array("mod_sql-$dwEditInstance-", 'mod_editsqlsave', "mod_editsql$dwEditInstance"));
				}
			}
		}

		if ($data->deleteable && isset($_GET['mod_delsql']) && isset($_GET['mod_delsql2']) && $_GET['mod_delsql'] == $dwEditInstance && $data->forceedit === false)
		{
			$chkquery = "SELECT COUNT(*) FROM `$esTable` $data->sqljoin WHERE `$esTable`.id = " . intval($_GET['mod_delsql2']) . " AND ($data->sqlwhere)";
			if ($data->deleteable !== true)
			{
				$chkquery .= " AND ($data->deleteable)";
			}
			if ($data->savedelete === true)
			{
				$chkquery .= " AND (`$esTable`.deleted = 0)";
			}

			if (mysql_result(mod_mysql_querya($chkquery, $data->sql), 0))
			{
				if ($data->deletecallback)
				{
					$deleteok = mod_call_user_func($data->deletecallback, intval($_GET['mod_delsql2']));
				}
				if (!isset($deleteok) || $deleteok != -1)
				{
					if ($data->savedelete === true)
					{
						$query = "UPDATE `$esTable` SET deleted = " . ($userdata['id'] != 0 ? $userdata['id'] : -1) . " WHERE id = " . intval($_GET['mod_delsql2']);
					}
					else
					{
						$query = "SELECT * FROM `$esTable` WHERE id = " . intval($_GET['mod_delsql2']);
						$tmp = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));
						foreach ($data->subtables as $subtablename => $subtablevar)
						{
							$esRealSubTable = mysql_escape_string(isset($data->subtables[$subtablename]['tablename']) ? $data->subtables[$subtablename]['tablename'] : $subtablename);

							$esId = mysql_escape_string($subtablevar['id']);
							$where = array();
							if (isset($subtablevar['type']) && $subtablevar['type'] == 'reverse')
							{
								if (isset($subtablevar['idtable'])) trigger_error('Unsupported operation', E_USER_ERROR);
								$where[] = "id = " . $tmp[$subtablevar['id']];
							}
							else
							{
								$where[] = "`$esId` = " . intval($_GET['delsql2']);
							}
							if (isset($subtablevar['defaults']))
							{
								foreach ($subtablevar['defaults'] as $defname => $defvar)
								{
									$where[] = '`' . mysql_escape_string($defname) . '` = "' . mysql_escape_string($defvar) . '"';
								}
							}
							$query = "DELETE FROM `$esRealSubTable` WHERE " . implode(' AND ', $where);
							mod_mysql_querya($query, $data->sql);
						}

						$query = "DELETE FROM `$esTable` WHERE ($data->sqlwhere) AND id = " . intval($_GET['mod_delsql2']);

						foreach ($data->relations as $index => $val)
						{
							if (isset($val['type']) && $val['type'] == 'file' && isset($val['storage']))
							{
								$relname = "mod_sql-$dwEditInstance-$index";
								if (substr($val['storage'], -1) != '/') $val['storage'] .= '/';
								if (file_exists($val['storage'] . intval($_GET['mod_delsql2'])))
								{
									unlink($val['storage'] . intval($_GET['mod_delsql2']));
								}
							}
						}
					}
					mod_mysql_querya($query, $data->sql);
					if ($data->mod_redir_changes || count($data->afterchange))
					{
						$_REQUEST["mod_sqleditmsg-$dwEditInstance"] = serialize(array_merge($mod_msg, $data->mod_errors));
						$_REQUEST += $data->afterchange;
						mod_redir_changes(array('mod_delsql'));
					}
				}
			}
		}

		if (($data->sortable === true || is_array($data->sortable)) && $data->forceedit === false && isset($_GET['mod_movesql']) && ((isset($_GET['mod_upsql']) && $_GET['mod_upsql'] == $dwEditInstance) || (isset($_GET['mod_downsql']) && $_GET['mod_downsql'] == $dwEditInstance)))
		{
			$chkquery = "SELECT COUNT(*) FROM `$esTable` $data->sqljoin WHERE `$esTable`.id = " . intval($_GET['mod_movesql']) . " AND ($data->sqlwhere)";
			if (is_array($data->sortable))
			{
				$chkquery .= " AND (" . $data->sortable[0] . ")";
			}
			if ($data->savedelete === true)
			{
				$chkquery .= " AND (`$esTable`.deleted = 0)";
			}

			if (mysql_result(mod_mysql_querya($chkquery, $data->sql), 0))
			{
				if (isset($_GET['mod_upsql']))
				{
					$compare1 = '<';
					$compare2 = 'DESC';
				}
				else
				{
					$compare1 = '>';
					$compare2 = 'ASC';
				}

				if ($data->sortablelinktable !== false)
				{
					$esSortTable = mysql_escape_string($data->sortablelinktable);
					$sortWhere = $sortWhereId = array();
					foreach ($data->sortablelinkdefaults as $linkname => $linkval)
					{
						$sortTmp = '`' . mysql_escape_string($linkname) . '` = "' . mysql_escape_string(str_replace('[ID]', intval($_GET['mod_movesql']), $linkval)) . '"';
						if (strpos($linkval, '[ID]') !== false) $sortWhereId[] = $sortTmp; else $sortWhere[] = $sortTmp;
					}
					$sortWhere = implode(' AND ', $sortWhere);
					$sortWhereId = implode(' AND ', $sortWhereId);
				}
				else
				{
					$esSortTable = $esTable;
					$sortWhere = $data->sqlwhere;
					$sortWhereId = 'id = ' . intval($_GET['mod_movesql']);
				}

				$query = "SELECT " . implode(',', mod_EscapeArray(array_merge(array('id', 'sort'), $data->sqlsortwhere), '`', 'mysql_escape_string')) . " FROM `$esSortTable` WHERE ($sortWhere) AND " . $sortWhereId;
				$tmp = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));

				if (count($data->sqlsortwhere))
				{
					$dirpart = array();
					foreach ($data->sqlsortwhere as $where)
					{
						$dirpart[] = '`' . mysql_escape_string($where) . '` = "' . mysql_escape_string($tmp[$where]) . '"';
					}
					$dirpart = ' AND ' . implode(' AND ', $dirpart);
				}
				else
				{
					$dirpart = '';
				}

				$query = "SELECT id, sort FROM `$esSortTable` WHERE sort $compare1 $tmp[sort] AND ($sortWhere) $dirpart ORDER BY sort $compare2";
				$result = mod_mysql_querya($query, $data->sql);
				if (mysql_num_rows($result))
				{
					$tmp2 = mysql_fetch_assoc($result);

					$query = "UPDATE `$esSortTable` SET sort = $tmp[sort] WHERE id = $tmp2[id]";
					mod_mysql_querya($query, $data->sql);
			
					$query = "UPDATE `$esSortTable` SET sort = $tmp2[sort] WHERE id = $tmp[id]";
					mod_mysql_querya($query, $data->sql);
				}
				mysql_free_result($result);

				if ($data->mod_redir_changes || count($data->afterchange))
				{
					$_REQUEST["mod_sqleditmsg-$dwEditInstance"] = serialize(array_merge($mod_msg, $data->mod_errors));
					$_REQUEST += $data->afterchange;
					mod_redir_changes(array('mod_upsql', 'mod_movesql'));
				}
			}
		}

		if ($data->copyable !== false && $data->forceedit === false && isset($_GET["mod_editsqlcopy$dwEditInstance"]) && isset($_GET["mod_editsqlcopytype$dwEditInstance"]) && count($data->copyable) > max(0, $tmp_copytype = intval($_GET["mod_editsqlcopytype$dwEditInstance"])))
		{
			$chkquery = "SELECT `$esTable`.* FROM `$esTable` $data->sqljoin WHERE `$esTable`.id = " . ($tmp_copyid = intval($_GET["mod_editsqlcopy$dwEditInstance"])) . " AND ($data->sqlwhere)";
			if ($data->editable !== true && $data->editable !== false)
			{
				$chkquery .= " AND ($data->editable)";
			}
			if ($data->savedelete === true)
			{
				$chkquery .= " AND (`$esTable`.deleted = 0)";
			}
			$result = mod_mysql_querya($chkquery, $data->sql);
			if (mysql_num_rows($result))
			{
				$tmp = mysql_fetch_assoc($result);
				mysql_free_result($result);
				unset($tmp['id']);
				if ($data->addchange)
				{
					$tmp['changed'] = time();
				}
				else if ($data->adddate)
				{
					$tmp['timestamp'] = time();
				}

				if ($data->namefield !== false)
				{
					$tmp_namefield = $data->namefield;
				}
				else if (isset($tmp['name']))
				{
					$tmp_namefield = 'name';
				}

				if ($tmp_namefield !== false)
				{
					$tmp[$tmp_namefield] = sprintf($data->mod_inttxt['edit_copy_of'], $tmp[$tmp_namefield]);
				}

				foreach ($data->copyable[$tmp_copytype] as $field => $value)
				{
					if (isset($tmp[$field])) $tmp[$field] = $value;
				}

				$query = "INSERT INTO `$esTable` " . mod_sql_insert_array($tmp);
				mod_mysql_querya($query, $data->sql);
				$tmp_newid = mysql_insert_id($data->sql);

				foreach ($data->relations as $relname => $relation)
				{
					if (mod_sqledit_update_checkrel($relation, -1)) continue;
					if (isset($data->copyable[$tmp_copytype][$relname])) continue;

					if (isset($relation['type']) && $relation['type'] == 'file' && isset($relation['storage']))
					{
						if (substr($relation['storage'], -1) != '/') $relation['storage'] .= '/';
						if (file_exists($relation['storage'] . $tmp_copyid))
						{
							copy($relation['storage'] . $tmp_copyid, $relation['storage'] . $tmp_newid);
						}
					}
					else if (($tmp_tabletype = (isset($relation['type']) && $relation['type'] == 'table')) || isset($relation['sqllink']))
					{
						$tmp_subtable = $tmp_tabletype ? $relation['tablesqltable'] : $relation['sqllink'];
						$tmp_defaults = $tmp_tabletype ? $relation['tableconstants'] : $relation['sqllinkdata'];
						$tmp_where = array();
						$tmp_merge = array();
						foreach ($tmp_defaults as $index => $val)
						{
							if (strpos($val, '[LINK') === 0)
							{
								continue;
							}
							else if ($val == '[ID]')
							{
								$tmp_where[] = '`' . mysql_escape_string($index) . "` = $tmp_copyid";
								$tmp_merge[$index] = $tmp_newid;
							}
							else
							{
								$tmp_where[] = '`' . mysql_escape_string($index) . '` = "' . mysql_escape_string($val) . '"';
							}
						}
						$esSubtable = mysql_escape_string($tmp_subtable);
						$query = "SELECT * FROM `$esSubtable` WHERE " . implode(' AND ', $tmp_where);
						$result = mod_mysql_querya($query, $data->sql);
						while ($tmp2 = mysql_fetch_assoc($result))
						{
							$tmp2 = array_merge($tmp2, $tmp_merge);
							unset($tmp2['id']);
							$query = "INSERT INTO `$esSubtable` " . mod_sql_insert_array($tmp2);
							mod_mysql_querya($query, $data->sql);
						}
						mysql_free_result($result);
					}
				}
				if ($data->copycallback !== false)
				{
					call_user_func($data->copycallback, $tmp_newid);
				}

				if ($data->mod_redir_changes || count($data->afterchange))
				{
					$_REQUEST["mod_sqleditmsg-$dwEditInstance"] = serialize(array_merge($mod_msg, $data->mod_errors));
					$_REQUEST += $data->afterchange;
					mod_redir_changes(array('mod_editsqlcopy', 'mod_editsqlcopytype'));
				}
			}
			else
			{
				mysql_free_result($result);
			}
		}
	}
}

function mod_sqledit_create_table(&$data)
{
	global $dwEditInstance, $userdata, $mod_txt, $mod_dwHtmlEditInstance, $mod_msg;

	$esTable = mod_mysql_escape_table($data->sqltablename);
	if ($data->showtable !== false)
	{
		if (strpos($data->defaultlink, '?') === false)
		{
			$lac = '?';
		}
		else
		{
			$lac = '&';
		}

		$mod_needjoin = '';

		if (is_int($data->showtable))
		{
			$tmp_javastart = "JavaScript:if (document.getElementsByName(\\'mod_sqledit_dropdown_$dwEditInstance\\')[0].value > 0)";
			$tmp_javapre = "$tmp_javastart document.location.href=\\'";
			$tmp_javareplace = ".replace(/mod_tmp_id/, document.getElementsByName(\\'mod_sqledit_dropdown_$dwEditInstance\\')[0].value)";
			$tmp_javapost = "\\'$tmp_javareplace;";
			$tmp_id = "'mod_tmp_id'";
		}
		else
		{
			$tmp_javapre = $tmp_javapost = $tmp_javareplace = '';
			$tmp_id = "`$esTable`.id";
			$tmp_javastart = 'JavaScript:';
		}

		$functionsa = array();
		if ($data->editable !== false || $data->viewable !== false)
		{
			$funceditlink = "$tmp_javapre" . mysql_escape_string($data->defaultlink) . $lac . "mod_editsql$dwEditInstance=', $tmp_id, '" . ($data->nojump === true ? '' : "#mod_sqledit$dwEditInstance") . "$tmp_javapost";
			$funcedit = "CONCAT('<a href=\"$funceditlink\">" . mysql_escape_string($data->mod_inttxt[$data->viewable ? 'edit_view' : 'edit_edit']) . "</a>&nbsp;')";
			if (is_string($data->editable))
			{
				$funcedit = "IF($data->editable, $funcedit, '<font style=\"visibility:hidden;\">" . mysql_escape_string($data->mod_inttxt['edit_edit']) . " </font>')";
			}
			$functionsa['edit'] = $funcedit;
		}
		if ($data->deleteable !== false)
		{
			if ($data->askdelete)
			{
				$onClick = "href=\"$tmp_javastart mod_askhref(\\'\\', \\'" . mysql_escape_string(htmlspecialchars(AddSlashes($data->defaultlink))) . $lac . "mod_delsql=$dwEditInstance&mod_delsql2=', $tmp_id, '" . ($data->nojump ? '' : "#mod_sqledita$dwEditInstance") . "\\'$tmp_javareplace);\"";
			}
			else
			{
				$onClick = "href=\"$tmp_javapre" . mysql_escape_string($data->defaultlink) . $lac . "mod_delsql=$dwEditInstance&mod_delsql2=', $tmp_id, '" . ($data->nojump ? '' : "#mod_sqledita$dwEditInstance") . "$tmp_javapost\"";
			}
			$funcdel = "CONCAT('<a $onClick>" . mysql_escape_string($data->mod_inttxt['edit_delete']) . "</a>&nbsp;')";
			if ($data->deleteable !== true)
			{
				$funcdel = "IF($data->deleteable, $funcdel, '<font style=\"visibility:hidden;\">" . mysql_escape_string($data->mod_inttxt['edit_delete']) . " </font>')";
			}
			$functionsa['delete'] = $funcdel;
		}
		if ($data->sortable === false && $data->adddate)
		{
			$data->sortable = "`$esTable`." . ($data->addchange ? 'changes' : 'timestamp') . ' DESC';
		}

		if ($data->sortable === true || is_array($data->sortable))
		{
			$functionsa['up'] = "'<a href=\"$tmp_javapre" . mysql_escape_string($data->defaultlink) . $lac . "mod_upsql=$dwEditInstance&mod_movesql=', $tmp_id, '" . ($data->nojump === true ? '' : "#mod_sqledita$dwEditInstance") . "$tmp_javapost\">" . mysql_escape_string($data->mod_inttxt['edit_up']) . "</a>&nbsp;'";
			$functionsa['down'] = "'<a href=\"$tmp_javapre" . mysql_escape_string($data->defaultlink) . $lac . "mod_downsql=$dwEditInstance&mod_movesql=', $tmp_id, '" . ($data->nojump === true ? '' : "#mod_sqledita$dwEditInstance") . "$tmp_javapost\">" . mysql_escape_string($data->mod_inttxt['edit_down']) . "</a>'";
			if (is_array($data->sortable))
			{
				$functionsa['up'] = 'IF(' . $data->sortable[0] . ",CONCAT($functionsa[up]), '<font style=\"visibility:hidden;\">" . mysql_escape_string($data->mod_inttxt['edit_up']) . " </font>')";
				$functionsa['down'] = 'IF(' . $data->sortable[0] . ",CONCAT($functionsa[down]), '<font style=\"visibility:hidden;\">" . mysql_escape_string($data->mod_inttxt['edit_down']) . " </font>')";
			}
		}

		if ($data->copyable !== false && count($data->copyable))
		{
			$functionsa['copy'] = array();
			$i = 0;
			foreach ($data->copyable as $index => $val)
			{
				$functionsa['copy'][] = "'<a href=\"$tmp_javapre" . mysql_escape_string($data->defaultlink) . $lac . "mod_editsqlcopytype$dwEditInstance=$i&mod_editsqlcopy$dwEditInstance=', $tmp_id, '" . ($data->nojump === true ? '' : "#mod_sqledita$dwEditInstance") . "$tmp_javapost\">" . mysql_escape_string(is_string($index) ? $index : $data->mod_inttxt['edit_copy']) . "</a>'";
				$i++;
			}
			$functionsa['copy'] = implode(',"' . mysql_escape_string($data->functionseperator) . "\",\n", $functionsa['copy']);
		}

		if (count($functionsa))
		{
			$functions = "CONCAT(" . implode(',"' . mysql_escape_string($data->functionseperator) . '",', $functionsa) . ')';
		}
		else
		{
			$functions = '""';
		}

		$query = array();
		if ($data->sqlselect === false && $data->subedit !== true)
		{
			foreach ($data->relations as $index => $relation)
			{
				$esIndex = mysql_escape_string(isset($relation['fieldname']) ? $relation['fieldname'] : $index);
				$esUseTable = isset($relation['subtable']) ? mysql_escape_string($relation['subtable']) : $esTable;
				if (
					(!isset($relation['sql']) || $relation['sql'] === false) &&
					(
						(isset($relation['type']) && ($relation['type'] == 'table' || $relation['type'] == 'list')) ||
						(isset($relation['sqllink'])) ||
						(isset($relation['storage'])) ||
						(isset($relation['admin']) && ($relation['admin'] === true || $relation['admin'] === false) && $relation['admin'] != $data->admin) ||
						($data->autohide && (!isset($relation['type']) || $relation['type'] != 'virtual') && (!isset($relation['hide']) || $relation['hide'] != false)) ||
						(isset($relation['multipleinstance']))
					)
				)
				{
					$relation['hide'] = true;
				}
				if (isset($relation['hide']) && $relation['hide'] === true)
				{
					continue;
				}
				if (isset($relation['link']))
				{
					$linkpart1 = "CONCAT('<a " . (isset($relation['linktarget']) ? mysql_escape_string("target='$relation[linktarget]' ") : '') . "href=\"" . str_ireplace('[ID]', "',`$esTable`.id,'", mysql_escape_string($relation['link'])) . '">\',';
					$linkpart2 = ',\'</a>\')';
				}
				else
				{
					$linkpart1 = $linkpart2 = '';
				}

				if (isset($relation['admin']) && is_string($relation['admin']) && !$data->admin) $relation['sql'] = $relation['admin'];
				if (isset($relation['sql']))
				{
					if ($relation['sql'] === true AND isset($relation['appendform']))
					{
						$querytmp = "CONCAT(`$esUseTable`.`$esIndex`, ' " . mysql_escape_string($relation['appendform']) . "')";
					}
					else
					{
						$querytmp = (array_key_exists($index, $data->functions) ? str_replace($data->functions[$index], $functions, $relation['sql']) : $relation['sql']);
					}
				}
				else if (isset($relation['type']) && ($relation['type'] == 'date' || $relation['type'] == 'datetime'))
				{
					$querytmp = "DATE_FORMAT(FROM_UNIXTIME(`$esUseTable`.`$esIndex`), '" . ($relation['type'] == 'datetime' ? $data->dateformat : $data->dateonlyformat) . "')";
				}
				else if (isset($relation['type']) && $relation['type'] == 'select' && (!isset($relation['autosql']) || $relation['autosql'] !== false) && (is_array($relation['options']) || (($tmp = stripos($relation['options'], 'select')) !== false && $tmp < 2)))
				{
					if (is_string($relation['options']))
					{
						$tmpTable = mysql_escape_string("mod_tmp_$index");
						$tmpselquery = $relation['options'];
						if (isset($relation['zeroopt'])) $tmpselquery = "(SELECT 0 AS id, '" . mysql_escape_string($relation['zeroopt']) . "' AS name) UNION ($tmpselquery)";

						$mod_needjoin .= "LEFT JOIN ($tmpselquery) AS `$tmpTable` ON `$tmpTable`.id = `$esUseTable`.`$esIndex`";
						$querytmp = "`$tmpTable`.name";
					}
					else
					{
						$querytmp = "CASE `$esUseTable`.`$esIndex`";
						foreach($relation['options'] AS $optind => $optval)
						{
							$querytmp .= ' WHEN "' . mysql_escape_string($optind) . '" THEN "' . mysql_escape_string($optval) . '"';
						}
						$querytmp .= ' ELSE "-" END';
					}
				}
				else if (isset($relation['type']) && $relation['type'] == 'checkbox' && (!isset($relation['autosql']) || $relation['autosql'] !== false))
				{
					if (isset($relation['type']) && $relation['type'] === 1)
					{
						$querytmp = "IF(`$esUseTable`.`$esIndex`=0,'-','X')";
					}
					else
					{
						$querytmp = "IF(`$esUseTable`.`$esIndex`=0,'" . mysql_escape_string($data->mod_inttxt['txt_no']) . "', '" . mysql_escape_string($data->mod_inttxt['txt_yes']) . "')";
					}
				}
				else if (isset($relation['cut']))
				{
					$querytmp = "CONCAT(LEFT(`$esUseTable`.`$esIndex`, " . intval($relation['cut']) .
						"), IF(LENGTH(`$esUseTable`.`$esIndex`) > " . intval($relation['cut']) . ",'...',''))";
				}
				else if (isset($relation['type']) && $relation['type'] == 'checkbox' && isset($relation['texts']))
				{
					if ($relation['texts'] === true) $relation['texts'] = array('-', $relation['name']);
					$querytmp = "IF(`$esUseTable`.`$esIndex` = 1,'" . mysql_escape_string($relation['texts'][1]) . "','" . mysql_escape_string($relation['texts'][0]) . "')";
				}
				else if (isset($relation['type']) && $relation['type'] == 'int' && isset($relation['float']) && $relation['float'] === 1)
				{
					$querytmp = "`$esUseTable`.`$esIndex`";
					if (isset($relation['currency']))
					{
						$querytmp = "ROUND($querytmp, 2)";
					}
					$querytmp = "REPLACE($querytmp, '.', ',')";
					if (isset($relation['currency']))
					{
						$querytmp = "CONCAT($querytmp,  '" . ($relation['currency'] == '' ? '' : '&nbsp;') . mysql_escape_string($relation['currency']) . "')";
					}
				}
				else if (isset($relation['type']) && $relation['type'] == 'ip')
				{
					$querytmp = "INET_NTOA(`$esUseTable`.`$esIndex`)";
				}
				else
				{
					$querytmp = "`$esUseTable`.`$esIndex`";
				}
				
				if (isset($relation['showextended'])) $querytmp = "CONCAT($querytmp, ' (', `$esUseTable`.`$esIndex`, ')')";

				if (isset($relation['color']))
				{
					$querytmp = "CONCAT('<font style=\"color:', $relation[color], ';\">', $querytmp, '</font>')";
				}
				$query[] = $linkpart1 . $querytmp . $linkpart2 . ' AS `' . mysql_escape_string($relation['name']) . '`';
			}
			if ($data->addchange)
			{
				$query[] = "CONCAT(IF(changed != 0 AND changed != timestamp,CONCAT('<font size=-2>" . mysql_escape_string($data->mod_inttxt['edit_changed']) . ": ', DATE_FORMAT(FROM_UNIXTIME(`$esTable`.changed), '$data->dateformat'),
					'<br>('),''), DATE_FORMAT(FROM_UNIXTIME(`$esTable`.timestamp), '$data->dateformat'), IF(changed != 0 AND changed != timestamp,')',''), '</font>') AS Date";
			}
			else if ($data->adddate)
			{
				$query[] = "CONCAT('<font size=-2>', DATE_FORMAT(FROM_UNIXTIME(`$esTable`.timestamp), '$data->dateformat'), '</font>') AS 'Date', `$esTable`.timestamp AS sort_Date";
			}
		}
		else
		{
			$query[] = $data->sqlselect;
		}

		if ($data->subedit)
		{
			if ($data->subedit === 3)
			{
				$querysub = $query;
			}
			else
			{
				$querysub = array();
			}
			$querysub[] = "`$esTable`.id";
			$querysub[] = $functions . ' AS `functions`';
		}

		if (is_string($data->showtable) || is_int($data->showtable))
		{
			array_unshift($query, "`$esTable`.id");
		}
		else if (count($data->functions) == 0 && count($functionsa) != 0) $query[] = $functions . ' AS `' . mysql_escape_string($data->mod_inttxt['edit_functions']) . '`';

		if (is_int($data->showtable) && strpos($data->namefield, ' ') !== false)
		{
			$query[] = "$data->namefield AS mod_tmp_namefield";
		}

		if ($data->sortablelinktable !== false)
		{
			$esSortLinkTable = mysql_escape_string($data->sortablelinktable);
			$SortLinkOn = array();
			foreach ($data->sortablelinkdefaults as $linkname => $linkval)
			{
				$SortLinkOn[] = "`$esSortLinkTable`.`" . mysql_escape_string($linkname) . '` = ' . ($linkval == '[ID]' ? "`$esTable`.id" : ('"' . mysql_escape_string($linkval) . '"'));
			}
			$mod_needjoin .= " LEFT JOIN `$esSortLinkTable` ON " . implode(' AND ', $SortLinkOn);
		}
		foreach ($data->subtables as $subtablename => $subtablevar)
		{
			$esSubTable = mysql_escape_string($subtablename);
			$esRealSubTable = isset($data->subtables[$subtablename]['tablename']) ? mysql_escape_string($data->subtables[$subtablename]['tablename']) : $esSubTable;
			$esSubId = mysql_escape_string($subtablevar['id']);
			$subjoin = array("`" . ((($subreverse = (isset($subtablevar['type']) && $subtablevar['type'] == 'reverse')) && isset($subtablevar['idtable'])) ? mysql_escape_string($subtablevar['idtable']) : $esTable) . "`.`" . ($subreverse ? $esSubId : 'id') . "` = `$esSubTable`.`" . ($subreverse ? 'id' : $esSubId) . "`");
			if (isset($subtablevar['defaults']))
			{
				foreach ($subtablevar['defaults'] as $defname => $defvar)
				{
					$subjoin[] = "`$esSubTable`.`" . mysql_escape_string($defname) . '` = "' . mysql_escape_string($defvar) . '"';
				}
			}

			$mod_needjoin .= " LEFT JOIN `$esRealSubTable` AS `$esSubTable` ON " . implode(' AND ', $subjoin);
		}

		if ($data->sortable === false && $data->adddate) $data->sortable = "`$esTable`." . ($data->addchange ? 'changed' : 'timestamp') . ' DESC';

		$query = 'SELECT ' . implode(',', $query) . " FROM `$esTable` $data->sqljoin $mod_needjoin WHERE ($data->sqlwhere)" . ($data->savedelete === true ? " AND `$esTable`.deleted = 0" : '') . " GROUP BY " . ($data->sqlgroup !== false ? $data->sqlgroup : "`$esTable`.id") . ($data->sortable === true ? (" ORDER BY `" . ($data->sortablelinktable === false ? $esTable : $esSortLinkTable) . "`.sort ASC") : (is_string($data->sortable) ? ' ORDER BY ' . $data->sortable : ''));
		if (count($data->mod_errors) == 0) $data->mod_output .= "<a name='mod_sqledita$dwEditInstance'></a>";

		if ($data->subedit)
		{
			$querysub = 'SELECT ' . implode(',', $querysub) . " FROM `$esTable` $data->sqljoin $mod_needjoin WHERE ($data->sqlwhere)" . ($data->savedelete === true ? " AND `$esTable`.deleted = 0" : '') . " GROUP BY " . ($data->sqlgroup !== false && $data->subedit < 2 ? $data->sqlgroup : "`$esTable`.id") . ($data->sortable === true ? " ORDER BY `$esTable`.sort ASC" : (is_string($data->sortable) ? ' ORDER BY ' . $data->sortable : ''));
			$result = mod_mysql_querya($querysub, $data->sql);
			while ($tmp = mysql_fetch_assoc($result))
			{
				$data->mod_subedit[$tmp['id']] = $tmp[$data->subedit === 3 ? $data->mod_inttxt['edit_functions'] : 'functions'];
			}
		}
		
		if ($data->subedit === true);
		else if ($data->showtable === true)
		{
			if (count($data->prelines))
			{
				$prelines = mod_AdeptPrelines($data->prelines, $data->relations, $data);
				$query = array($prelines, $query);
			}

			$table = new table;
			mod_doDefaults($table, $data->tabledata, true);
			if ($data->pagesize) $table->pagesize = $data->pagesize;

			$table->callback = $data->table_callback;
			$table->sql = $data->sql;
			$table->data = $query;
			$table->width = $data->sqleditwidth;
			$table->title = $data->title;
			$table->multi_data = (count($data->prelines) != 0);

			$data->mod_output .= CreateTable($table);
			unset($table);
		}
		else if (is_string($data->showtable))
		{
			if ($data->pagesize > 0 && $data->pages != 0 && $data->pagetype !== 0)
			{
				$querycount = "SELECT COUNT(DISTINCT `$esTable`.id) FROM `$esTable` $data->sqljoin WHERE ($data->sqlwhere)" . ($data->savedelete === true ? " AND `$esTable`.deleted = 0" : '');
				$count = mysql_result(mod_mysql_querya($querycount, $data->sql), 0);
				if ($data->pagecols < 1) $data->pagecols = 1;

				if (is_numeric($data->pagetype) && $data->pagetype > 0 && $data->pagetype < 4 && ($count > $data->pagesize * $data->pagecols || $data->pagetype != 1))
				{

					if (isset($_REQUEST["mod_sql_start$dwEditInstance"]) && $_REQUEST["mod_sql_start$dwEditInstance"] == -1)
					{
						$limittop = 0;
						$limitrows = $count;
						$pagesize = $data->pagetype >= 2 && isset($_REQUEST["mod_sql_rows$dwEditInstance"]) ? intval($_REQUEST["mod_sql_rows$dwEditInstance"]) : $data->pagesize * $data->pagecols;
					}
					else
					{
						$limittop = isset($_REQUEST["mod_sql_start$dwEditInstance"]) ? intval($_REQUEST["mod_sql_start$dwEditInstance"]) : 0;
						$limitrows = $data->pagetype >= 2 && isset($_REQUEST["mod_sql_rows$dwEditInstance"]) ? intval($_REQUEST["mod_sql_rows$dwEditInstance"]) : $data->pagesize * $data->pagecols;
						$pagesize = $limitrows;
					}

					$pagetexts = array();
					if ((intval($data->pagetype) & 2) == 2)
					{
						$pagetext = mod_linkToForm(mod_RemoveURLParam($data->defaultlink, array("mod_sql_start$dwEditInstance", "mod_sql_rows$dwEditInstance")));
						$pagetext .= "<input type='submit' value='" . $data->mod_inttxt['edit_pages_button'] . "'>&nbsp;" . 
						"<input size=3 value='$limitrows' name='mod_sql_rows$dwEditInstance'>&nbsp;" . $data->title . "&nbsp;" . $data->mod_inttxt['edit_pages'] . "&nbsp;<input size=3 value='$limittop' name='mod_sql_start$dwEditInstance'>&nbsp;&nbsp;&nbsp;<i>($count&nbsp;$data->title)</i>" . '</form>';

						$pagetexts[] = $pagetext;
					}

					if ((intval($data->pagetype) & 1) == 1)
					{
						$pagetext = array();
						for ($i = 1;$i <= ceil($count / $pagesize) + 1;$i++)
						{
							$bold = isset($_REQUEST["mod_sql_start$dwEditInstance"]) && intval($_REQUEST["mod_sql_start$dwEditInstance"]) == ($i > ceil($count / $pagesize) ? -1 : (($i - 1) * $pagesize));
							$pagetext[] = "<a href='" . mod_RemoveURLParam($data->defaultlink, array("mod_sql_start$dwEditInstance", "mod_sql_rows$dwEditInstance")) . "&mod_sql_rows$dwEditInstance=$pagesize&mod_sql_start$dwEditInstance=" . ($i > ceil($count / $pagesize) ? -1 : (($i - 1) * $pagesize)) . "'>" . ($bold ? '<b>' : '') . ($i > ceil($count / $pagesize) ? $data->mod_inttxt['java_all'] : $i) . ($bold ? '</b>' : '') . "</a>";
						}
						$pagetexts[] = (count($pagetext) > 1 ? implode('&nbsp;', $pagetext) : '') . ($data->pagetype == 1 ? "&nbsp;&nbsp;&nbsp;<i>($count&nbsp;$data->title)</i>" : '');
					}
					$pagetext = (count($pagetexts) ? '<br>' : '') . implode('', $pagetexts);
				}
				else if (is_string($data->pagetype) || is_array($data->pagetype))
				{
					if (isset($_REQUEST["mod_archive$dwEditInstance"]))
					{
						if (is_string($data->pagetype)) $data->mod_output .= $data->pagetype . '<br>';
						else if (is_array($data->pagetype) && isset($data->pagetype[1])) $data->mod_output .= $data->pagetype[1] . '<br>';
					}
					else if ($count > $data->pagesize * $data->pagecols)
					{
						$limittop = 0;
						$limitrows = $data->pagesize * $data->pagecols;
						$pagetext = "<a href='$data->defaultlink&mod_archive$dwEditInstance'>" . (is_array($data->pagetype) ? $data->pagetype[0] : $data->pagetype) . '</a>';
					}
				}
			}

			$querylimit = isset($limittop) && isset($limitrows) ? " LIMIT $limittop, $limitrows" : '';
			$result = mod_mysql_querya($query . $querylimit, $data->sql);
			if (isset($pagetext) && ($data->pages === true || $data->pages === 1)) $data->mod_output .= $pagetext;
			while ($arrayselect = mysql_fetch_assoc($result))
			{
				$query = "SELECT * FROM `$esTable` WHERE id = $arrayselect[id]";
				$arraytable = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));
				$query = array();
				foreach($functionsa as $index => $val)
				{
					$query[] = "CONCAT($val) AS `$index`";
				}
				if (count($query))
				{
					$query = "SELECT " . implode(',', $query) . " FROM `$esTable` $data->sqljoin WHERE `$esTable`.id = $arrayselect[id]";
					$arrayfunctions = mysql_fetch_assoc(mod_mysql_querya($query, $data->sql));
				}
				else
				{
					$arrayfunctions = array();
				}

				if (!isset($tablefirst)) $tablefirst = true;
				else $tablefirst = false;

				$data->mod_output .= call_user_func($data->showtable, $arraytable, $arrayselect, $arrayfunctions, $tablefirst, $data);
			}
			if (mysql_num_rows($result)) $data->mod_output .= call_user_func($data->showtable, false, false, false, -1, false);
			if (isset($pagetext) && ($data->pages === true || $data->pages === -1)) $data->mod_output .= $pagetext;
		}
		else
		{
			$result = mod_mysql_querya($query, $data->sql);

			echo "<table width=$data->sqleditwidth><tr><td width=1>" . $data->mod_inttxt['sort_search'] . "</td><td><input type=text style='width:$data->sqleditwidth;' onKeyUp='mod_select_search(document.getElementsByName(\"mod_sqledit_dropdown_$dwEditInstance\")[0], this.value)'></td></tr></table>";

			echo "<select ondblclick=\"" . str_ireplace(array('javascript:', "', '"), '', StripSlashes($funceditlink)) . "\" style='width:$data->sqleditwidth;' ". ($data->showtable > 1 ? " size=$data->showtable " : '') . "name='mod_sqledit_dropdown_$dwEditInstance'>";
			while ($tmp = mysql_fetch_assoc($result))
			{
				echo "<option value='$tmp[id]'" . (isset($_REQUEST["mod_editsql$dwEditInstance"]) && $tmp['id'] == $_REQUEST["mod_editsql$dwEditInstance"] ? ' selected' : '') . ">";

				array_shift($tmp);
				if ($data->namefield !== false && strpos($data->namefield, ' ') !== false) echo htmlspecialchars($tmp['mod_tmp_namefield']);
				else if ($data->namefield !== false && isset($tmp[$data->namefield])) echo htmlspecialchars($tmp[$data->namefield]);
				else echo htmlspecialchars(reset($tmp));

				echo '</option>';
			}
			mysql_free_result($result);
			echo '</select><br>';

			$query = "SELECT $functions";
			$result = mod_mysql_querya($query, $data->sql);
			echo mysql_result($result, 0);
			mysql_free_result($result);
		}
	}
}

function mod_sqledit_create_edit(&$data)
{
	global $dwEditInstance, $userdata, $mod_txt, $mod_dwHtmlEditInstance, $mod_msg;

	$esTable = mod_mysql_escape_table($data->sqltablename);
	if (($data->mod_tmpmayedit = (($data->editable || $data->viewable) && isset($_REQUEST["mod_editsql$dwEditInstance"]))) || ($data->addable && (!$data->addbutton || (isset($_REQUEST['mod_addsqlcreate']) && $_REQUEST['mod_addsqlcreate'] == $dwEditInstance))))
	{
		if ($data->addchangebutton !== false)
		{
			if (!is_array($data->addchangebutton)) $data->addchangebutton = array($data->addchangebutton);
			if (isset($data->addchangebutton[0]) && !isset($data->addchangebutton[1])) $data->addchangebutton[1] = $data->addchangebutton[0];
			if (isset($data->addchangebutton[-1]) && !isset($data->addchangebutton[-2])) $data->addchangebutton[-2] = $data->addchangebutton[-1];
		}

		$data->mod_formok = true;
		if (isset($_REQUEST["mod_editsql$dwEditInstance"]))
		{
			$query = '';
			$select = array();
			foreach ($data->subtables as $name => $val)
			{
				$esSubTable = mysql_escape_string($name);
				$esRealSubtable = isset($val['tablename']) ? mysql_escape_string($val['tablename']) : $esSubTable;
				$esId = mysql_escape_string($val['id']);
				$reverse = isset($val['type']) && $val['type'] == 'reverse';
				$query .= " LEFT JOIN `$esRealSubtable` AS `$esSubTable` ON `$esSubTable`.`" . ($reverse ? 'id' : $esId) . "` = `" . ($reverse && isset($val['idtable']) ? mysql_escape_string($val['idtable']) : $esTable) . "`.`" . ($reverse ? $esId : 'id') . '`';
			}
			foreach ($data->relations as $index => $val2)
			{
				if (!isset($val2['multipleinstance'])) $val2 = array($val2);
				foreach ($val2 as $val)
				{
					if (isset($val['subtable']))
					{
						$select[] = '`' . mysql_escape_string($val['subtable']) . '`.' . (isset($val['fieldname']) ? ('`' . mysql_escape_string($val['fieldname']) . '` AS ') : '') . '`' . mysql_escape_string($index) . '`';
					}
				}
			}
			$query = "SELECT `$esTable`.*" . (count($select) ? (',' . implode(',', $select)) : '') . " FROM `$esTable` $data->sqljoin $query WHERE `$esTable`.id = " . intval($_REQUEST["mod_editsql$dwEditInstance"]) . " AND ($data->sqlwhere)";
			if (!is_bool($data->editable))
			{
				$query .= " AND ($data->editable)";
			}
			if ($data->savedelete === true)
			{
				$query .= " AND (`$esTable`.deleted = 0)";
			}

			$result = mod_mysql_querya($query, $data->sql);
			if (mysql_num_rows($result))
			{
				$tmp = mysql_fetch_assoc($result);
			}
			else
			{
				unset($_REQUEST["mod_editsql$dwEditInstance"]);
			}
			mysql_free_result($result);
		}

		if (isset($_REQUEST["mod_editsql$dwEditInstance"]))
		{
			foreach ($data->relations as $index => $val)
			{
				if (isset($val['type']) && $val['type'] == 'md5')
				{
					$tmp[$index] = '';
				}

				if (isset($val['type']) && $val['type'] == 'table')
				{
					$query = "SELECT row, col, text FROM `" . mysql_escape_string($val['tablesqltable']) . "`";
					if (isset($val['tableconstants']))
					{
						$tmpwhere = array();
						foreach ($val['tableconstants'] as $constant => $constval)
						{
							if ($constval == '[ID]')
							{
								$tmpwhere[] = '`' . mysql_escape_string($constant) . '` = ' . intval($_REQUEST["mod_editsql$dwEditInstance"]);
							}
							else
							{
								$tmpwhere[] = '`' . mysql_escape_string($constant) . '` = "' . mysql_escape_string($constval) . '"';
							}
						}
						if (count($tmpwhere)) $query .= ' WHERE ' . implode(' AND ', $tmpwhere);
					}
					$query .= ' ORDER BY row ASC, col ASC';
					$result = mod_mysql_querya($query, $data->sql);
					$usertable = array();
					while ($tmptable = mysql_fetch_assoc($result))
					{
						$usertable[$tmptable['row']][$tmptable['col']] = $tmptable['text'];
					}
					$tmp[$index] = $usertable;
				}
				
				if (isset($val['type']) && $val['type'] == 'int' && isset($val['float']) && $val['float'] === 1)
				{
					if (isset($val['currency']))
					{
						$tmp[$index] = number_format($tmp[$index], 2);
					}
					$tmp[$index] = str_replace('.', ',', $tmp[$index]);
				}
			}

			if (($data->forceedit !== false && $data->forceedit < 0) || ($data->mod_tmpmayedit && $data->viewable))
			{
				$caption = '';
			}
			else
			{
				$caption = sprintf($data->mod_inttxt['edit_title_change'], $data->name);

				if (is_string($data->namefield) && isset($tmp[$data->namefield]) && $tmp[$data->namefield] != '')
				{
					$caption .= ' (' . substr($tmp[$data->namefield], 0, 100) . ')';
				}
			}

			if ($data->addable)
			{
				if ($data->forceedit === false)
				{
					$caption .= '<br>' . mod_CreateSqlEdit_addbutton($data);
				}
			}
			$caption .= "
				<input type='hidden' name='mod_editsqlsave' value='$dwEditInstance'>
				<input type='hidden' name='mod_editsqlsave2' value='" . $_REQUEST["mod_editsql$dwEditInstance"] . "'>";

			if ($data->addchangebutton === false || ((isset($data->addchangebutton[1]) && $data->addchangebutton[1] === false) || (isset($data->addchangebutton[-2]) && $data->addchangebutton[-2] === false)))
			{
				$btn = sprintf($data->mod_inttxt['edit_submit_change'], $data->name);
			}
			else
			{
				$custombutton = isset($data->addchangebutton[-2]);
				$btn = $data->addchangebutton[-2];
			}
		}
		else
		{
			$tmp = array_merge($data->adddefaults, $data->justadddefaults);
			foreach ($data->relations as $index => $val)
			{
				if (isset($val['autoinc']) && $val['autoinc'])
				{
					$query = "SELECT IFNULL(MAX(`$esTable`.`$index`), 0) + 1 FROM `$esTable` $data->sqljoin WHERE ($data->sqlwhere)";
					if ($val['autoinc'] !== true) $query .= " AND `$esTable`.`$index` < " . intval($val['autoinc']);
					$tmp[$index] = mysql_result(mod_mysql_querya($query, $data->sql), 0);
				}
				else
				{
					$tmp[$index] = isset($val['default']) ? $val['default'] : (isset($val['type']) && $val['type'] == 'int' ? (isset($val['force']) && $val['force'] === true ? 1 : 0) : '');
				}
			}
			$caption = sprintf($data->mod_inttxt['edit_title_add'], $data->name) . "<input type='hidden' name='mod_addsql' value='$dwEditInstance'>";

			if ($data->addchangebutton === false || ((isset($data->addchangebutton[0]) && $data->addchangebutton[0] === false) || (isset($data->addchangebutton[-1]) && $data->addchangebutton[-1] === false)))
			{
				$btn = sprintf($data->mod_inttxt['edit_submit_add'], $data->name);
			}
			else
			{
				$custombutton = isset($data->addchangebutton[-1]);
				$btn = $data->addchangebutton[-1];
			}
		}

		$htmledit = array();
		foreach($data->relations as $index => $relation)
		{
			if (isset($relation['type']) && $relation['type'] == 'html')
			{
				$html = new htmledit;
				$html->width = isset($relation['cols']) ? $relation['cols'] : (isset($relation['width']) ? $relation['width'] : '100%');
				if (isset($relation['rows'])) $html->height = $relation['rows'];
				$html->text = $tmp[$index];
				$html->inputname = htmlspecialchars('mod_sql-' . $dwEditInstance . '-' . $index, ENT_QUOTES);
				$submit = "mod_changehtmledittext($mod_dwHtmlEditInstance);";
				if ($data->onsubmit === false)
					$data->onsubmit = $submit;
				else
					$data->onsubmit .= $submit;
				$tmphtml = '';
				if (isset($relation['htmltoolbar']) && $relation['htmltoolbar'])
				{
					$tmphtml .= CreateHtmlEditToolbar($html);
				}
				$htmledit[$index] = $tmphtml . CreateHtmlEdit($html);
			}
		}

		$data->mod_output .= ($data->showtable ? '<br><br>' : '') . "<a name='mod_sqledit" . (count($data->mod_errors) ? 'a' : '') . "$dwEditInstance'></a>" . mod_linkToForm(mod_link_prefile($data->defaultlink), $data->nojump ? '' : "#mod_sqledita$dwEditInstance", 'POST', "enctype='multipart/form-data'" . ($data->onsubmit === false ? '' : ' onSubmit="' . htmlspecialchars($data->onsubmit) . '"'));

		if ($data->customdesign === false)
		{
			$data->mod_design = "<b>$caption</b><table width='$data->sqleditwidth'>";
		}
		$data->mod_inputs = array();
		$data->mod_inputnames = array();

		$grouping = false;

		$data->ReloadInstance = '';
		$dwMultipleInstance = 0;

		foreach($data->relations as $index => $relations)
		{
			if (!isset($relations['multipleinstance']))
			{
				if ((isset($relations['type']) && ($relations['type'] == 'hidden' || $relations['type'] == 'virtual')) ||
					(($tmpedit = (isset($_REQUEST["mod_editsql$dwEditInstance"]))) && (
						isset($relations['editable']) && $relations['editable'] === false
					))
					|| (isset($relations['requireedit']) && ($tmpedit ^ $relations['requireedit']))
				)
				{
					continue;
				}
				$relation = $relations;
				$relations = array($relations);
			}
			else
			{
				$relation = $relations['multipleinstance'];
			}

			if ($data->customdesign === false)
			{
				if (isset($relation['type']) && $relation['type'] == 'seperator')
				{
					$data->mod_design .= '<tr><td colspan=3' . (isset($relation['inhtml']) ? (' ' . $relation['inhtml']) : '') . '>';
				}
				else
				{
					if ($grouping)
					{
						$data->mod_design .= "\n<td width=10>&nbsp;&nbsp;&nbsp;";
					}
					else
					{
						$data->mod_design .= "\n<tr id='mod_sqledittable_$dwEditInstance-$index'><td valign=top width=10>";
					}
					$data->mod_design .= str_replace(' ', '&nbsp;', (isset($relation['formname']) ? $relation['formname'] : $relation['name'])) . '&nbsp;';
					$data->mod_design .= '<font style="' . ((isset($relation['force']) && $relation['force']) || isset($relation['pw']) ? 'color:red' : 'visibility:hidden') . ';">*</font>';
					$data->mod_design .=  '&nbsp;&nbsp;</td>';
					$data->mod_design .= '<td valign=top colspan=' . (isset($relation['appendform']) || $grouping ? '1' : '2') . '>';
	
					if (isset($relation['group']) && $relation['group'] !== false)
					{
						$grouping = true;
						$data->mod_design .= '<table style="width:100%;" cellpadding=0 cellspacing=0><tr><td';
						if ($relation['group'] !== true) $data->mod_design .= ' width=10>' . str_replace(' ', '&nbsp;', $relation['group']) . '&nbsp;&nbsp;&nbsp;</td><td';
						if (isset($relation['width'])) $data->mod_design .= " width=$relation[width]";
						$data->mod_design .= '>';
					}
				}

				$data->mod_design .= '[INPUT_' . $index . ']';
			}
			$data->mod_inputnames[] = '[INPUT_' . $index . ']';
			$name = ((isset($relation['virtualedit']) && $relation['virtualedit']) ? '' : htmlspecialchars('mod_sql-' . $dwEditInstance . '-' . $index, ENT_QUOTES));

			foreach ($relations as $index2 => $relation)
			{
				if ($index2 === 'multipleinstance') continue;
				if (isset($relations['multipleinstance']))
				{
					$relation = array_merge($relations['multipleinstance'], $relation);
				}

				if (isset($relation['style']))
				{
					$style = $relation['style'];
				}
				else if ($data->commonstyle !== false)
				{
					$style = $data->commonstyle;
				}
				else
				{
					$style = '';
				}

				$inhtml = isset($relation['inhtml']) ? $relation['inhtml'] : (isset($relation['recheckinstance']) ? "onChange='mod_UpdateMultipleInstances$dwEditInstance();' id='$relation[recheckinstance]'" : '');

  				$tmpwidth = isset($relation['width']) ? $relation['width'] : '100%';
				if (count($data->mod_errors) && isset($_POST[$name]) && !isset($relation['pw'])) $tmp[$index] = $_POST[$name];
				if (
					(isset($_REQUEST["mod_editsql$dwEditInstance"]) && isset($relation['editable']) && ($relation['editable'] === 0 || (is_string($relation['editable']) && mysql_result(mod_mysql_querya("SELECT COUNT(*) FROM `$esTable` WHERE id = " . intval($_REQUEST["mod_editsql$dwEditInstance"]) . " AND $relation[editable]", $data->sql), 0) == 0)))
					|| ((($data->forceedit !== false && $data->forceedit < 0) || ($data->viewable && $data->mod_tmpmayedit)) && isset($tmp[$index]))
				)
				{
					$data->mod_inputs[] = $tmp[$index];
				}
				else if (isset($relation['type']) && ($relation['type'] == 'select' || $relation['type'] == 'root'))
				{
					if ($relation['type'] == 'root')
					{
						$menu = new menu;
						$menu->sql = $data->sql;
						$menu->table = $data->sqltablename;
						$menu->html = array('<option value="[ID]">', '', '</option>');
						$menu->nolinks = true;
						$menu->url = false;

						$tmpval = mod_sqledit_getrootvals($data, $relation);
						$ids = $tmpval[0];
						$roots = $tmpval[1];

						if (count($ids))
						{
							$menu->checkrights = 'id IN (' . implode(',', $ids) . ')';
	
							if (isset($_REQUEST["mod_editsql$dwEditInstance"]))
							{
								global $mod_unmergearray;
								$mod_unmergearray = mod_menu_getSubIds($menu, $tmp['id']);
								$menu->callback_func = 'mod_unmerge_filter';
							}

							$relation['options'] = '<option value="-1">' . (isset($relation['rootname']) ? $relation['rootname'] : $data->mod_inttxt['edit_root']) . '</option>' . CreateMenu($menu, -1, 1, $roots, true, true, false, false);

							if (isset($relation['rootdisable']) && count($relation['rootdisable']))
							{
								$disableids = $tmpval[2];

								$relation['options'] = str_replace($disableids, 'disabled', $relation['options']);
							}
							unset($menu);
						}
						else
						{
							$relation['options'] = array();
							if (!isset($relation['rootdisable']) || !isset($relation['rootdisable'][-1])) $relation['options'][-1] = isset($relation['rootname']) ? $relation['rootname'] : $data->mod_inttxt['edit_root'];
						}
					}
					else
					{
						mod_selectquery($relation, $data->sql, isset($_REQUEST["mod_editsql$dwEditInstance"]));
					}

					$input = "<select $inhtml style='$style;' name='$name'>";

					if ($selforce = (!isset($_REQUEST["mod_editsql$dwEditInstance"]) && isset($relation['force']) && ($relation['force'] === true || is_numeric($relation['force']))))
					{
						$input .= '<option value="' . ($relation['force'] === true ? 0 : $relation['force']) . '">[' . $data->mod_inttxt['edit_select_force'] . ']</option>';
					}

					if (is_string($relation['options']))
					{
						$input .= str_ireplace("value=\"$tmp[$index]\">", "value=\"$tmp[$index]\" selected>", $relation['options']);
					}
					else
					{
						foreach($relation['options'] as $optindex => $option)
						{
							$input .= '<option value="' . htmlspecialchars($optindex, ENT_QUOTES) . '"' . (!$selforce && $optindex == $tmp[$index] ? ' selected' : '') . '>' . $option . '</option>';
						}
					}
					$input .= '</select>';
					if (strpos($input, '<option') === false && (!isset($relation['foldempty']) || !$relation['foldempty']))
					{
						$data->mod_errors[] = "No available entries for $relation[name]";
						$data->mod_formok = false;
					}
					$data->mod_inputs[] = $input;
				}
				else if (isset($relation['type']) && $relation['type'] == 'checkbox')
				{
					$data->mod_inputs[] = "<input $inhtml type='checkbox' style='$style;' name='$name'" . ($tmp[$index] ? ' checked' : '') . '>';
				}
				else if (isset($relation['type']) && $relation['type'] == 'html')
				{
					$data->mod_inputs[] = $htmledit[$index];
				}
				else if (isset($relation['type']) && $relation['type'] == 'list')
				{
					$list = new duallist;
					$list->sql = $data->sql;
					$list->inputname = $name;
					$list->style = $style;
					if (!(isset($relation['binarylist']) && $relation['binarylist'])) $list->fullids = true;
					if (isset($relation['singlelist']) && $relation['singlelist']) $list->singlelist = $relation['singlelist'];
					if (isset($relation['rows'])) $list->size = $relation['rows'];
					$query = str_replace(array('[ID]', '[VALUE]'), array(isset($tmp['id']) ? $tmp['id'] : 0, isset($tmp[$index]) ? intval($tmp[$index]) : 0), $relation['listdata']);
					$result = mod_mysql_querya($query, $data->sql);
					while ($tmplist = mysql_fetch_row($result))
					{
						$list->data[$tmplist[2]] .= "<option value='" . htmlspecialchars($tmplist[0]) . "'>" . htmlspecialchars($tmplist[1]) . "</option>";
					}
					if (isset($relation['subdefaults'])) mod_doDefaults($list, $relation['subdefaults']);
					$data->mod_inputs[] = CreateFormDualList($list);
				}
				else if (isset($relation['type']) && $relation['type'] == 'table')
				{
					$usertable = new usertable;
					if (isset($tmp[$index]) && is_array($tmp[$index]))
					{
						$usertable->data = $tmp[$index];
					}
					else if (isset($relation['rows']) || isset($relation['cols']))
					{
						$usertable->data[0] = isset($relation['rows']) ? $relation['rows'] : 1;
						$usertable->data[1] = isset($relation['cols']) ? $relation['cols'] : 1;
					}
					if (isset($relation['tablefixed'])) $usertable->fixed = $relation['tablefixed'];
					if (isset($relation['tabletitles'])) $usertable->titles = $relation['tabletitles'];
					$usertable->input = $name;

					if (isset($relation['subdefaults'])) mod_doDefaults($usertable, $relation['subdefaults']);

					$data->mod_inputs[] = CreateUserTable($usertable);
				}
				else if (isset($relation['rows']) && $relation['rows'] > 1)
				{
					$data->mod_inputs[] =  "<textarea $inhtml style='width:$tmpwidth;$style;' rows='$relation[rows]' name='$name'>" . htmlspecialchars($tmp[$index], ENT_QUOTES) . '</textarea>';
				}
				else if (isset($relation['type']) && $relation['type'] == 'callback')
				{
					$data->mod_inputs[] =  call_user_func($relation['func'], isset($relation['sqllink']) ? -1 : (isset($tmp[$index]) ? $tmp[$index] : -2), (isset($tmp['id']) ? $tmp['id'] : 0), $name);
				}
				else if (isset($relation['type']) && ($relation['type'] == 'fixed' || $relation['type'] == 'seperator'))
				{
					$data->mod_inputs[] =  $relation['default'];
				}
				else if (isset($relation['type']) && $relation['type'] == 'file')
				{
					$input = "<input $inhtml style='$style' type='file' name='$name'>";
					if (isset($relation['storage']) && substr($relation['storage'], -1) != '/') $relation['storage'] .= '/';
					if (isset($_REQUEST["mod_editsql$dwEditInstance"]) && (!isset($relation['filename']) || (isset($relation['force']) && $relation['force'] === false)) && ((!isset($relation['storage']) && $tmp[$index] != '') || (isset($relation['storage']) && file_exists($relation['storage'] . intval($_REQUEST["mod_editsql$dwEditInstance"])))))
					{
						$input .= " <input style='$style;' type='checkbox' name='$name" . "_delete' onClick='document.getElementsByName(\"$name\")[0].disabled = this.checked;'> " . $data->mod_inttxt['edit_delfile'];
					}
					$input .= "&nbsp;&nbsp;<i style='font-size:80%;'>(Max. " . mod_sqledit_filesize($relation) . " Bytes)</i>";
					$data->mod_inputs[] = $input;
				}
				else if (isset($relation['type']) && $relation['type'] == 'multi')
				{
					$multitext = new multitext;
					$multitext->sql = $data->sql;
					if (isset($relation['multitextdefaults']) && !isset($_REQUEST["mod_editsql$dwEditInstance"]))
					{
						$multitext->data = $relation['multitextdefaults'];
					}
					else if (isset($relation['sqllink']) && (!isset($relation['multitextdata']) || !$relation['multitextdata']))
					{
						if (isset($_REQUEST["mod_editsql$dwEditInstance"]))
						{
							$where = array();
							$select = array();
							foreach ($relation['sqllinkdata'] as $link => $value)
							{
								if ($value == '[ID]')
								{
									$where[] = '`' . mysql_escape_string($link) . '` = ' . intval($_REQUEST["mod_editsql$dwEditInstance"]);
								}
								else if (strncmp($value, '[LINK', 5) === 0)
								{
									if (isset($relation['multilink']) && $relation['multilink'])
									{
										$select[substr($value, 5, -1)] = $link;
									}
									else
									{
										$select = $link;
									}
								}
								else
								{
									$where[] = '`' . mysql_escape_string($link) . '` = "' . mysql_escape_string($value) . '"';
								}
							}
							$where = implode(' AND ', $where);
							if (isset($relation['multilink']) && $relation['multilink'])
							{
								ksort($select);
								$select = implode(',', $select);
							}
							else
							{
								$multitext->datasql = 0;
							}
							$multitext->data = "SELECT $select FROM `" . mysql_escape_string($relation['sqllink']) . "` WHERE $where";
							if (isset($relation['sqllinknums']))
							{
								$multitext->data .= ' ORDER BY `' . mysql_escape_string($relation['sqllinknums']) . '` ASC';
							}
						}
					}
					else if (isset($relation['multitextdata']))
					{
						$multitext->data = $relation['multitextdata'];
					}
					if (isset($relation['multitextseperator'])) $multitext->seperator = $relation['multitextseperator'];
					if (isset($relation['multitextcopy'])) $multitext->copybutton = $relation['multitextcopy'];
					$multitext->name = $relation['name'];
					$multitext->input = $name;
					if (isset($relation['multitexthtml']))
					{
						$multitext->inputhtml = $relation['multitexthtml'];
					}
					else
					{
						$multitext->inputhtml = str_ireplace('<input ', "<input style='$style;' ", $multitext->inputhtml);
					}
					if (isset($relation['multitextselects'])) $multitext->selectvals = $relation['multitextselects'];
					if (isset($relation['subdefaults'])) mod_doDefaults($multitext, $relation['subdefaults']);

					$data->mod_inputs[] = CreateMultiText($multitext);
				}
				else
				{
					if (isset($relation['type']) && $relation['type'] == 'ip')
					{
						$tmp[$index] = long2ip($tmp[$index]);
					}
					else if (isset($relation['type']) && ($relation['type'] == 'date' || $relation['type'] == 'datetime') && is_numeric($tmp[$index]))
					{
						$tmp[$index] = date(($relation['type'] == 'datetime' ? 'G:i:s ' : '') . 'j.n.Y', $tmp[$index]);
					}
					$data->mod_inputs[] =  "<input $inhtml style='width:$tmpwidth;$style;' type='" . (isset($relation['pw']) ? 'password' : 'text') . "' name='$name' value=\"" . htmlspecialchars($tmp[$index], ENT_QUOTES) . '">';
					if (isset($relation['pw']) && $relation['pw'] == 2)
					{
						if ($data->customdesign === false)
						{
							$data->mod_inputs[count($data->mod_inputs) - 1] .= "</td></tr><tr><td valign=top>" . (isset($relation['confirm']) ? $relation['confirm'] : $data->mod_inttxt['edit_confirm']) . "&nbsp;<font style='color:red;'>*</font>&nbsp;</td><td colspan=" . (isset($relation['appendform']) ? '1' : '2') . ">";
							$data->mod_inputs[count($data->mod_inputs) - 1] .= "<input style='width:$tmpwidth;$style;' type='password' name='$name" . "_confirm'>";
						}
						else
						{
							$data->mod_inputs[] = "<input style='width:$tmpwidth;$style;' type='password' name='$name" . "_confirm'>";
							$data->mod_inputnames[] = 'INPUT_' . $index . '_confirm';
						}
					}
				}
				if (isset($relation['appendform2']))
				{
					$data->mod_inputs[count($data->mod_inputs) - 1] .= $relation['appendform2'];
				}
			}

			if (isset($relations['multipleinstance']))
			{
				$relation = $relations['multipleinstance'];
				$instances = array_splice($data->mod_inputs, 1 - count($relations), count($data->mod_inputs), array("<div id='mod_sqleditmulti$dwEditInstance" . "_$dwMultipleInstance'></div>"));
				$InstanceState = 0;
				foreach ($relations as $index2 => $relation)
				{
					if ($index2 === 'multipleinstance') continue;

					if ($InstanceState == 0) $InstanceState = 1;
					else $data->ReloadInstance .= 'else ';

					if (!isset($relation['check_java'])) $relation['check_java'] = '';
					if ($relation['check_java'] !== '') $data->ReloadInstance .= "if ($relation[check_java]) ";
					$data->ReloadInstance .= "{mod_UpdateMultipleInstance(document.getElementById('mod_sqleditmulti$dwEditInstance" . "_$dwMultipleInstance'), '" . AddSlashes(array_shift($instances)) . "');";
					if (isset($relation['multiplehideline']))
					{
						$data->ReloadInstance .= "mod_tmp_tr = document.getElementById('mod_sqledittable_$dwEditInstance-$index');if(mod_tmp_tr !== null) mod_tmp_tr.style.display = '" . ($relation['multiplehideline'] ? 'none' : '') . "';";
					}
					$data->ReloadInstance .= "}\n";

					if ($relation['check_java'] === '')
					{
						$InstanceState = 2;
						break;
					}
				}
				if ($InstanceState != 2) $data->ReloadInstance .= " else alert('Internal Error');\n";
				$dwMultipleInstance++;
				$relation = $relations['multipleinstance'];
			}
			if (isset($relation['appendform'])) $data->mod_design .= "</td><td valign=top " . (isset($relation['width']) ? '' : "width=10") . " style='padding-left:5px;'>$relation[appendform]</td>";

			if ($data->customdesign === false)
			{
				$data->mod_design .= '</td>';
				if (isset($relation['group']) && $relation['group'] === false)
				{
					$grouping = false;
					$data->mod_design .= '</tr></table></td>';
				}
				if (!$grouping) $data->mod_design .= '</tr>';
			}
		}


		if ($data->ineditform === true) $data->ineditform = $data->inaddform;
		if (!isset($_REQUEST["mod_editsql$dwEditInstance"]) && $data->inaddform !== false)
		{
			$data->mod_design .= $data->inaddform;
		}
		else if (isset($_REQUEST["mod_editsql$dwEditInstance"]) && $data->ineditform !== false)
		{
			$data->mod_design .= $data->ineditform;
		}

		if ($data->customdesign === false)
		{
			$data->mod_design .= "</table>";
			if (($data->viewable === false || !$data->mod_tmpmayedit) && ($data->forceedit === false || $data->forceedit > 0))
			{
				if (isset($custombutton))
				{
					$data->mod_design .= "<input type='image' src='" . htmlspecialchars($btn) . "' onClick='this.parent.submit();'>";
				}
				else
				{
					$data->mod_design .= "<input type='submit' value='$btn'>";
				}
			}
			$data->mod_design .= "</form>";
		}
	}
}

function mod_sqledit_resolve_mi_blocks($data)
{
	$newrelations = array();
	foreach ($data->relations as $index => $relation)
	{
		if (!isset($relation['multipleinstanceblocks']))
		{
			$newrelations[$index] = $relation;
		}
		else
		{
			foreach($relation as $blockindex => $block)
			{
				if ($blockindex !== 'multipleinstanceblocks')
				{
					foreach ($block as $blockrelindex => $blockrelation)
					{
						if ($blockrelindex !== 'check_java' && $blockrelindex !== 'check_php')
						{
							$newrelations[$blockrelindex] = array(
								'multipleinstance' => array_merge(array('name' => $blockrelation['name']), $relation['multipleinstanceblocks'], $blockrelation),
								array('check_java' => $block['check_java'], 'check_php' => $block['check_php'], 'multiplehideline' => false),
								array('multiplehideline' => true, 'type' => 'fixed', 'default' => '-', 'hide' => true, 'check_java' => 'true', 'check_php' => 'return (true);')
							);
						}
					}
				}
			}
		}
	}
	$data->relations = $newrelations;
}

function CreateSqlEdit(&$data, $returnoutput = 0)
{
	global $dwEditInstance, $userdata, $mod_txt, $mod_dwHtmlEditInstance, $mod_msg;

	$data->mod_errors = array();

	mod_doDefaults($data);

	$data->mod_inttxt = array_merge($mod_txt, $data->mod_txt);

	if ($data->name === false) $data->name = $data->mod_inttxt['edit_entry'];

	if (count($data->relations) == 0 && $data->subedit !== true)
	{
		trigger_error('No Relation given', E_USER_ERROR);
	}
	if ($data->sqltablename === false)
	{
		trigger_error('No Table Name given', E_USER_ERROR);
	}
	$data->defaultlink = mod_RemoveURLParam($data->defaultlink, array("mod_editsql$dwEditInstance", 'mod_delsql', 'mod_delsql2', 'mod_movesql', 'mod_upsql', 'mod_downsql'));
	$data->defaultlink .= mod_addLink(array("mod_sql_start$dwEditInstance", "mod_sql_rows$dwEditInstance"));

	if ($data->sql === false)
	{
		trigger_error('No SQL Connection given', E_USER_ERROR);
	}
	if ($data->title === false)
	{
		$data->title = mod_mysql_get_table($data->sqltablename);
	}
	if ($data->addchange && $data->adddate !== true)
	{
		trigger_error('addchange can only be used when adddate = true', E_USER_ERROR);
	}

	if ($data->savedelete && !isset($data->checktable['deleted'])) $data->checktable['deleted'] = array('int' => 11, 'index' => 0);
	if ($data->adddate && !isset($data->checktable['timestamp'])) $data->checktable['timestamp'] = array('int' => 11, 'index' => 0);
	if ($data->addchange && !isset($data->checktable['changed'])) $data->checktable['changed'] = array('int' => 11, 'default' => 0);
	checkTable($data->checktable, $data->sqltablename, $data->sql);

	if ($data->sqleditwidth === false) $data->sqleditwidth = '90%';

	$esTable = mod_mysql_escape_table($data->sqltablename);

	if (count($data->subtables))
	{
		$data->mod_sqledit_subtables_join_tmp = '';
	}

	if ($data->sqlwhere == '')
	{
		$data->sqlwhere = array();
		foreach ($data->adddefaults as $index => $val)
		{
			$data->sqlwhere[] = "`$esTable`.`" . mysql_escape_string($index) . '` = "' . mysql_escape_string($val) . '"';
		}
		$data->sqlwhere = implode(' AND ', $data->sqlwhere);
		if ($data->sqlwhere == '') $data->sqlwhere = 'TRUE';
	}

	if ($data->sqlforcewhere !== false)
	{
		$data->sqlwhere = "($data->sqlwhere) AND ($data->sqlforcewhere)";
		$data->sqlforcewhere = false;
	}

	if ($data->admin)
	{
		$data->admin = true;
	}
	else
	{
		$data->noaction = true;
		$data->addable = $data->editable = $data->deleteable = false;
		if ($data->sortable === true) $data->sortable = false;
		$data->admin = false;
	}

	if ($data->copyable !== false && !is_array($data->copyable))
	{
		$data->copyable = array(array());
	}

	if ($data->sortable && !is_string($data->sortable) && !is_array($data->sortable)) $data->sortable = true;

	mod_sqledit_resolve_mi_blocks($data);

	mod_sqledit_update($data);

	$data->mod_output = '';

	if (($data->addbutton === true || $data->addbutton === 1 || is_string($data->addbutton)) && !isset($_REQUEST["mod_editsql$dwEditInstance"]) && (!isset($_REQUEST['mod_addsqlcreate']) || $_REQUEST['mod_addsqlcreate'] != $dwEditInstance))
	{
		$data->mod_output .= mod_CreateSqlEdit_addbutton($data, true, true) . '<br><br>';
	}

	if ($data->subedit)
	{
		$data->mod_subedit = array();
	}

	mod_sqledit_create_table($data);

	if ($data->addbutton === -1 && !isset($_REQUEST["mod_editsql$dwEditInstance"]) && (!isset($_REQUEST['mod_addsqlcreate']) || $_REQUEST['mod_addsqlcreate'] != $dwEditInstance))
	{
		$data->mod_output .= mod_CreateSqlEdit_addbutton($data, false, true);
	}

	if (!$data->editable && !$data->viewable && isset($_REQUEST["mod_editsql$dwEditInstance"])) unset($_REQUEST["mod_editsql$dwEditInstance"]);

	if ($data->forceedit !== false)
	{
		$_REQUEST["mod_editsql$dwEditInstance"] = abs($data->forceedit);
	}

	if (isset($_REQUEST["mod_editsql$dwEditInstance"]))
	{
		$chkquery = "SELECT COUNT(*) FROM `$esTable` $data->sqljoin WHERE `$esTable`.id = " . intval($_REQUEST["mod_editsql$dwEditInstance"]) . " AND ($data->sqlwhere)";
		if (!is_bool($data->editable))
		{
			$chkquery .= " AND ($data->editable)";
		}
		if ($data->savedelete === true)
		{
			$chkquery .= " AND (`$esTable`.deleted = 0)";
		}
		if (mysql_result(mod_mysql_querya($chkquery, $data->sql), 0) == 0)
		{
			if ($data->forceedit !== false) return;
			unset ($_REQUEST["mod_editsql$dwEditInstance"]);
		}
	}

	mod_sqledit_create_edit($data);

	if (isset($_REQUEST["mod_sqleditmsg-$dwEditInstance"])) $data->mod_errors = array_merge($data->mod_errors, unserialize($_REQUEST["mod_sqleditmsg-$dwEditInstance"]));
	if (count($data->mod_errors))
	{
		$data->mod_output .= '<br><center><font style="color:red;font-weight:bold;">' . implode('<br>', $data->mod_errors) . '</font></center><br>';
	}

	if (isset($data->mod_formok) && $data->mod_formok)
	{
		$data->mod_output .= str_replace($data->mod_inputnames, $data->mod_inputs, $data->customdesign === false ? $data->mod_design : $data->customdesign);
	}

	if (isset($data->ReloadInstance) && $data->ReloadInstance != '')
	{
		$data->mod_output .= "<script>\nfunction mod_UpdateMultipleInstances$dwEditInstance(){\n$data->ReloadInstance}mod_UpdateMultipleInstances$dwEditInstance();</script>\n";
	}

	$oldEditInstance = $dwEditInstance++;

	if ($data->mod_tmpmayedit)
	{
		foreach ($data->subedits as $field => $edits)
		{
			if (!is_array($edits)) $edits = array($edits);
			foreach ($edits as $edit)
			{
				$edit->adddefaults[$field] = intval($_REQUEST["mod_editsql$oldEditInstance"]);
				$edit->sql = $data->sql;
				if (count($edit->tabledata) == 0) $edit->tabledata = $data->tabledata;
				$edit->title = ($edit->title === false ? mod_mysql_get_table($edit->sqltablename) : $edit->title) .
					' (' . ($data->title === false ? '' : ($data->title . ': ')) . (isset($tmp[$data->namefield]) ? $tmp[$data->namefield] : '') . ')';
				if ($edit->sqlwhere == 'TRUE') $edit->sqlwhere = '';
				$edit->defaultlink = "$data->defaultlink&mod_editsql$oldEditInstance=" . $_REQUEST["mod_editsql$oldEditInstance"];
				$data->mod_output .= '<br><hr><br>';
				$data->mod_output .= CreateSqlEdit($edit, 1);
			}
		}
	}

	if ($data->subedit)
	{
		if ($data->subedit !== true)
		{
			echo $data->mod_output;
		}
		else
		{
			$data->mod_subedit['edit'] = $data->mod_output;
		}
		return($data->mod_subedit);
	}
	else if ($returnoutput)
	{
		return($data->mod_output);
	}
	else
	{
		echo $data->mod_output;
	}
}

?>
